/* A Bison parser, made by GNU Bison 3.0.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         VLparse
#define yylex           VLlex
#define yyerror         VLerror
#define yydebug         VLdebug
#define yynerrs         VLnerrs

#define yylval          VLlval
#define yychar          VLchar
#define yylloc          VLlloc

/* Copy the first part of user declarations.  */
#line 2 "./parse.y" /* yacc.c:339  */

/*
 * Copyright (c) 1998-2010 Stephen Williams (steve@icarus.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

# include "config.h"

# include  "parse_misc.h"
# include  "compiler.h"
# include  "pform.h"
# include  "Statement.h"
# include  "PSpec.h"
# include  <stack>
# include  <cstring>
# include  <sstream>

class PSpecPath;

extern void lex_start_table();
extern void lex_end_table();

static svector<PExpr*>* param_active_range = 0;
static bool param_active_signed = false;
static ivl_variable_type_t param_active_type = IVL_VT_LOGIC;

/* Port declaration lists use this structure for context. */
static struct {
      NetNet::Type port_net_type;
      NetNet::PortType port_type;
      ivl_variable_type_t var_type;
      bool sign_flag;
      svector<PExpr*>* range;
} port_declaration_context = {NetNet::NONE, NetNet::NOT_A_PORT,
                              IVL_VT_NO_TYPE, false, 0};

/* The task and function rules need to briefly hold the pointer to the
   task/function that is currently in progress. */
static PTask* current_task = 0;
static PFunction* current_function = 0;
static stack<PBlock*> current_block_stack;

/* This is used to keep track of the extra arguments after the notifier
 * in the $setuphold and $recrem timing checks. This allows us to print
 * a warning message that the delayed signals will not be created. We
 * need to do this since not driving these signals creates real
 * simulation issues. */
static unsigned args_after_notifier;

/* Later version of bison (including 1.35) will not compile in stack
   extension if the output is compiled with C++ and either the YYSTYPE
   or YYLTYPE are provided by the source code. However, I can get the
   old behavior back by defining these symbols. */
# define YYSTYPE_IS_TRIVIAL 1
# define YYLTYPE_IS_TRIVIAL 1

/* Recent version of bison expect that the user supply a
   YYLLOC_DEFAULT macro that makes up a yylloc value from existing
   values. I need to supply an explicit version to account for the
   text field, that otherwise won't be copied. */
# define YYLLOC_DEFAULT(Current, Rhs, N)  do {       \
  (Current).first_line   = (Rhs)[1].first_line;      \
  (Current).first_column = (Rhs)[1].first_column;    \
  (Current).last_line    = (Rhs)[N].last_line;       \
  (Current).last_column  = (Rhs)[N].last_column;     \
  (Current).text         = (Rhs)[1].text;   } while (0)

/*
 * These are some common strength pairs that are used as defaults when
 * the user is not otherwise specific.
 */
const static struct str_pair_t pull_strength = { PGate::PULL,  PGate::PULL };
const static struct str_pair_t str_strength = { PGate::STRONG, PGate::STRONG };

static list<pair<perm_string,PExpr*> >* make_port_list(char*id, PExpr*expr)
{
      list<pair<perm_string,PExpr*> >*tmp = new list<pair<perm_string,PExpr*> >;
      tmp->push_back(make_pair(lex_strings.make(id), expr));
      delete[]id;
      return tmp;
}
static list<pair<perm_string,PExpr*> >* make_port_list(list<pair<perm_string,
                                                                 PExpr*> >*tmp,
                                                       char*id, PExpr*expr)
{
      tmp->push_back(make_pair(lex_strings.make(id), expr));
      delete[]id;
      return tmp;
}

static list<perm_string>* list_from_identifier(char*id)
{
      list<perm_string>*tmp = new list<perm_string>;
      tmp->push_back(lex_strings.make(id));
      delete[]id;
      return tmp;
}

static list<perm_string>* list_from_identifier(list<perm_string>*tmp, char*id)
{
      tmp->push_back(lex_strings.make(id));
      delete[]id;
      return tmp;
}

static svector<PExpr*>* copy_range(svector<PExpr*>* orig)
{
      svector<PExpr*>*copy = 0;

      if (orig) {
	    copy = new svector<PExpr*>(2);
	    (*copy)[0] = (*orig)[0];
	    (*copy)[1] = (*orig)[1];
      }

      return copy;
}

template <class T> void append(vector<T>&out, const vector<T>&in)
{
      for (size_t idx = 0 ; idx < in.size() ; idx += 1)
	    out.push_back(in[idx]);
}

/*
 * This is a shorthand for making a PECallFunction that takes a single
 * arg. This is used by some of the code that detects built-ins.
 */
static PECallFunction*make_call_function(perm_string tn, PExpr*arg)
{
      svector<PExpr*> parms(1);
      parms[0] = arg;
      PECallFunction*tmp = new PECallFunction(tn, parms);
      return tmp;
}

static PECallFunction*make_call_function(perm_string tn, PExpr*arg1, PExpr*arg2)
{
      svector<PExpr*> parms(2);
      parms[0] = arg1;
      parms[1] = arg2;
      PECallFunction*tmp = new PECallFunction(tn, parms);
      return tmp;
}


#line 236 "parse.cc" /* yacc.c:339  */

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parse.hh".  */
#ifndef YY_VL_PARSE_HH_INCLUDED
# define YY_VL_PARSE_HH_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int VLdebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENTIFIER = 258,
    SYSTEM_IDENTIFIER = 259,
    STRING = 260,
    DISCIPLINE_IDENTIFIER = 261,
    PATHPULSE_IDENTIFIER = 262,
    BASED_NUMBER = 263,
    DEC_NUMBER = 264,
    REALTIME = 265,
    K_LE = 266,
    K_GE = 267,
    K_EG = 268,
    K_EQ = 269,
    K_NE = 270,
    K_CEQ = 271,
    K_CNE = 272,
    K_LS = 273,
    K_RS = 274,
    K_RSS = 275,
    K_SG = 276,
    K_CONTRIBUTE = 277,
    K_PO_POS = 278,
    K_PO_NEG = 279,
    K_POW = 280,
    K_PSTAR = 281,
    K_STARP = 282,
    K_LOR = 283,
    K_LAND = 284,
    K_NAND = 285,
    K_NOR = 286,
    K_NXOR = 287,
    K_TRIGGER = 288,
    K_edge_descriptor = 289,
    K_always = 290,
    K_and = 291,
    K_assign = 292,
    K_begin = 293,
    K_buf = 294,
    K_bufif0 = 295,
    K_bufif1 = 296,
    K_case = 297,
    K_casex = 298,
    K_casez = 299,
    K_cmos = 300,
    K_deassign = 301,
    K_default = 302,
    K_defparam = 303,
    K_disable = 304,
    K_edge = 305,
    K_else = 306,
    K_end = 307,
    K_endcase = 308,
    K_endfunction = 309,
    K_endmodule = 310,
    K_endprimitive = 311,
    K_endspecify = 312,
    K_endtable = 313,
    K_endtask = 314,
    K_event = 315,
    K_for = 316,
    K_force = 317,
    K_forever = 318,
    K_fork = 319,
    K_function = 320,
    K_highz0 = 321,
    K_highz1 = 322,
    K_if = 323,
    K_ifnone = 324,
    K_initial = 325,
    K_inout = 326,
    K_input = 327,
    K_integer = 328,
    K_join = 329,
    K_large = 330,
    K_macromodule = 331,
    K_medium = 332,
    K_module = 333,
    K_nand = 334,
    K_negedge = 335,
    K_nmos = 336,
    K_nor = 337,
    K_not = 338,
    K_notif0 = 339,
    K_notif1 = 340,
    K_or = 341,
    K_output = 342,
    K_parameter = 343,
    K_pmos = 344,
    K_posedge = 345,
    K_primitive = 346,
    K_pull0 = 347,
    K_pull1 = 348,
    K_pulldown = 349,
    K_pullup = 350,
    K_rcmos = 351,
    K_real = 352,
    K_realtime = 353,
    K_reg = 354,
    K_release = 355,
    K_repeat = 356,
    K_rnmos = 357,
    K_rpmos = 358,
    K_rtran = 359,
    K_rtranif0 = 360,
    K_rtranif1 = 361,
    K_scalared = 362,
    K_small = 363,
    K_specify = 364,
    K_specparam = 365,
    K_strong0 = 366,
    K_strong1 = 367,
    K_supply0 = 368,
    K_supply1 = 369,
    K_table = 370,
    K_task = 371,
    K_time = 372,
    K_tran = 373,
    K_tranif0 = 374,
    K_tranif1 = 375,
    K_tri = 376,
    K_tri0 = 377,
    K_tri1 = 378,
    K_triand = 379,
    K_trior = 380,
    K_trireg = 381,
    K_vectored = 382,
    K_wait = 383,
    K_wand = 384,
    K_weak0 = 385,
    K_weak1 = 386,
    K_while = 387,
    K_wire = 388,
    K_wor = 389,
    K_xnor = 390,
    K_xor = 391,
    K_Shold = 392,
    K_Snochange = 393,
    K_Speriod = 394,
    K_Srecovery = 395,
    K_Ssetup = 396,
    K_Ssetuphold = 397,
    K_Sskew = 398,
    K_Swidth = 399,
    KK_attribute = 400,
    K_bool = 401,
    K_logic = 402,
    K_automatic = 403,
    K_endgenerate = 404,
    K_generate = 405,
    K_genvar = 406,
    K_localparam = 407,
    K_noshowcancelled = 408,
    K_pulsestyle_onevent = 409,
    K_pulsestyle_ondetect = 410,
    K_showcancelled = 411,
    K_signed = 412,
    K_unsigned = 413,
    K_Sfullskew = 414,
    K_Srecrem = 415,
    K_Sremoval = 416,
    K_Stimeskew = 417,
    K_cell = 418,
    K_config = 419,
    K_design = 420,
    K_endconfig = 421,
    K_incdir = 422,
    K_include = 423,
    K_instance = 424,
    K_liblist = 425,
    K_library = 426,
    K_use = 427,
    K_wone = 428,
    K_uwire = 429,
    K_always_comb = 430,
    K_always_ff = 431,
    K_always_latch = 432,
    K_assert = 433,
    K_abs = 434,
    K_abstol = 435,
    K_access = 436,
    K_acos = 437,
    K_acosh = 438,
    K_analog = 439,
    K_asin = 440,
    K_asinh = 441,
    K_atan = 442,
    K_atan2 = 443,
    K_atanh = 444,
    K_ceil = 445,
    K_continuous = 446,
    K_cos = 447,
    K_cosh = 448,
    K_ddt_nature = 449,
    K_discipline = 450,
    K_discrete = 451,
    K_domain = 452,
    K_enddiscipline = 453,
    K_endnature = 454,
    K_exclude = 455,
    K_exp = 456,
    K_floor = 457,
    K_flow = 458,
    K_from = 459,
    K_ground = 460,
    K_hypot = 461,
    K_idt_nature = 462,
    K_inf = 463,
    K_ln = 464,
    K_log = 465,
    K_max = 466,
    K_min = 467,
    K_nature = 468,
    K_potential = 469,
    K_pow = 470,
    K_sin = 471,
    K_sinh = 472,
    K_sqrt = 473,
    K_string = 474,
    K_tan = 475,
    K_tanh = 476,
    K_units = 477,
    K_TAND = 478,
    UNARY_PREC = 479,
    less_than_K_else = 480
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 163 "./parse.y" /* yacc.c:355  */

      bool flag;

      char letter;

	/* text items are C strings allocated by the lexor using
	   strdup. They can be put into lists with the texts type. */
      char*text;
      list<perm_string>*perm_strings;

      list<pair<perm_string,PExpr*> >*port_list;

      pform_name_t*pform_name;

      ivl_discipline_t discipline;

      hname_t*hier;

      list<string>*strings;

      struct str_pair_t drive;

      PCase::Item*citem;
      svector<PCase::Item*>*citems;

      lgate*gate;
      svector<lgate>*gates;

      Module::port_t *mport;
      LexicalScope::range_t* value_range;
      vector<Module::port_t*>*mports;

      named_pexpr_t*named_pexpr;
      svector<named_pexpr_t*>*named_pexprs;
      struct parmvalue_t*parmvalue;

      PExpr*expr;
      svector<PExpr*>*exprs;

      svector<PEEvent*>*event_expr;

      NetNet::Type nettype;
      PGBuiltin::Type gatetype;
      NetNet::PortType porttype;
      ivl_variable_type_t datatype;

      PWire*wire;
      svector<PWire*>*wires;

      PEventStatement*event_statement;
      Statement*statement;
      svector<Statement*>*statement_list;

      PTaskFuncArg function_type;

      net_decl_assign_t*net_decl_assign;

      verinum* number;

      verireal* realtime;

      PSpecPath* specpath;
      list<index_component_t> *dimensions;

#line 567 "parse.cc" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE VLlval;
extern YYLTYPE VLlloc;
int VLparse (void);

#endif /* !YY_VL_PARSE_HH_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 596 "parse.cc" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef __attribute__
/* This feature is available in gcc versions 2.5 and later.  */
# if (! defined __GNUC__ || __GNUC__ < 2 \
      || (__GNUC__ == 2 && __GNUC_MINOR__ < 5))
#  define __attribute__(Spec) /* empty */
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  25
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   11444

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  271
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  194
/* YYNRULES -- Number of rules.  */
#define YYNRULES  733
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1780

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   480

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   247,     2,   243,     2,   235,   228,     2,
     238,   242,   233,   231,   239,   232,   244,   234,   252,   253,
       2,     2,     2,     2,     2,     2,     2,     2,   225,   241,
     229,   240,   230,   224,   245,     2,   260,     2,     2,     2,
     257,     2,     2,     2,     2,     2,     2,   263,   265,     2,
     267,   268,   262,     2,     2,     2,     2,     2,     2,     2,
       2,   250,     2,   251,   227,   270,     2,     2,   255,     2,
       2,     2,   256,     2,   259,     2,     2,     2,   258,     2,
     264,     2,   266,   269,   261,     2,     2,     2,     2,     2,
     254,     2,     2,   248,   226,   249,   246,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   236,
     237
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   393,   393,   393,   396,   397,   400,   402,   404,   412,
     413,   420,   421,   422,   426,   432,   441,   448,   466,   479,
     493,   498,   507,   509,   512,   516,   517,   522,   527,   532,
     536,   540,   544,   548,   555,   556,   560,   561,   565,   572,
     577,   582,   589,   595,   603,   604,   605,   609,   610,   614,
     621,   622,   626,   630,   635,   643,   648,   653,   659,   669,
     670,   674,   679,   687,   691,   697,   708,   718,   727,   728,
     729,   730,   731,   732,   744,   744,   748,   747,   754,   755,
     759,   761,   763,   765,   771,   770,   778,   779,   783,   785,
     786,   788,   790,   795,   805,   808,   811,   813,   817,   818,
     820,   822,   823,   826,   828,   831,   833,   837,   839,   843,
     847,   851,   855,   859,   863,   870,   871,   875,   876,   877,
     878,   882,   883,   884,   885,   889,   897,   903,   910,   912,
     918,   927,   934,   941,   955,   957,   962,   964,   966,   971,
     976,   981,   986,   991,   996,  1001,  1006,  1011,  1016,  1021,
    1026,  1031,  1036,  1041,  1046,  1051,  1056,  1061,  1066,  1071,
    1076,  1081,  1086,  1091,  1096,  1101,  1106,  1111,  1116,  1121,
    1126,  1131,  1136,  1141,  1146,  1151,  1156,  1161,  1169,  1171,
    1218,  1223,  1229,  1234,  1242,  1247,  1255,  1261,  1266,  1271,
    1282,  1293,  1299,  1310,  1317,  1324,  1331,  1338,  1345,  1352,
    1359,  1366,  1373,  1380,  1387,  1394,  1401,  1408,  1415,  1422,
    1429,  1436,  1443,  1450,  1461,  1467,  1473,  1481,  1486,  1492,
    1499,  1515,  1517,  1532,  1534,  1541,  1551,  1564,  1575,  1592,
    1603,  1618,  1631,  1646,  1654,  1663,  1664,  1665,  1666,  1667,
    1668,  1669,  1670,  1671,  1672,  1673,  1674,  1678,  1679,  1680,
    1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,  1699,
    1704,  1710,  1719,  1729,  1739,  1755,  1757,  1762,  1764,  1766,
    1768,  1790,  1796,  1804,  1810,  1815,  1834,  1839,  1847,  1864,
    1881,  1898,  1915,  1940,  1941,  1944,  1944,  1951,  1957,  1969,
    1978,  1984,  1994,  1998,  1993,  2020,  2020,  2023,  2024,  2028,
    2029,  2030,  2036,  2038,  2042,  2043,  2044,  2055,  2076,  2095,
    2110,  2116,  2124,  2129,  2149,  2155,  2161,  2172,  2178,  2182,
    2188,  2192,  2196,  2200,  2205,  2209,  2216,  2220,  2225,  2229,
    2237,  2245,  2256,  2261,  2265,  2270,  2282,  2281,  2296,  2295,
    2311,  2310,  2326,  2338,  2337,  2352,  2351,  2366,  2376,  2378,
    2384,  2381,  2391,  2388,  2395,  2400,  2399,  2406,  2413,  2413,
    2426,  2429,  2433,  2442,  2449,  2454,  2460,  2466,  2475,  2482,
    2487,  2488,  2491,  2494,  2495,  2499,  2499,  2501,  2501,  2506,
    2507,  2511,  2512,  2522,  2523,  2524,  2528,  2528,  2539,  2550,
    2556,  2562,  2563,  2564,  2567,  2567,  2570,  2571,  2572,  2573,
    2574,  2575,  2576,  2577,  2578,  2579,  2580,  2585,  2589,  2596,
    2598,  2597,  2608,  2607,  2618,  2617,  2635,  2634,  2652,  2651,
    2664,  2665,  2669,  2677,  2677,  2680,  2682,  2687,  2689,  2691,
    2693,  2695,  2700,  2701,  2702,  2703,  2706,  2706,  2714,  2725,
    2727,  2726,  2737,  2736,  2747,  2746,  2764,  2763,  2781,  2780,
    2793,  2794,  2814,  2820,  2826,  2838,  2844,  2848,  2855,  2865,
    2870,  2893,  2901,  2912,  2921,  2930,  2931,  2947,  2955,  2978,
    3000,  3014,  3016,  3029,  3036,  3044,  3054,  3060,  3068,  3069,
    3070,  3074,  3083,  3084,  3087,  3088,  3091,  3099,  3110,  3111,
    3112,  3113,  3114,  3115,  3116,  3125,  3141,  3151,  3157,  3166,
    3181,  3190,  3196,  3205,  3224,  3230,  3239,  3240,  3243,  3246,
    3254,  3262,  3270,  3275,  3279,  3284,  3288,  3292,  3297,  3301,
    3305,  3310,  3314,  3318,  3323,  3326,  3329,  3332,  3335,  3341,
    3342,  3346,  3348,  3355,  3355,  3358,  3362,  3366,  3370,  3377,
    3378,  3379,  3383,  3385,  3390,  3398,  3401,  3404,  3411,  3417,
    3423,  3429,  3438,  3443,  3481,  3485,  3493,  3494,  3498,  3499,
    3500,  3504,  3506,  3508,  3512,  3516,  3518,  3522,  3526,  3535,
    3536,  3541,  3542,  3546,  3548,  3550,  3552,  3561,  3573,  3579,
    3589,  3594,  3606,  3614,  3613,  3629,  3634,  3640,  3649,  3648,
    3664,  3669,  3676,  3682,  3688,  3693,  3700,  3705,  3710,  3715,
    3720,  3722,  3724,  3726,  3731,  3736,  3740,  3744,  3750,  3755,
    3760,  3764,  3769,  3773,  3780,  3791,  3798,  3805,  3810,  3815,
    3820,  3825,  3832,  3839,  3844,  3850,  3855,  3860,  3868,  3875,
    3882,  3894,  3901,  3908,  3916,  3921,  3929,  3931,  3936,  3943,
    3944,  3948,  3949,  3954,  3962,  3970,  3982,  3997,  4012,  4030,
    4044,  4058,  4075,  4083,  4091,  4102,  4108,  4113,  4116,  4121,
    4135,  4148,  4164,  4185,  4206,  4230,  4250,  4270,  4293,  4306,
    4319,  4335,  4341,  4343,  4357,  4362,  4371,  4371,  4377,  4378,
    4382,  4395,  4401,  4410,  4416,  4425,  4439,  4450,  4451,  4455,
    4461,  4473,  4474,  4475,  4476,  4477,  4478,  4479,  4480,  4481,
    4482,  4483,  4484,  4485,  4486,  4487,  4488,  4489,  4490,  4491,
    4492,  4493,  4494,  4495,  4499,  4500,  4501,  4502,  4509,  4511,
    4519,  4527,  4538,  4540,  4549,  4555,  4563,  4563,  4566,  4567,
    4571,  4577,  4590,  4605
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENTIFIER", "SYSTEM_IDENTIFIER",
  "STRING", "DISCIPLINE_IDENTIFIER", "PATHPULSE_IDENTIFIER",
  "BASED_NUMBER", "DEC_NUMBER", "REALTIME", "K_LE", "K_GE", "K_EG", "K_EQ",
  "K_NE", "K_CEQ", "K_CNE", "K_LS", "K_RS", "K_RSS", "K_SG",
  "K_CONTRIBUTE", "K_PO_POS", "K_PO_NEG", "K_POW", "K_PSTAR", "K_STARP",
  "K_LOR", "K_LAND", "K_NAND", "K_NOR", "K_NXOR", "K_TRIGGER",
  "K_edge_descriptor", "K_always", "K_and", "K_assign", "K_begin", "K_buf",
  "K_bufif0", "K_bufif1", "K_case", "K_casex", "K_casez", "K_cmos",
  "K_deassign", "K_default", "K_defparam", "K_disable", "K_edge", "K_else",
  "K_end", "K_endcase", "K_endfunction", "K_endmodule", "K_endprimitive",
  "K_endspecify", "K_endtable", "K_endtask", "K_event", "K_for", "K_force",
  "K_forever", "K_fork", "K_function", "K_highz0", "K_highz1", "K_if",
  "K_ifnone", "K_initial", "K_inout", "K_input", "K_integer", "K_join",
  "K_large", "K_macromodule", "K_medium", "K_module", "K_nand",
  "K_negedge", "K_nmos", "K_nor", "K_not", "K_notif0", "K_notif1", "K_or",
  "K_output", "K_parameter", "K_pmos", "K_posedge", "K_primitive",
  "K_pull0", "K_pull1", "K_pulldown", "K_pullup", "K_rcmos", "K_real",
  "K_realtime", "K_reg", "K_release", "K_repeat", "K_rnmos", "K_rpmos",
  "K_rtran", "K_rtranif0", "K_rtranif1", "K_scalared", "K_small",
  "K_specify", "K_specparam", "K_strong0", "K_strong1", "K_supply0",
  "K_supply1", "K_table", "K_task", "K_time", "K_tran", "K_tranif0",
  "K_tranif1", "K_tri", "K_tri0", "K_tri1", "K_triand", "K_trior",
  "K_trireg", "K_vectored", "K_wait", "K_wand", "K_weak0", "K_weak1",
  "K_while", "K_wire", "K_wor", "K_xnor", "K_xor", "K_Shold",
  "K_Snochange", "K_Speriod", "K_Srecovery", "K_Ssetup", "K_Ssetuphold",
  "K_Sskew", "K_Swidth", "KK_attribute", "K_bool", "K_logic",
  "K_automatic", "K_endgenerate", "K_generate", "K_genvar", "K_localparam",
  "K_noshowcancelled", "K_pulsestyle_onevent", "K_pulsestyle_ondetect",
  "K_showcancelled", "K_signed", "K_unsigned", "K_Sfullskew", "K_Srecrem",
  "K_Sremoval", "K_Stimeskew", "K_cell", "K_config", "K_design",
  "K_endconfig", "K_incdir", "K_include", "K_instance", "K_liblist",
  "K_library", "K_use", "K_wone", "K_uwire", "K_always_comb",
  "K_always_ff", "K_always_latch", "K_assert", "K_abs", "K_abstol",
  "K_access", "K_acos", "K_acosh", "K_analog", "K_asin", "K_asinh",
  "K_atan", "K_atan2", "K_atanh", "K_ceil", "K_continuous", "K_cos",
  "K_cosh", "K_ddt_nature", "K_discipline", "K_discrete", "K_domain",
  "K_enddiscipline", "K_endnature", "K_exclude", "K_exp", "K_floor",
  "K_flow", "K_from", "K_ground", "K_hypot", "K_idt_nature", "K_inf",
  "K_ln", "K_log", "K_max", "K_min", "K_nature", "K_potential", "K_pow",
  "K_sin", "K_sinh", "K_sqrt", "K_string", "K_tan", "K_tanh", "K_units",
  "K_TAND", "'?'", "':'", "'|'", "'^'", "'&'", "'<'", "'>'", "'+'", "'-'",
  "'*'", "'/'", "'%'", "UNARY_PREC", "less_than_K_else", "'('", "','",
  "'='", "';'", "')'", "'#'", "'.'", "'@'", "'~'", "'!'", "'{'", "'}'",
  "'['", "']'", "'0'", "'1'", "'x'", "'b'", "'f'", "'F'", "'l'", "'h'",
  "'B'", "'r'", "'R'", "'M'", "'n'", "'N'", "'p'", "'P'", "'Q'", "'q'",
  "'_'", "$accept", "main", "source_file", "number", "real_or_realtime",
  "attribute_list_opt", "attribute_list", "attribute", "block_item_decl",
  "block_item_decls", "block_item_decls_opt", "case_item", "case_items",
  "charge_strength", "charge_strength_opt", "defparam_assign",
  "defparam_assign_list", "delay1", "delay3", "delay3_opt",
  "delay_value_list", "delay_value", "delay_value_simple", "description",
  "optional_semicolon", "discipline_declaration", "$@1",
  "discipline_items", "discipline_item", "nature_declaration", "$@2",
  "nature_items", "nature_item", "config_declaration",
  "lib_cell_identifiers", "list_of_config_rule_statements",
  "config_rule_statement", "opt_config", "lib_cell_id",
  "list_of_libraries", "drive_strength", "drive_strength_opt",
  "dr_strength0", "dr_strength1", "event_control", "event_expression_list",
  "event_expression", "branch_probe_expression", "expression",
  "expr_mintypmax", "expression_list_with_nuls", "expression_list_proper",
  "expr_primary", "function_item_list", "function_item", "gate_instance",
  "gate_instance_list", "gatetype", "switchtype", "hierarchy_identifier",
  "list_of_identifiers", "list_of_port_identifiers", "list_of_ports",
  "list_of_port_declarations", "port_declaration", "net_type_opt",
  "signed_opt", "lpvalue", "cont_assign", "cont_assign_list", "module",
  "$@3", "$@4", "module_start", "module_attribute_foreign",
  "module_port_list_opt", "module_parameter_port_list_opt",
  "module_parameter_port_list", "module_item", "$@5", "$@6", "$@7", "$@8",
  "$@9", "$@10", "$@11", "$@12", "$@13", "automatic_opt", "generate_if",
  "generate_case_items", "generate_case_item", "$@14", "$@15",
  "module_item_list", "module_item_list_opt", "generate_block",
  "generate_block_opt", "net_decl_assign", "net_decl_assigns",
  "primitive_type", "primitive_type_opt", "net_type", "var_type",
  "parameter_assign_decl", "$@16", "$@17", "$@18", "$@19", "$@20",
  "parameter_assign_list", "parameter_assign",
  "parameter_value_ranges_opt", "parameter_value_ranges",
  "parameter_value_range", "value_range_expression", "from_exclude",
  "localparam_assign", "localparam_assign_decl", "$@21", "$@22", "$@23",
  "$@24", "$@25", "localparam_assign_list", "parameter_value_opt",
  "parameter_value_byname", "parameter_value_byname_list", "port",
  "port_opt", "port_reference", "port_reference_list", "port_name",
  "port_name_list", "port_type", "range", "range_opt", "dimensions_opt",
  "dimensions", "function_range_or_type_opt", "register_variable",
  "register_variable_list", "real_variable", "real_variable_list",
  "net_variable", "net_variable_list", "specify_item", "specify_item_list",
  "specify_edge_path_decl", "edge_operator", "specify_edge_path",
  "polarity_operator", "specify_simple_path_decl", "specify_simple_path",
  "specify_path_identifiers", "specparam", "specparam_list",
  "spec_polarity", "spec_reference_event", "edge_descriptor_list",
  "spec_notifier_opt", "spec_notifier", "statement", "$@26", "$@27",
  "statement_list", "statement_or_null", "analog_statement", "task_item",
  "reg_opt", "task_port_item", "task_item_list", "task_item_list_opt",
  "task_port_decl", "task_port_decl_list", "udp_body", "$@28",
  "udp_entry_list", "udp_comb_entry", "udp_comb_entry_list",
  "udp_sequ_entry_list", "udp_sequ_entry", "udp_initial", "udp_init_opt",
  "udp_input_list", "udp_input_sym", "udp_output_sym", "udp_port_decl",
  "udp_port_decls", "udp_port_list", "udp_reg_opt", "udp_initial_expr_opt",
  "udp_input_declaration_list", "udp_primitive", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,    63,    58,   124,    94,    38,    60,
      62,    43,    45,    42,    47,    37,   479,   480,    40,    44,
      61,    59,    41,    35,    46,    64,   126,    33,   123,   125,
      91,    93,    48,    49,   120,    98,   102,    70,   108,   104,
      66,   114,    82,    77,   110,    78,   112,    80,    81,   113,
      95
};
# endif

#define YYPACT_NINF -1313

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1313)))

#define YYTABLE_NINF -717

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     449,   172,    60,   -81,   237,   245,   267,   286,   547,   270,
   -1313, -1313, -1313, -1313, -1313, -1313,   187, -1313,     3, -1313,
      69,   497,   279,   296,   296, -1313, -1313, -1313, -1313,   563,
    5360, -1313,   592,    97,   340,   436, -1313, -1313, -1313, -1313,
   -1313,   377, -1313, -1313,   628, -1313,  5904,  5904,  5904,   402,
     407,   423,   467,   472,   478,   489,   500,   505,   527,   541,
     543,   552,   559,   575,   630,   635,   641,   646,   652,   656,
     663,   689,   700,  5904,   754,  5904,  5904,  5904,  5360,  5642,
    3264,  5360, -1313, 10360, -1313,   438, -1313, -1313,   662,   147,
     907, -1313,   364,   329,   742,  5360, -1313, -1313, -1313, -1313,
    5360,  5360,  5360,  5360,  5360,  5360,  5360,  5360,  5360,  5360,
    5360,  5360,  5360,  5360,  5360,  5360,  5360,  5360,  5360,  5360,
    5360,  5360,  5360,  5360, -1313, -1313, -1313, -1313, -1313, -1313,
    9924,   544,  5904,  5904,  5904, -1313, -1313, -1313,  3156,   -43,
    5360,  5360,  5360,  5360,  5360,  5360,  5360,  5360,  5360,  5360,
    5360,  5360,  5360,  5360,  5360,  5360,  5360,  5360,  5360,  5360,
    5360,  5360,  5360,  5360,  5360,  5360,  5360,   974,  5360, -1313,
     990,   994,   770,   766,    31,   540,  1032,  1047,   525, -1313,
     804,   833,   844,   863,   867,   594, -1313,   850,   872, 10360,
     448,  6299,  6343,  6365,  6387,  6409,  6431,  9255,  6453,  6528,
    6682,  6704,  6757,  6779,  9277,  6801,  6823,  9299,  9321,  9387,
    6845,  6867,  6933,  7096,  7118,  5360, -1313, -1313, -1313, -1313,
    5360,  5360, -1313,   235,   235,   435,   435,   435,   435,   209,
     209,   209, -1313,  1952,  3990,   538,  1041,  1041,  9951,  3533,
    1041,   538,   235,   235,    81,    81,  1088,  1088,  1088,   610,
   -1313,  1675,   878, -1313,   306,  1116,   884, -1313, -1313,   891,
     916,   919,   926, -1313, -1313,  5360,  1172,  1191,  1192,  1193,
   -1313, -1313,  1127,   153,  1196, -1313, -1313, -1313, -1313, -1313,
   -1313, -1313,  5360, -1313, -1313, -1313, -1313, -1313, -1313,  5360,
   -1313, -1313,  5360,  5360,  5360, -1313, -1313, -1313, -1313, -1313,
    9973,     0, 10360,  5360, -1313,  5360,  5360,  5360, -1313,  5360,
     995,  1255,  1256,   139, -1313,   576,  1018,  1259,   320, -1313,
   -1313, -1313, -1313,  8395,  1023,  1024,  1042,  1043,  1277,   614,
    1011,  1282,  1283,   416,   639,   650, -1313, -1313, -1313, -1313,
    1284,  1049,  7162,  7184,  7206,  7228,  7250,  5360,    18, 10360,
    4347,  4460,  4809, 10360,  1216, -1313,   272,  1050,  1052,  1286,
    1291, -1313,  1180, -1313, -1313, -1313,  1126,  1295, -1313,  1297,
   -1313, -1313, -1313, -1313, -1313, -1313,  1061, -1313,   157, -1313,
    2683,  1064, -1313,   232,  1357,  1357,  1104,    57, -1313,   161,
   -1313, -1313,  1230, -1313, -1313, -1313, -1313, -1313, -1313, 10360,
    1063, -1313, -1313, -1313, -1313,  1310,   661,  1311, -1313, -1313,
   -1313,  1074,  1076, -1313,  1265, -1313,   482,   182,  5360,  1277,
   -1313,  1077,  4015,    58,  1283, -1313, -1313, -1313, -1313, -1313,
   -1313, -1313, -1313, -1313, -1313, -1313, -1313, -1313,  1168, -1313,
    1168, -1313,  1168,  1168, -1313, -1313, -1313,  1324, 10853, -1313,
   -1313,  1257,  1089, -1313, -1313,   100, 11174, -1313,    43, -1313,
    1295, -1313,  1295,  9900, -1313, -1313,  5360, -1313,  1283,  1090,
   -1313, -1313,  1081,  1081,  1081,  1081,  1093,  1094,  1255,    55,
    1096,    33,  1255,  1098,   212,  1099,  1239,  1239,  1338,  1239,
     265,    66,   138,  1296,  1197,  1103,  1108, 10713,  1255,   268,
   11241, -1313, -1313,  6125, 10573,  1294,  1258,  1347,  1180,  1110,
   -1313, -1313, -1313, -1313, -1313, -1313, -1313, -1313, -1313, -1313,
   -1313, -1313, -1313, -1313, -1313, -1313, -1313, -1313, -1313, -1313,
   -1313, -1313, -1313,  1299, -1313, 11174, 11174, -1313,  9311, -1313,
   -1313, -1313,    51,  1129,    54,  1129,  5591, -1313, -1313,   123,
   -1313,    62,  4923,   275, -1313,  5360, -1313,  1352,  1358,  1359,
    1360,  1355, -1313,   460,   433,   774, -1313,  1124,  5360, -1313,
     678,   403,  1297,   750,  1365,  1316, -1313,   375,  5360,  1168,
    1168,  1133,  1168,  1134, -1313, -1313, -1313, -1313,  1081, -1313,
    1135,  1145, -1313, -1313,   180,  4075, -1313,   776,  4204,   781,
    1328, -1313,  1148,  1150,   471,  1151,  1152,  1156,  1160,  1161,
    1162,  1164,  1165,  1401,  1401,  1401,  1401,  1167,  1173,  1175,
    1176,   432, -1313,  2186,  1169,  1177,  1178,  1181,  1413,   166,
   -1313,  1081,  1020,  9597,  1269,   785,  1179,  1183, -1313, -1313,
    1081, -1313, -1313,  1184,  1185, -1313,  1198,  3871, -1313, -1313,
   -1313, -1313, -1313,  3871,  1033, -1313, -1313, -1313, -1313, -1313,
   -1313, -1313, -1313, -1313,  1039,  1040,    61, -1313, -1313, -1313,
   -1313, -1313,  1044, -1313, -1313, -1313, -1313, -1313,  1423,   101,
     136,   -44,  9753, -1313, -1313, -1313,  1376, -1313, -1313,  1081,
    1168, -1313,  1372, -1313, -1313, -1313, 10162, -1313, 10209, 10256,
   -1313, -1313,  1278,  1202, -1313,  1203, 10360, -1313,  4784,  4784,
   -1313,  1204,  9995, -1313, -1313, -1313,  1205,  1206, -1313,  5360,
   -1313,  1209,  1214, -1313, -1313, -1313, -1313, -1313, -1313, -1313,
   -1313,  1221,  1222,   156, -1313,    65,  7272,  1297, -1313,  5360,
   -1313, -1313,  1224, -1313, -1313, -1313, -1313, -1313,  1081, -1313,
    1459,  7347,  1081,  1081, -1313,  1081, -1313,  1277,  1277, -1313,
    1277, -1313,  1277,  1277,  1537,  1227,  1225, 10360,   668,   171,
   -1313,  1226, -1313, -1313,  5360,  1048,  1232,  1235,  1236, -1313,
     823,  5709,  5709,  5709,  5709,  5709,  5709,  5709,  5709,  1233,
     826,   831,   838,   839,  5709,  5709,  5709,  5709,  1242, -1313,
   -1313,  1401,   514, -1313, -1313, -1313,   160, -1313,   191,   104,
    1247,  1250,  1251,  1124,  1252,  1238,  1463,  1443, -1313, -1313,
   -1313,  5360,  1494,  1494, -1313,  1494, -1313,  1494,  1494,    98,
     146,    17,   673,  1297,    65,  3363,  1262,  1264,  1266,    65,
    1297,  1267,    65,  3871,  1879,  1268,    65,  1271,  1274,  1275,
     227,    95,  5360,  3537,  1477,   491,    90, -1313, -1313,  1273,
     294, -1313,   842,  1276,   366, -1313,   848,  1279,   853,  1280,
   -1313, -1313, -1313, -1313,  1168,  1281,   854,  1285,  1485, -1313,
    3945,   171,   136,   857,  5360,   171,   858,  1168,  1513,  1467,
   -1313,  1124,  1081, -1313,   555, 11174, -1313,  1287,  1288,  1292,
    1300,  1298, -1313, -1313, -1313, -1313,  5752,  5837, 10360,  1301,
    1302, -1313,  5360,  5360,  1497,  8417,   370,   528,   450,   585,
   -1313, -1313, -1313,  5360, -1313,   208,  1308, -1313,   865, -1313,
   -1313, 10360,  5360, -1313,   142, -1313,  1255,  1255,  1529,  1145,
    1145,  1277,  1145, -1313,  1145,  1293,  1533,   674, -1313,   676,
    1607,   171,  5360, -1313, -1313,   171,  7501,   514, -1313,  5360,
    5477,   471, -1313,  1303,  5360,  5360,  1314,  1312,  1313,  1315,
    1317,  1318,  1319,  1320,  1323,  5904,  1547, -1313, -1313, -1313,
   -1313,  1325,  1326,  1327,  1331, -1313,   514, -1313, -1313,   520,
    5360, -1313,  2765, -1313,  1496,  1321, -1313, -1313, -1313, -1313,
    1255,  1330,  1567, -1313,  1424, 10360,  1185,  1185,  1494,  1185,
   -1313,  1185, -1313, -1313,  4898,  1333,   875,  5360,  5360, -1313,
    5360, -1313,   462,  1335,   150, -1313,  1573, -1313,  3611,  5360,
    5360,  5360,  1336,   548,    34,  1339, -1313, -1313,  1575,  3658,
    2849,  1340,  5360,  5360,  2931,  5360, -1313,  1477,  1855,   208,
     365, -1313, -1313, -1313,  3537,  5015, -1313,  4322,  4435, -1313,
    5360,  5360, -1313,  1332,  1577, -1313, -1313,  5360, -1313,  1580,
   -1313, -1313, -1313, -1313,    47, -1313, -1313,  1581,  5360,   885,
     171,   886, -1313,   890, -1313,   200, 10993, -1313, 11133,  1132,
    1255, -1313, -1313, -1313,   555, -1313, -1313, -1313,  4784,  4784,
    5271, 10360, -1313, -1313,  1343,  1344,  1345,  1346,  1348,  1349,
     682, 10017,  5360,    65, -1313,  5129,  8439,  1535, -1313,  1356,
     901,   902,  1353,   912,  1145, -1313,  1361, -1313,  1351, -1313,
    1354,   684,   686,   913, 10360,   917,  1362,   681, 10039,  5360,
   10360, -1313,  1564, 10360,  1378, 10360,  1379,  5360,  5709,  5709,
    5360,  5709,  5709,  5709,  5709,  5360,  1363,  1369,  5709,  5709,
    5709,  5709,   712,   173,   183,   706, -1313,  1364,   710, -1313,
    1366,   488,  1003,   924, -1313,  1370, 10993, -1313,  1185,  1600,
     715, -1313,   734, -1313, -1313,  8461,  8483,   739, -1313,  5360,
   -1313,  1552, -1313, -1313,  7523,  7576,  7598, -1313, -1313,  1371,
    1380,  5360,  1531, -1313,  1381,  7620, -1313,  7642,  7664,  1382,
    7686,  1383,  3537,  1384,  5360,  5360,  1385,   133, -1313, 10360,
   -1313, -1313,  1387,   740,  1391,   185,  5360,  5360,  8505,  1392,
    5360,  5360,  8571, 10360, 10061,  5360, -1313, 10360, -1313,  1577,
     925,   741,  8733, -1313,   941, -1313, -1313,  1618,  1124,  1570,
   -1313,  1390,   942,   947,  1393,   -19,     5, -1313, -1313, -1313,
   -1313, -1313, -1313, -1313,  5360, -1313,  5360, 10360, -1313,  1410,
     -57,  4553, -1313,  5360, -1313,   562,   488, -1313, -1313,  5360,
    1633, -1313,  2351, -1313, -1313, -1313, -1313, -1313, -1313,  1399,
    1400,  1401,  1401,  5360,  9233, -1313,   335,  5360,  5360, 10360,
    1403,  1404,    92,  1405,  1406,  1407,  1408,   756, -1313,  5904,
    1409,  1411,  1414,  1415,  1417,  1418,  1401,   764,  1401,   765,
    5360, -1313, -1313, -1313, -1313,   429,   587,   620, -1313,   657,
     679,   707,   738,   778, -1313, -1313, -1313,  1003,  3537, -1313,
    1644,  1605,  1420, -1313,  1416, -1313, -1313, -1313,  1421,  8755,
   -1313,   722,  2435,  2517,  2601,  3871,  5360,  8799, -1313,   722,
    3537,  3537,  3871,  3537,  3871,  3871, -1313, -1313, -1313, 10360,
   10360,  1477,  4667,  4667, -1313, -1313,  1422,  5360,  1928,  8821,
    8843, -1313,  5360,  8865,  8887, -1313,  5360, 10091,   948, -1313,
    1649, -1313, -1313, -1313,  1419, -1313,   951,  1658, -1313, -1313,
   -1313, -1313, -1313, -1313, -1313, -1313, -1313,   777, 10316, -1313,
   -1313, -1313, -1313,  8909, -1313,  3245, -1313, -1313,   667, 10360,
    1426,  1425, -1313,  7752, -1313, -1313, 10338,  5360,  1634,  5904,
   10360, 10360,  5360,  5360, -1313,  1297,  1427,  1434,  5360,  5360,
    5360,  5360,  5360,  1437,  1428,  5360,  5360,  5360,  5360,  1401,
    1401,   148, -1313,   148, -1313, -1313,   722,  1677, -1313,  1682,
    1685,  1168,  1693,  1694,  1698,  1168,  1699,  1705,  1706,  1168,
     458, -1313,  1469,  1255,  1255,  1255,  1168,  1255,  1255,  1255,
    1168,  1255,  1255,  1255,  1168, -1313,  1652,  1470,  1565,  5246,
   -1313, -1313, -1313, -1313,   722,  3871,   -11,  3493, -1313,  2021,
     132,    -9,  2187,    -4,  2269, -1313,  8983, -1313,  3871,  1662,
    1664, -1313, -1313, -1313, -1313,  3537, -1313, -1313, -1313,  7915,
   -1313, -1313,  7937, -1313, -1313,  5385,  5360, -1313,  1475,  5360,
    1618, -1313,   441,   952, -1313,   965,  5360, -1313,  5360,  6125,
    6125,  1715, -1313,  1667,  1487,  5360, -1313, -1313,  5360,  7981,
   -1313,  1508,    92,  1493,   208,  1492,  1297,    92,    92,  1498,
      92,  6275, -1313, -1313,  1501,  1502,    92,    92,   148,   148,
   -1313, -1313, -1313,  5360,  5360,  3537, -1313, -1313, -1313,  1081,
   -1313, -1313, -1313,  1081, -1313, -1313, -1313,  1081, -1313, -1313,
     722,   968,   969,   972,  1081,   973,   982,   991,  1081,  1001,
    1005,  1006,  1081, -1313,  1503, -1313, -1313,  8003, -1313,  3750,
   -1313,  3537,  3537, -1313,  1510, -1313, -1313,  3537, -1313, -1313,
   -1313, -1313,  3013,  3824,  3537,  3537, -1313,  1500,  1500, -1313,
    6118, -1313, 10360, -1313, -1313, -1313,  1739, -1313,  1509, 10360,
   -1313, -1313,  1516, -1313,   722, 10360, 10360, -1313,  5360,  1517,
    5360, -1313,   208,  1518,  1519,  5360,  1520,  1524,  5360,  5360,
    1525,  1528,  5360,  5360,  8025,  8047,  1691,  1768,  1769,  1770,
    3537, -1313, -1313, -1313,  1255, -1313, -1313, -1313,  1255, -1313,
   -1313, -1313,  1255, -1313, -1313, -1313, -1313, -1313, -1313,  1536,
    9137, -1313, -1313, -1313,  5360,  5360, -1313,  1530, -1313, -1313,
    5360,  3871, 10360,  1541,    92,  1546,  1550,    92,  1557,  1560,
      92,    92,  1561,  1562,  8069,  8091,  1532,  1563, -1313, -1313,
   -1313, -1313,  1719,  1009,  1012,  1015,    65,    42,  9159,  9211,
    8166,  1734, -1313,  1568, -1313, -1313,  1569, -1313, -1313,  1572,
    1578, -1313, -1313,  1579,  1584, -1313, -1313, -1313, -1313, -1313,
   -1313,  1566,  1587,  1590, -1313, -1313, -1313, -1313,  1571,  1574,
    1595,  1596, -1313, -1313,  5360,  3871,  5360, 11133, -1313, -1313,
   -1313, -1313,  8320, -1313,  8342, -1313,  3871,  3871, -1313, -1313
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
      13,     0,     0,     0,     0,     0,     0,     0,    13,     0,
       4,    72,    71,    70,    68,    69,    16,    12,     0,    15,
       0,     0,     0,    75,    75,     1,     5,   296,   295,     0,
       0,    11,     0,     0,     0,     0,    74,    76,    84,   292,
     259,   189,   188,     6,     7,   187,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   186,    17,   136,   190,    14,   724,   727,     0,
       0,    94,     0,     0,   302,     0,     8,   147,   148,   149,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   142,   151,   143,   140,   137,   138,
     178,     0,     0,     0,     0,   139,   150,   141,   185,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   726,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    79,
       0,     0,     0,     0,     0,     0,    87,     0,   301,   185,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   217,   145,   146,   144,
       0,     0,   218,   171,   172,   169,   173,   170,   174,   166,
     167,   168,   153,   175,   176,   161,   162,   163,     0,   160,
     152,   159,   164,   165,   157,   158,   154,   155,   156,     0,
     260,     0,   729,   725,     0,     0,   105,    96,    95,     0,
       0,     0,     0,    77,    78,     0,     0,     0,     0,     0,
      85,    86,     0,    13,   298,   192,   214,   193,   194,   195,
     196,   197,     0,   198,   200,   201,   202,   203,   204,     0,
     206,   207,     0,     0,     0,   209,   210,   211,   212,   213,
       0,     0,   184,     0,   191,     0,     0,     0,   261,     0,
       0,     0,     0,     0,   722,   688,     0,     0,     0,    81,
      80,    83,    82,     0,     0,     0,     0,     0,     0,     0,
     467,     0,     0,     0,     0,     0,   273,   465,   271,   461,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   177,
       0,     0,     0,   728,     0,   265,     0,     0,     0,     0,
       0,   687,     0,   723,    73,   106,     0,     0,    93,     0,
      97,    89,    90,    92,    91,    88,     0,   304,     0,   303,
       0,     0,   471,     0,   284,   284,   284,   466,   299,    13,
     277,   300,     0,   293,   199,   205,   215,   216,   208,   179,
       0,   219,   263,   264,   262,     0,     0,     0,   718,   719,
     720,     0,     0,   676,     0,   107,     0,     0,     0,     0,
     305,     0,     0,     0,     0,   463,   399,   403,   397,   402,
     398,   401,   405,   400,   396,   404,   406,   407,   286,   283,
     286,   408,   286,   286,   272,   275,   274,     0,     0,   220,
     730,     0,     0,   266,   721,     0,     0,   732,     0,   107,
       0,   107,     0,   424,   306,   470,     0,   469,     0,     0,
     472,   285,   483,   483,   483,   483,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   480,   478,     0,   479,
       0,     0,     0,     0,   371,    48,     0,     0,     0,     0,
       0,   318,   380,     0,     0,     0,   286,     0,     0,     0,
     694,   713,   696,   697,   691,   692,   693,   695,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,     0,   681,   678,   679,   683,     0,   689,
     108,    98,     0,   103,     0,   103,   437,   436,   422,   423,
     426,     0,     0,     0,   462,     0,   482,     0,     0,     0,
       0,     0,   364,     0,     0,     0,   115,    60,     0,    50,
       0,     0,     0,     0,     0,     0,   370,   494,     0,   286,
     286,     0,   286,     0,   414,     9,    10,   416,     0,   418,
       0,   409,   420,   410,     0,   182,   234,     0,   182,     0,
       0,   360,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   529,     0,     0,     0,     0,     0,     0,     0,
      47,   483,     0,     0,     0,     0,     0,     0,   444,   446,
       0,   448,   450,     0,   439,   440,   456,     0,   235,   241,
     242,   243,   251,     0,     0,   236,   247,   238,   244,   245,
     246,   237,   249,   252,     0,     0,     0,   248,   250,   254,
     257,   258,     0,   253,   255,   256,   240,   239,     0,     0,
       0,   395,     0,   387,   383,   386,   354,   379,   294,   483,
     286,   731,     0,   686,   677,   682,     0,   684,     0,     0,
     690,   101,     0,     0,    99,     0,   431,   425,     0,     0,
     468,     0,     0,   279,   278,   280,   281,     0,   317,     0,
     366,     0,     0,   119,   123,   118,   122,   117,   121,   120,
     124,     0,     0,     0,    59,     0,     0,     0,   319,     0,
      51,    24,     0,   367,   490,   491,   492,   493,     0,   488,
       0,     0,   483,   483,   363,   483,    32,     0,     0,   412,
       0,    25,     0,     0,     0,   228,     0,   181,     0,     0,
     327,     0,   326,   362,     0,     0,     0,     0,     0,   556,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   548,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   534,
     533,     0,   560,   361,   530,   508,     0,   507,     0,     0,
       0,     0,     0,    60,     0,     0,     0,     0,   348,   349,
      33,     0,     0,     0,   442,     0,    26,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    13,   287,     0,   333,   334,     0,
     484,   497,     0,     0,   484,   501,     0,     0,     0,     0,
     393,   392,   391,   394,   286,     0,     0,     0,     0,   335,
     182,     0,     0,     0,   182,     0,     0,   286,     0,     0,
     352,    60,   483,   733,     0,     0,   717,   691,   692,   693,
       0,     0,   104,   102,   100,   433,     0,     0,   432,     0,
       0,   464,     0,     0,     0,     0,     0,     0,     0,     0,
      67,    65,    66,     0,    55,   287,     0,   291,     0,   355,
      52,    49,     0,   489,     0,   372,     0,     0,     0,   415,
     417,     0,   419,   421,   411,     0,     0,     0,   477,     0,
       0,     0,   183,   227,   233,     0,     0,   560,   511,     0,
       0,     0,   506,     0,     0,     0,   568,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   528,   525,   526,
     527,     0,     0,     0,     0,   547,   560,   558,   559,     0,
       0,   532,     0,   543,     0,   338,   336,    46,    45,    44,
       0,     0,     0,   358,     0,   438,   445,   447,     0,   449,
     451,   441,   455,   454,   182,     0,     0,     0,     0,   633,
     182,   629,     0,     0,     0,   585,     0,   635,     0,     0,
       0,     0,     0,     0,     0,     0,   594,   590,     0,     0,
       0,     0,     0,     0,     0,     0,    53,    13,     0,   125,
       0,   637,   636,   613,     0,     0,   632,     0,     0,    28,
       0,     0,   495,   485,     0,    20,    30,     0,   499,     0,
      22,    31,    23,    27,     0,    29,    21,     0,     0,     0,
       0,     0,   320,     0,   324,   483,     0,   384,     0,     0,
       0,   714,   715,   716,     0,   680,   434,   435,     0,     0,
       0,   282,   297,   365,     0,     0,     0,     0,     0,     0,
       0,    63,     0,     0,   332,     0,     0,     0,   343,     0,
       0,     0,   267,     0,   413,   231,     0,   225,     0,   229,
       0,     0,     0,     0,   180,     0,     0,     0,   552,     0,
     554,   557,     0,   562,   136,   561,   136,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   550,     0,     0,
       0,     0,     0,     0,     0,     0,    61,     0,     0,   342,
       0,     0,   658,     0,   369,     0,     0,   357,   443,     0,
       0,   459,     0,   331,   330,     0,     0,     0,   593,     0,
     587,   583,   582,   634,     0,     0,     0,   579,   592,     0,
       0,     0,   588,   595,     0,     0,   581,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   128,   133,
     288,   614,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   496,     0,     0,   498,   500,   502,     0,
       0,     0,     0,   321,     0,   322,   325,     0,    60,     0,
     353,     0,     0,     0,     0,     0,     0,   481,   114,   113,
     111,   109,   112,   110,     0,    56,     0,   289,   290,     0,
       0,     0,   374,     0,   347,    13,     0,   315,   314,     0,
       0,   313,     0,   476,   232,   226,   230,   329,   328,     0,
       0,     0,     0,     0,   178,   570,     0,     0,     0,   567,
       0,     0,   571,     0,     0,     0,     0,     0,   549,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   531,   544,   542,   340,   642,   642,   642,   672,     0,
     642,   642,   642,     0,   639,   656,   640,   657,     0,   310,
       0,     0,     0,   452,     0,   453,   620,   618,     0,     0,
     586,    37,     0,     0,     0,     0,     0,     0,   591,    37,
       0,     0,     0,     0,     0,     0,    54,   615,   127,   132,
     131,    13,     0,     0,   126,   631,     0,     0,     0,     0,
       0,   619,     0,     0,     0,   617,     0,     0,     0,    19,
       0,   135,   638,   323,     0,   390,     0,     0,   385,   316,
     311,   312,   685,   430,   429,   428,   427,     0,     0,   377,
     375,   356,   373,     0,   224,     0,   221,   223,     0,   268,
     269,     0,   475,     0,   510,   509,     0,     0,     0,     0,
     564,   563,     0,     0,   577,   573,     0,   572,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   545,     0,   546,    62,    37,     0,   641,     0,
       0,   286,     0,     0,     0,   286,     0,     0,     0,   286,
     674,   675,     0,     0,     0,     0,   286,     0,     0,     0,
     286,     0,     0,     0,   286,   655,     0,     0,     0,     0,
     460,   628,   578,    34,    36,     0,     0,     0,    43,     0,
       0,     0,     0,     0,     0,   610,     0,   580,     0,   605,
     603,   596,   627,   612,   611,     0,   129,   130,   630,     0,
     622,   625,     0,   621,   623,     0,     0,    18,     0,     0,
       0,   309,   484,     0,   504,     0,     0,    57,     0,     0,
       0,     0,   222,     0,     0,     0,   474,   473,     0,     0,
     569,   565,   571,     0,   574,     0,   575,   571,   571,     0,
     571,   571,   524,   551,     0,     0,   571,   571,     0,     0,
     539,   540,   541,     0,     0,     0,   664,   667,   670,   483,
     662,   665,   668,   483,   663,   666,   669,   483,   673,   671,
      37,     0,     0,     0,   483,     0,     0,     0,   483,     0,
       0,     0,   483,   337,     0,   359,   458,     0,    35,     0,
     600,     0,     0,    40,     0,   597,    42,     0,   601,   598,
     602,   599,     0,     0,     0,     0,   616,     0,     0,   486,
       0,   134,   388,   389,   503,   308,     0,   307,     0,    64,
     378,   376,     0,   344,    37,   270,   553,   555,     0,     0,
       0,   515,   576,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   648,   651,   654,     0,   646,   649,   652,     0,   647,
     650,   653,     0,   368,   457,   584,    41,    39,    38,     0,
       0,   589,   606,   604,     0,     0,   487,   484,   505,    58,
       0,     0,   566,     0,   571,     0,     0,   571,     0,     0,
     571,   571,     0,     0,     0,     0,     0,     0,   341,   661,
     659,   660,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   513,     0,   516,   519,     0,   521,   523,     0,
       0,   518,   522,     0,     0,   535,   537,   339,   645,   643,
     644,     0,     0,     0,   626,   624,   350,   346,     0,     0,
       0,     0,   536,   538,     0,     0,     0,     0,   514,   520,
     512,   517,     0,   608,     0,   351,     0,     0,   609,   607
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1313, -1313, -1313,  1386,  -498,     7, -1313,  1772, -1113, -1313,
   -1312,  -748,  -528, -1313, -1313,  -506, -1313,  -227,  -468,  -797,
     815,  -856,  -438,  1823,  1816, -1313, -1313, -1313,  1665, -1313,
   -1313, -1313,  1657, -1313, -1313, -1313, -1313,  1305,  -140,   796,
    -665, -1313,  -570,  -565, -1018, -1313,  -441, -1313,   -30, -1313,
    -733,   -69,   523, -1313,   437,  1075,  -475, -1313, -1313,  -216,
    -305, -1313, -1313, -1313,  1458,   459,  -245,  -694,   735, -1313,
   -1313, -1313, -1313, -1313, -1313, -1313, -1313, -1313,  -501, -1313,
   -1313, -1313, -1313, -1313, -1313, -1313, -1313, -1313,  1367, -1313,
   -1313,   586, -1313, -1313, -1313,  -479, -1084,  -589,   332,   469,
   -1313,  1186,   -21,   328, -1313, -1313, -1313, -1313, -1313, -1313,
    -399,  -323, -1313, -1313,  1322,  -682, -1313,  1045, -1313, -1313,
   -1313, -1313, -1313, -1313,  -504, -1313,   524, -1313, -1313,  1482,
      67,  1402,   745,   927, -1313,  -344,  -464,  -252, -1313, -1313,
     810,  -659,   806,  1211,   242, -1313,  1261, -1313,   743, -1313,
   -1313, -1243,  -597, -1313,  -592,   920, -1313,  -735,  -289, -1313,
    -599, -1313,  -615, -1313, -1313,  -836,  -904, -1313,   551,  -484,
   -1223, -1313, -1313,   419,   615,  1388, -1313, -1313,  1389, -1313,
   -1313,  1375, -1313, -1313,   601,  -518,   798,  1582, -1313, -1313,
   -1313, -1313, -1313, -1313
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     7,     8,    82,   589,   500,    18,    19,   501,  1494,
    1495,  1498,  1499,   630,   631,   569,   570,   853,   734,   735,
    1165,  1166,   924,    10,    37,    11,    92,   178,   179,    12,
      93,   185,   186,    13,   174,   318,   370,   703,   258,   458,
     566,   567,   731,   732,   854,  1217,  1218,   878,  1111,   131,
     768,  1500,    84,  1415,  1416,   596,   597,   679,   680,    85,
     356,  1123,   334,   335,   336,   438,   472,   856,   927,   928,
      14,    94,   448,    29,   341,   274,   188,   329,   502,  1172,
    1171,  1456,  1275,  1119,  1767,  1088,  1115,  1176,   577,   503,
    1271,  1272,  1540,  1539,   504,   505,   685,   686,  1395,  1396,
     873,   874,   439,   443,   590,   763,   941,   757,   758,   760,
     591,   592,   548,   549,   550,   909,   551,   642,   643,   828,
    1008,   822,   823,   825,   644,   830,  1181,  1182,   337,   338,
     339,   383,   948,   949,   506,   556,   557,  1634,  1063,   750,
     861,   862,   865,   866,  1534,  1535,   622,   623,   624,   801,
     625,  1573,   626,   627,  1317,   779,   780,   989,   967,  1296,
    1436,  1437,  1052,  1351,  1359,  1028,  1053,   879,  1335,  1461,
    1336,  1337,  1338,  1328,  1329,   414,   456,   533,   534,   535,
     536,   537,   361,   362,   538,   539,   901,   314,   315,    89,
     170,   310,   406,    15
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      83,   641,   684,   687,  1250,   377,   776,     9,  1039,   558,
     559,   560,   139,   876,   882,     9,  1000,   599,   634,   400,
     700,   790,   791,   792,   793,   766,   190,   910,  1017,   802,
      31,   947,   857,   771,   256,  1199,    40,    40,   858,  1227,
    1231,   926,  1610,  1752,  1618,    40,   540,  1508,   130,  1620,
     860,   138,  1417,   870,   540,   420,   564,   540,  -116,  1334,
     330,   330,   869,    20,  -395,   189,   740,  1110,    40,   594,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,  1089,  1434,   464,   249,    40,  1012,
      87,  1057,   871,   872,   594,   994,   149,  1013,    43,    44,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   189,   572,   251,   594,
    1023,   594,   358,  1117,  1575,  1032,   593,  1015,  1035,   594,
    1221,   301,  1041,   417,   817,   645,   330,    21,   870,   920,
     376,  1017,  1414,   920,   445,   921,   922,   813,  1410,   921,
     922,  1570,  1571,   563,   594,    16,   789,   573,   700,     1,
     700,   900,   221,   957,    88,   300,   789,     1,    40,  1211,
     189,   302,  1417,   635,   920,   473,   221,   474,   475,    17,
     921,   922,  1190,   889,   883,   886,   222,   871,   872,   986,
    1574,   881,   885,   575,  1611,  -371,  1611,  1131,  -395,  1372,
    1027,  1611,  1137,  1403,  1334,   891,   359,   416,  1036,  1027,
     920,   930,  1404,   749,   149,   323,   921,   922,  1493,   221,
      22,   810,    32,   811,   759,   419,  1493,  1405,    23,   348,
     765,  1162,   342,   146,   147,   148,  1406,  1018,  1019,   343,
     149,   689,   344,   345,   346,   571,   583,   401,   376,   636,
      24,   637,   257,   349,   812,   350,   351,   352,  1670,   353,
     333,  1180,   852,   555,   541,  -371,    25,  1187,   936,   937,
     852,   938,   701,   565,  1302,   704,   824,   555,  -116,  1307,
     708,   331,  1414,  -116,   595,   332,   468,    33,  1367,  -371,
    -371,  -395,   709,   852,   163,   164,   165,   399,  1006,  1007,
     543,  1009,   545,   546,  1011,  1662,  1663,   547,  1047,  -371,
    1058,  1435,  1701,  1048,   752,   753,  1014,   755,   584,   880,
    1200,   638,   995,  1493,   733,   996,    27,  1105,    28,  1109,
     422,  1104,   461,  1107,   462,  1016,   571,  1617,   939,   940,
     576,   942,   585,   586,   944,   585,   586,   366,   991,  -371,
     993,   221,  1373,  1572,   884,  1374,   598,   900,   311,   733,
    -345,  1608,   587,  1118,   884,   639,   171,   976,   463,   172,
    1018,  1019,  -466,   312,   923,  -466,   333,   331,   990,   382,
    -276,   332,  -276,  -276,   933,   313,  1079,  1081,  1407,   884,
    1083,  1316,  1046,  1193,  1080,  1240,  1255,  1256,   764,   926,
    1247,  1318,   588,  1378,  1193,   640,   167,    30,  1090,   992,
     555,   855,   168,   798,  1486,   789,   552,   855,   565,   943,
     161,   162,   163,   164,   165,   892,   140,   141,   744,    -3,
     555,  1397,   167,   146,   147,   148,  1509,  1510,   168,  1512,
     149,  1588,  -371,   724,  1455,  1045,   161,   162,   163,   164,
     165,   424,   745,   746,   777,     1,  1133,  1493,   778,   681,
    1135,   425,   726,   367,   728,   690,   368,   384,   385,   369,
     469,   470,   747,   968,   969,   970,   971,   972,   973,   974,
      34,   730,  1457,   386,  1178,   981,   982,   983,   984,   180,
     181,   407,   799,   408,   424,   555,   706,  1106,   555,   925,
      35,   571,   800,   182,   711,   712,   585,   586,  1458,  1325,
    1326,  1493,   748,  1163,  1060,   382,   183,    36,   736,  1290,
       2,  1164,  1124,   724,  1061,  1327,  1459,    -2,   751,   140,
     141,   184,   142,   143,   144,   145,   146,   147,   148,  1325,
    1326,   175,   726,   149,   728,   767,    39,   176,   767,    97,
      98,    99,  1319,     1,  1428,  1327,  1552,  1553,   177,    90,
    1388,   730,  1557,  1558,  1559,  1560,  1429,   684,     1,  1564,
    1565,  1566,  1567,  1613,     3,    16,   124,   126,   127,   128,
     129,    91,   135,   137,   221,  1244,  1067,  1249,  1062,  1694,
    1695,  1626,  1068,     4,  1220,    95,  1061,  1022,   925,   855,
     723,  1248,   482,   925,  1033,   555,   925,   855,   855,  1074,
     925,  1120,  1121,  1330,  1331,  1049,    96,   855,     2,   725,
     100,   727,  1085,   739,     5,   101,   360,   167,   311,  1332,
     490,  1108,   459,   168,   460,   217,   218,   219,   729,  1609,
    1462,   102,     6,   312,   159,   160,   161,   162,   163,   164,
     165,  1666,  1623,   719,   720,   313,   166,   723,   908,   908,
    1638,  1529,   167,  1775,   585,   586,  1458,   221,   168,   915,
     275,  1061,     3,  1466,  1291,  1173,   725,  1341,   727,   407,
    1319,   718,  1292,  1188,  1463,   103,   167,  1686,  1687,   931,
     104,     4,   168,  1688,   499,   729,   105,   585,   586,  1458,
    1692,  1693,   175,   263,  1451,  1314,  1453,   106,   176,  1055,
    1239,   259,  1056,  1315,   767,   167,   260,  1467,   107,   177,
    1505,   168,     5,   108,   956,   987,   988,  1511,     1,  1513,
    1514,  1616,  1473,   976,  1616,   125,  1616,    40,    41,    42,
       6,   169,    43,    44,    45,   109,  1722,   159,   160,   161,
     162,   163,   164,   165,   180,   181,   585,   586,  1458,   110,
    1477,   111,   482,  1050,  1252,  1253,   216,   896,   182,  1198,
     112,  1005,   167,   270,  1704,   -13,  1474,   113,   168,  1707,
    1543,   183,  1710,  1711,   585,   586,  1458,  1091,  1092,  1093,
     490,  1481,   855,   114,   579,   580,   184,   582,   925,   -13,
     -13,   -13,   189,   855,  1478,  1502,  1504,  1460,  1464,  1468,
    1226,  1230,  1475,  1479,  1483,   585,   586,  1458,   855,   -13,
     721,   722,  1465,  1469,   440,   442,  1476,  1480,  1484,   221,
     767,   654,   304,   378,   767,  1482,   379,  1568,  1569,  1300,
    1301,  1054,  1303,  1304,  1305,  1306,   723,   724,   115,  1310,
    1311,  1312,  1313,   116,   499,   664,   665,   666,   387,   117,
    1027,   388,  1100,  1101,   118,   725,   726,   727,   728,   389,
     119,   390,   391,  1027,   120,   672,  1470,   925,  1471,  1472,
     451,   121,  1116,   452,   729,   730,  1470,   952,  1471,  1544,
     953,  1020,   173,   952,  1021,  1128,  1127,   737,  1129,   738,
     767,  1264,  1134,   952,  1265,  1128,  1285,   122,  1286,  1138,
    1140,  1516,  1517,    49,  1143,  1145,    50,    51,   123,    52,
      53,    54,    55,    56,    57,  1320,    58,    59,  1321,  1320,
    1640,  1641,  1323,  1649,   952,    60,    61,  1343,  1653,  1654,
      62,  1656,  1657,    63,    64,    65,    66,  1660,  1661,    67,
      68,    69,    70,  1344,    71,    72,  1345,   250,   952,   221,
    1390,  1348,  1376,  1391,   767,   187,  1223,  1185,  1186,   407,
     767,   741,    78,   252,  1193,  1442,   855,   253,  1443,  1194,
    1195,  1196,    81,   976,   976,   255,  1452,  1454,  1193,  1049,
    1205,   254,  1207,  1208,  1210,   769,  1536,   770,  1219,  1537,
     769,   814,   772,   815,   407,   189,   819,  1228,  1232,     1,
    1233,  1234,  1751,  1753,   859,   261,   860,  1237,   684,   684,
     863,   867,   864,   864,   265,   875,  1270,   860,  1242,   798,
     262,   789,   140,   141,  1212,   142,   143,   144,   145,   146,
     147,   148,   961,   482,   962,   976,   149,   977,   908,   908,
     976,   152,   978,   266,  1330,  1331,   -13,   976,   976,   979,
     980,  1064,  1267,  1065,   267,   189,  1731,  1069,   272,  1070,
    1332,   490,  1069,  1064,  1072,  1076,   769,   769,  1082,  1084,
     -13,   -13,   -13,   268,  1113,  1733,  1114,   269,  1736,  1294,
     273,  1739,  1740,   149,   769,  1667,  1184,  1299,   309,  1668,
     -13,   316,   855,  1669,   769,   769,  1243,  1245,   317,   769,
    1674,  1246,   319,  1251,  1678,   355,   696,   698,  1682,   855,
     407,   407,  1277,  1278,   855,   855,   855,   855,   855,   855,
    1773,  1280,   769,  1281,  1287,   499,   769,   320,  1288,  1349,
     321,  1778,  1779,   407,  1064,  1339,  1389,   322,  1591,  1592,
    1593,  1357,  1595,  1596,  1597,   324,  1599,  1600,  1601,  1333,
     769,   407,  1393,  1400,  1369,  1370,   407,  1064,  1401,  1527,
    1530,  1530,  1531,  1635,   325,   326,  1379,  1380,   327,   855,
    1383,  1384,  1270,   441,  1636,  1387,  1637,   407,   407,  1671,
    1672,   407,   407,  1673,  1675,   328,  1579,   426,   427,  1554,
    1583,   407,   340,  1676,  1587,   428,   429,   430,   431,   432,
     407,  1594,  1677,   433,   354,  1598,  1408,   434,   435,  1602,
     407,   189,  1679,  1413,   407,   407,  1680,  1681,   407,  1419,
    1748,   407,  1423,  1749,   407,   542,  1750,   544,   355,   357,
     364,   380,   365,  1426,   372,   373,   684,  1430,  1431,   158,
     159,   160,   161,   162,   163,   164,   165,   436,   437,   855,
     376,   855,  1333,   374,   375,   381,   330,   392,   405,   411,
     393,   409,   855,   410,   412,   413,   415,   600,   256,   855,
      40,   418,   423,   447,   966,   966,   966,   966,   966,   966,
     966,   966,   449,   450,   453,   454,   455,   966,   966,   966,
     966,   457,   189,   189,   189,   471,  1506,   476,   465,   507,
     508,   555,   554,   561,   568,   562,   574,   578,   441,   581,
    1652,   629,  1219,  1219,  1333,   576,   632,  1519,  1219,   688,
     691,   693,  1522,   601,   702,   713,  1525,   694,  1333,   855,
     717,   714,   715,   716,   602,   603,  1333,   733,   742,  1723,
     743,   426,   427,  1724,   754,   756,   761,  1725,  1515,   428,
     429,   430,   431,   432,   762,   773,   774,   433,   775,   781,
     782,   434,   435,   855,   783,   855,   855,  1549,   784,   785,
     786,   855,   787,   788,   789,   794,   604,   855,   855,   855,
     805,   795,  1561,   796,   797,   471,   809,   806,   818,   807,
     820,   808,  1333,   821,   827,   826,   877,   890,   893,   128,
     129,   436,   437,   605,   606,   607,   608,   609,   610,   611,
     612,   829,   902,   903,   904,   913,   911,   914,   916,   613,
     614,   615,   616,   917,   855,   617,   618,   619,   620,  1607,
     918,   919,   934,  1333,   932,   950,  1003,   951,   955,   189,
     426,   427,   189,   958,   189,   959,   960,  1002,   428,   429,
     430,   431,   432,   975,   985,   855,   433,  1144,  1146,   997,
     434,   435,   998,   999,  1001,  1004,  1630,   637,  1156,  1632,
    1029,  1333,  1030,     1,  1031,  1034,  1040,  1078,  1639,  1042,
     925,   925,  1043,  1044,  1059,  1645,  1086,  1066,  1646,  1087,
    1071,  1073,  1075,  1077,  1102,  1094,  1098,  1099,  -714,  -715,
     436,   437,  1122,  -716,   621,  1125,  1126,  1147,   945,  1095,
      40,    41,    42,  1664,  1665,    43,    44,    45,  1112,   855,
    1157,  1148,  1149,  1142,  1150,  1169,  1151,  1152,  1153,  1154,
     855,   855,  1155,  1170,  1158,  1159,  1160,    46,    47,    48,
    1161,  1174,  1175,  1177,  1183,  1189,  1191,  1197,  1202,  1201,
     860,  1206,  1235,   864,  1241,  1258,  1259,  1260,  1261,  1274,
    1262,  1263,  1690,  1279,  1276,   946,  1284,  1333,  1295,  1282,
     621,  1297,  1298,  1342,  1350,  1358,  1322,  1324,  1130,  1340,
      40,    41,    42,  1355,  1308,    43,    44,    45,  1702,  1309,
    1356,  1394,  1398,  1360,  1364,  1366,  1368,  1371,  1375,  1377,
    1382,  1399,  1714,  1715,  1402,  1409,  1420,    46,    47,    48,
    1424,  1425,  1432,  1433,  1438,  1439,  1440,  1441,  1445,  1487,
    1446,  1333,  1528,  1447,  1448,  1449,  1450,  1488,  1489,  1529,
    1179,  1532,  1491,  1518,  1728,  1729,  1545,  1546,  1550,  1555,
    1730,   966,   966,  1556,   966,   966,   966,   966,  1562,  1563,
    1576,   966,   966,   966,   966,  1577,   140,   141,  1578,   142,
     143,   144,   145,   146,   147,   148,  1580,  1581,   305,   306,
     149,  1582,  1584,   150,   151,   152,   153,   154,  1585,  1586,
    1590,  1603,  1604,  1624,  1605,  1625,    49,  1631,  1642,    50,
      51,  1643,    52,    53,    54,    55,    56,    57,  1644,    58,
      59,  1648,  1650,  1651,  1772,  1611,  1774,  1655,    60,    61,
    1658,  1659,  1697,    62,  1683,  1225,    63,    64,    65,    66,
    1718,  1699,    67,    68,    69,    70,  1700,    71,    72,  1703,
    1705,  1706,  1708,    73,    74,    75,  1709,  1712,    76,    77,
    1713,  1719,  1720,  1721,  1745,    78,  -182,  1726,  1747,  -182,
    1061,   946,  1732,    79,    80,    81,    49,  1734,  1757,    50,
      51,  1735,    52,    53,    54,    55,    56,    57,  1737,    58,
      59,  1738,  1741,  1742,    86,  1746,  1764,  1168,    60,    61,
    1758,  1759,  1768,    62,  1760,  1769,    63,    64,    65,    66,
    1761,  1762,    67,    68,    69,    70,  1763,    71,    72,  1765,
    1766,    26,  1444,    73,    74,    75,  1770,  1771,    76,    77,
      38,   509,   271,   264,   954,    78,  -182,   446,  1268,  -182,
     705,   946,  1542,    79,    80,    81,  1213,  1412,    40,    41,
      42,   628,  1633,    43,    44,    45,  1533,   887,  1490,   444,
     553,   707,  1010,  1283,  1236,  1238,   868,  1132,  1698,  1289,
     831,  1141,    40,   832,   804,    46,    47,    48,  1485,  1589,
       0,  1418,  1254,     0,     0,     0,   692,   363,     0,   155,
     307,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   697,   833,     0,     0,     0,   834,   835,     0,     0,
       0,   836,   837,   838,   695,   839,   308,     0,   840,  1213,
       0,    40,    41,    42,     0,  1214,    43,    44,    45,     0,
     841,   842,   843,   844,     0,  1215,     0,   845,     0,     0,
       0,     0,  1551,  1037,     0,     0,     0,     0,    46,    47,
      48,     0,     0,   140,   141,     0,   142,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,   149,     0,   846,
     847,   151,   152,   153,   154,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   848,  1214,     0,
       0,   849,     0,     0,     0,     0,     0,     0,  1215,     0,
       0,     0,  1614,     0,    40,    41,    42,     0,     0,    43,
      44,    45,     0,     0,    49,     0,     0,    50,    51,     0,
      52,    53,    54,    55,    56,    57,     0,    58,    59,     0,
       0,    46,    47,    48,     0,     0,    60,    61,     0,     0,
       0,    62,     0,     0,    63,    64,    65,    66,  1497,     0,
      67,    68,    69,    70,  1615,    71,    72,     0,     0,     0,
       0,    73,    74,    75,     0,     0,    76,    77,  1216,     0,
       0,     0,     0,    78,     0,     0,     0,     0,     0,     0,
       0,    79,    80,    81,  1038,     0,     0,    49,     0,     0,
      50,    51,     0,    52,    53,    54,    55,    56,    57,     0,
      58,    59,   850,     0,   851,     0,     0,   852,     0,    60,
      61,     0,     0,     0,    62,     0,     0,    63,    64,    65,
      66,     0,     0,    67,    68,    69,    70,     0,    71,    72,
       0,     0,     0,     0,    73,    74,    75,     0,     0,    76,
      77,     0,     0,     0,     0,     0,    78,     0,     0,     0,
       0,     0,     0,     0,    79,    80,    81,     0,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,  1614,     0,
      40,    41,    42,     0,     0,    43,    44,    45,     0,     0,
      49,     0,     0,    50,    51,     0,    52,    53,    54,    55,
      56,    57,     0,    58,    59,     0,     0,    46,    47,    48,
       0,     0,    60,    61,     0,     0,     0,    62,     0,     0,
      63,    64,    65,    66,  1497,     0,    67,    68,    69,    70,
    1619,    71,    72,   803,     0,     0,     0,    73,    74,    75,
       0,     0,    76,    77,   602,   603,     0,     0,     0,    78,
       0,     0,     0,     0,     0,     0,     0,    79,    80,    81,
    1614,     0,    40,    41,    42,     0,     0,    43,    44,    45,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   604,     0,     0,    46,
      47,    48,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1497,     0,     0,     0,
       0,     0,  1621,   605,   606,   607,   608,   609,   610,   611,
     612,     0,     0,     0,     0,     0,     0,     0,     0,   613,
     614,   615,   616,     0,     0,   617,   618,   619,   620,     0,
       0,     0,  1421,     0,    40,    41,    42,     0,     0,    43,
      44,    45,     0,     0,     0,     0,    49,     0,     0,    50,
      51,     0,    52,    53,    54,    55,    56,    57,     0,    58,
      59,    46,    47,    48,     0,     0,     0,     0,    60,    61,
       0,     0,     0,    62,     0,     0,    63,    64,    65,    66,
       0,     0,    67,    68,    69,    70,     0,    71,    72,     0,
       0,     0,     0,    73,    74,    75,     0,     0,    76,    77,
       0,     0,     0,     0,   621,    78,     0,     0,     0,     0,
       0,     0,     0,    79,    80,    81,  1496,     0,    40,    41,
      42,     0,     0,    43,    44,    45,     0,     0,    49,     0,
       0,    50,    51,     0,    52,    53,    54,    55,    56,    57,
       0,    58,    59,     0,     0,    46,    47,    48,     0,     0,
      60,    61,     0,     0,     0,    62,     0,     0,    63,    64,
      65,    66,  1497,     0,    67,    68,    69,    70,     0,    71,
      72,     0,     0,     0,     0,    73,    74,    75,     0,     0,
      76,    77,     0,     0,     0,     0,     0,    78,     0,     0,
       0,     0,     0,     0,     0,    79,    80,    81,  1501,     0,
      40,    41,    42,     0,     0,    43,    44,    45,     0,     0,
      49,     0,     0,    50,    51,     0,    52,    53,    54,    55,
      56,    57,     0,    58,    59,     0,     0,    46,    47,    48,
       0,     0,    60,    61,     0,     0,     0,    62,     0,     0,
      63,    64,    65,    66,  1497,     0,    67,    68,    69,    70,
       0,    71,    72,     0,     0,     0,     0,    73,    74,    75,
       0,     0,    76,    77,     0,     0,     0,     0,     0,    78,
       0,     0,     0,  1422,     0,     0,     0,    79,    80,    81,
       0,     0,  1503,     0,    40,    41,    42,     0,     0,    43,
      44,    45,     0,     0,    49,     0,     0,    50,    51,     0,
      52,    53,    54,    55,    56,    57,     0,    58,    59,     0,
       0,    46,    47,    48,     0,     0,    60,    61,     0,     0,
       0,    62,     0,     0,    63,    64,    65,    66,  1497,     0,
      67,    68,    69,    70,     0,    71,    72,     0,     0,     0,
       0,    73,    74,    75,     0,     0,    76,    77,     0,     0,
       0,     0,     0,    78,     0,     0,     0,     0,     0,     0,
       0,    79,    80,    81,   421,     0,    40,    41,    42,     0,
       0,    43,    44,    45,     0,     0,    49,     0,     0,    50,
      51,     0,    52,    53,    54,    55,    56,    57,     0,    58,
      59,     0,     0,    46,    47,    48,     0,     0,    60,    61,
       0,     0,     0,    62,     0,     0,    63,    64,    65,    66,
       0,     0,    67,    68,    69,    70,     0,    71,    72,     0,
       0,     0,     0,    73,    74,    75,     0,     0,    76,    77,
       0,     0,     0,     0,     0,    78,     0,     0,     0,     0,
       0,     0,     0,    79,    80,    81,  1167,     0,    40,    41,
      42,     0,     0,    43,    44,    45,     0,     0,     0,     0,
      49,     0,     0,    50,    51,     0,    52,    53,    54,    55,
      56,    57,     0,    58,    59,    46,    47,    48,     0,     0,
       0,     0,    60,    61,     0,     0,     0,    62,     0,     0,
      63,    64,    65,    66,     0,     0,    67,    68,    69,    70,
       0,    71,    72,     0,     0,     0,     0,    73,    74,    75,
       0,     0,    76,    77,     0,     0,     0,     0,     0,    78,
       0,     0,     0,     0,     0,     0,     0,    79,    80,    81,
    1204,     0,    40,    41,    42,     0,     0,    43,    44,    45,
       0,     0,    49,     0,     0,    50,    51,     0,    52,    53,
      54,    55,    56,    57,     0,    58,    59,     0,     0,    46,
      47,    48,     0,     0,    60,    61,     0,     0,     0,    62,
       0,     0,    63,    64,    65,    66,     0,     0,    67,    68,
      69,    70,     0,    71,    72,     0,     0,     0,     0,    73,
      74,    75,     0,     0,    76,    77,     0,     0,     0,     0,
       0,    78,     0,     0,     0,     0,     0,     0,     0,    79,
      80,    81,  1209,     0,    40,    41,    42,     0,     0,    43,
      44,    45,     0,     0,    49,     0,     0,    50,    51,     0,
      52,    53,    54,    55,    56,    57,     0,    58,    59,     0,
       0,    46,    47,    48,     0,     0,    60,    61,     0,     0,
       0,    62,     0,     0,    63,    64,    65,    66,     0,     0,
      67,    68,    69,    70,     0,    71,    72,     0,     0,     0,
       0,    73,    74,    75,     0,     0,    76,    77,     0,     0,
       0,     0,     0,    78,     0,     0,     0,     0,     0,     0,
       0,    79,    80,    81,  1689,     0,    40,    41,    42,     0,
       0,    43,    44,    45,     0,     0,     0,     0,    49,     0,
       0,    50,    51,     0,    52,    53,    54,    55,    56,    57,
       0,    58,    59,    46,    47,    48,     0,     0,     0,     0,
      60,    61,     0,     0,     0,    62,     0,     0,    63,    64,
      65,    66,     0,     0,    67,    68,    69,    70,     0,    71,
      72,     0,     0,     0,     0,    73,    74,    75,     0,     0,
      76,    77,     0,     0,     0,     0,     0,    78,     0,     0,
       0,     0,     0,     0,     0,    79,    80,    81,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      49,     0,     0,    50,    51,     0,    52,    53,    54,    55,
      56,    57,     0,    58,    59,     0,     0,     0,     0,     0,
       0,     0,    60,    61,     0,     0,     0,    62,     0,     0,
      63,    64,    65,    66,     0,     0,    67,    68,    69,    70,
       0,    71,    72,     0,     0,     0,     0,    73,    74,    75,
       0,     0,    76,    77,     0,     0,     0,   140,   141,    78,
     142,   143,   144,   145,   146,   147,   148,    79,    80,    81,
       0,   149,     0,     0,   150,   151,   152,   153,   154,     0,
       0,     0,    49,     0,     0,    50,    51,     0,    52,    53,
      54,    55,    56,    57,     0,    58,    59,     0,     0,     0,
       0,     0,     0,     0,    60,    61,     0,     0,     0,    62,
       0,     0,    63,    64,    65,    66,     0,     0,    67,    68,
      69,    70,     0,    71,    72,     0,     0,     0,     0,    73,
      74,    75,     0,     0,    76,    77,   831,     0,    40,   832,
       0,    78,     0,     0,     0,     0,     0,     0,     0,    79,
      80,    81,     0,     0,     0,   136,     0,    40,    41,    42,
       0,     1,    43,    44,    45,     0,     0,     0,   833,     0,
       0,     0,   834,   835,     0,     0,     0,   836,   837,   838,
       0,   839,     0,     0,   840,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   482,   841,   842,   843,   844,
       0,     0,     0,   845,     0,     0,  1330,  1331,   -13,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1332,   490,     0,     0,     0,     0,     0,     0,
       0,     0,   -13,   -13,   -13,   846,   847,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   -13,     0,  1024,     0,    40,   832,     0,     0,
       0,     0,     0,   848,     0,     0,     0,   849,     0,     0,
     155,     0,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,     0,     0,     0,     0,   833,   499,     0,     0,
     834,   835,     0,     0,   220,   836,   837,   838,     0,   839,
       0,     0,   840,     0,     0,  1025,     0,     0,     0,     0,
       0,     0,     0,     0,   841,   842,   843,   844,     0,     0,
       0,   845,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    49,     0,     0,    50,    51,     0,    52,
      53,    54,    55,    56,    57,     0,    58,    59,     0,     0,
       0,     0,     0,   846,   847,    60,    61,     0,     0,     0,
      62,     0,     0,    63,    64,    65,    66,     0,     0,    67,
      68,    69,    70,     0,    71,    72,     0,     0,   850,     0,
     851,   848,     0,   852,   831,   849,    40,   832,     0,     0,
       0,     0,    78,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    81,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   833,     0,     0,     0,
     834,   835,     0,     0,     0,   836,   837,   838,   831,   839,
      40,   832,   840,     0,   140,   141,     0,   142,   143,   144,
     145,   146,   147,   148,   841,   842,   843,   844,   149,     0,
       0,   845,     0,   152,   153,   154,     0,     0,     0,     0,
     833,     0,     0,     0,   834,   835,     0,     0,     0,   836,
     837,   838,     0,   839,     0,     0,   840,     0,  1026,     0,
       0,     0,     0,   846,   847,     0,     0,     0,   841,   842,
     843,   844,     0,     0,     0,   845,   850,     0,   851,     0,
       0,   852,   831,     0,    40,   832,     0,     0,     0,     0,
       0,   848,     0,     0,     0,   849,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   846,   847,     0,
       0,     0,     0,     0,   833,     0,     0,     0,   834,   835,
       0,     0,     0,   836,   837,   838,     0,   839,     0,   831,
     840,    40,   832,  1192,     0,   848,     0,     0,     0,   849,
       0,     0,   841,   842,   843,   844,     0,     0,     0,   845,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   833,     0,     0,     0,   834,   835,     0,     0,     0,
     836,   837,   838,     0,   839,     0,     0,   840,     0,     0,
       0,   846,   847,     0,     0,     0,     0,     0,  1612,   841,
     842,   843,   844,     0,     0,     0,   845,     0,     0,     0,
       0,     0,  1203,     0,  1051,     0,   850,     0,   851,   848,
       0,   852,     0,   849,     0,     0,     0,     0,     0,     0,
       0,   831,     0,    40,   832,     0,     0,     0,   846,   847,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1051,     0,
     850,     0,   851,   833,     0,   852,   848,   834,   835,     0,
     849,     0,   836,   837,   838,     0,   839,     0,     0,   840,
       0,     0,  1685,     0,     0,     0,     0,     0,     0,     0,
       0,   841,   842,   843,   844,     0,     0,     0,   845,     0,
       0,     0,     0,     0,     0,   831,     0,    40,   832,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     846,   847,     0,     0,   850,     0,   851,   833,     0,   852,
       0,   834,   835,     0,     0,     0,   836,   837,   838,     0,
     839,     0,   831,   840,    40,   832,     0,     0,   848,     0,
       0,     0,   849,     0,     0,   841,   842,   843,   844,     0,
       0,     0,   845,     0,     0,     0,     0,     0,  1691,     0,
       0,   850,     0,   851,   833,     0,   852,     0,   834,   835,
       0,     0,     0,   836,   837,   838,     0,   839,     0,     0,
     840,     0,     0,     0,   846,   847,     0,     0,     0,     0,
       0,     0,   841,   842,   843,   844,     0,     0,     0,   845,
       0,     0,     0,     0,     0,     0,     0,     0,    40,    41,
      42,     0,   848,    43,    44,    45,   849,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   846,   847,     0,     0,    46,    47,    48,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   850,     0,   851,     0,     0,   852,   848,
       0,   140,   141,   849,   142,   143,   144,   145,   146,   147,
     148,   721,   722,     0,     0,   149,     0,     0,     0,     0,
     152,   153,   154,     0,     0,     0,   140,   141,     0,   142,
     143,   144,   145,   146,   147,   148,     0,   723,   724,     0,
     149,     0,     0,   150,   151,   152,   153,   154,     0,     0,
       0,     0,     0,     0,     0,     0,   725,   726,   727,   728,
       0,     0,     0,     0,     0,     0,     0,   850,     0,   851,
       0,     0,   852,     0,     0,   729,   730,     0,    40,    41,
      42,     0,     0,    43,    44,    45,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,    47,    48,     0,     0,
       0,     0,     0,     0,   850,     0,   851,     0,     0,   852,
       0,     0,     0,     0,    49,     0,     0,    50,    51,     0,
      52,    53,    54,    55,    56,    57,     0,    58,    59,     0,
       0,     0,     0,     0,     0,     0,    60,    61,     0,     0,
       0,    62,     0,     0,    63,    64,    65,    66,     0,     0,
      67,    68,    69,    70,     0,    71,    72,   723,     0,     0,
       0,    73,    74,    75,     0,     0,    76,    77,     0,     0,
       0,     0,     0,    78,     0,     0,   725,     0,   727,     0,
       0,    79,    80,    81,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   729,     0,    40,    41,    42,
       0,     0,    43,    44,    45,     0,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,     0,     0,     0,     0,
       0,     0,     0,     0,    46,    47,    48,     0,     0,   155,
     466,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,    49,     0,     0,    50,    51,     0,
      52,    53,    54,    55,    56,    57,   467,    58,    59,     0,
       0,     0,     0,     0,     0,     0,    60,    61,     0,     0,
       0,    62,     0,     0,    63,    64,    65,    66,     0,     0,
      67,    68,    69,    70,     0,    71,    72,   724,     0,     0,
       0,    73,    74,    75,     0,     0,    76,    77,     0,     0,
       0,     0,     0,    78,     0,     0,   726,     0,   728,     0,
       0,    79,    80,    81,     0,    40,    41,    42,     0,     0,
      43,    44,    45,     0,     0,   730,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    46,    47,    48,     0,     0,     0,   140,   141,
       0,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
       0,     0,     0,    49,     0,     0,    50,    51,     0,    52,
      53,    54,    55,    56,    57,     0,    58,    59,     0,     0,
       0,     0,     0,     0,     0,    60,    61,     0,     0,     0,
      62,     0,     0,    63,    64,    65,    66,     0,     0,    67,
      68,    69,    70,  1224,    71,    72,     0,     0,     0,     0,
      73,    74,    75,     0,     0,    76,    77,     0,    40,    41,
      42,     0,    78,    43,    44,    45,     0,     0,     0,     0,
      79,    80,    81,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,    47,    48,     0,     0,
       0,   140,   141,     0,   142,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,   149,     0,     0,   150,   151,
     152,   153,   154,     0,     0,     0,     0,     0,     0,     0,
       0,    49,     0,     0,    50,    51,     0,    52,    53,    54,
      55,    56,    57,     0,    58,    59,     0,     0,     0,     0,
       0,     0,     0,    60,    61,     0,     0,     0,    62,     0,
       0,    63,    64,    65,    66,     0,  1229,    67,    68,    69,
      70,     0,    71,    72,     0,     0,     0,     0,    73,    74,
      75,     0,     0,    76,    77,     0,    40,    41,    42,     0,
      78,    43,    44,    45,     0,   850,     0,  1225,    79,    80,
      81,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,    46,    47,    48,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   402,     0,
    1269,     0,     0,     0,     0,     0,  1411,     0,     0,     0,
       0,     0,     0,     0,    49,     0,     0,    50,    51,     0,
      52,    53,    54,    55,    56,    57,     0,    58,    59,     0,
       0,     0,     0,     0,     0,     0,    60,    61,     0,     0,
       0,    62,     0,     0,    63,    64,    65,    66,     0,     0,
      67,    68,    69,    70,     0,    71,    72,     0,     0,     0,
       0,    73,    74,    75,     0,     0,    76,    77,     0,     0,
      40,    41,    42,    78,     0,    43,    44,    45,   850,     0,
    1225,    79,    80,    81,   155,     0,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,     0,    46,    47,    48,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   403,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    49,     0,     0,    50,    51,     0,    52,    53,
      54,    55,    56,    57,     0,    58,    59,  1214,     0,     0,
       0,     0,     0,     0,    60,    61,     0,  1215,     0,    62,
       0,     0,    63,    64,    65,    66,     0,     0,    67,    68,
      69,    70,     0,    71,    72,     0,     0,     0,     0,    73,
      74,    75,     0,     0,    76,    77,     0,    40,    41,    42,
       0,    78,    43,    44,    45,     0,     0,     0,     0,    79,
      80,    81,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    46,    47,    48,     0,     0,     0,
     140,   141,     0,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,     0,     0,     0,     0,    49,     0,     0,    50,
      51,     0,    52,    53,    54,    55,    56,    57,     0,    58,
      59,     0,     0,     0,     0,     0,     0,     0,    60,    61,
       0,     0,     0,    62,     0,     0,    63,    64,    65,    66,
       0,     0,    67,    68,    69,    70,     0,    71,    72,     0,
       0,     0,     0,    73,    74,    75,     0,     0,    76,    77,
       0,    40,    41,    42,     0,    78,    43,    44,    45,     0,
       0,     0,     0,    79,    80,    81,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    46,    47,
      48,     0,     0,     0,   140,   141,     0,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,     0,     0,     0,     0,
       0,     0,     0,    49,     0,     0,    50,    51,     0,    52,
      53,    54,    55,    56,    57,     0,    58,    59,     0,     0,
       0,     0,     0,     0,     0,    60,    61,     0,     0,     0,
      62,     0,   905,    63,    64,    65,    66,     0,     0,    67,
      68,    69,    70,     0,    71,    72,     0,     0,     0,     0,
      73,    74,    75,     0,     0,   906,   907,     0,    40,    41,
      42,     0,    78,    43,    44,    45,     0,     0,     0,     0,
      79,    80,    81,   155,     0,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,    46,    47,    48,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     404,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    49,     0,     0,
      50,    51,     0,    52,    53,    54,    55,    56,    57,     0,
      58,    59,     0,     0,     0,     0,     0,     0,     0,    60,
      61,     0,     0,     0,    62,     0,     0,    63,    64,    65,
      66,     0,     0,    67,    68,    69,    70,     0,    71,    72,
       0,     0,     0,     0,    73,    74,    75,     0,     0,    76,
      77,     0,    40,    41,    42,     0,    78,    43,    44,    45,
       0,     0,  1179,     0,    79,    80,    81,   155,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,    46,
      47,    48,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   710,     0,  1269,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    49,     0,     0,    50,    51,     0,
      52,    53,    54,    55,    56,    57,     0,    58,    59,     0,
       0,     0,     0,     0,     0,     0,    60,    61,     0,     0,
       0,    62,     0,     0,    63,    64,    65,    66,     0,     0,
      67,    68,    69,    70,     0,    71,    72,     0,     0,     0,
       0,    73,    74,    75,     0,     0,    76,    77,     0,    40,
      41,    42,     0,    78,    43,    44,    45,  1222,     0,     0,
       0,    79,    80,    81,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    46,    47,    48,     0,
       0,     0,   140,   141,     0,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,     0,     0,     0,     0,    49,     0,
       0,    50,    51,     0,    52,    53,    54,    55,    56,    57,
       0,    58,    59,     0,     0,     0,     0,     0,     0,     0,
      60,    61,     0,     0,     0,    62,     0,     0,    63,    64,
      65,    66,     0,     0,    67,    68,    69,    70,     0,    71,
      72,     0,     0,     0,     0,    73,    74,    75,     0,     0,
      76,    77,     0,    40,    41,    42,     0,    78,    43,    44,
      45,     0,     0,     0,     0,    79,    80,    81,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      46,    47,    48,     0,     0,     0,   140,   141,     0,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,     0,     0,
       0,     0,     0,     0,     0,    49,     0,     0,    50,    51,
       0,    52,    53,    54,    55,    56,    57,     0,    58,    59,
       0,     0,     0,     0,     0,     0,     0,    60,    61,     0,
       0,     0,    62,     0,     0,    63,    64,    65,    66,     0,
       0,    67,    68,    69,    70,     0,    71,    72,     0,     0,
       0,     0,    73,    74,    75,     0,     0,    76,    77,     0,
      40,    41,    42,     0,    78,    43,    44,    45,  1606,     0,
       0,     0,    79,    80,    81,   155,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    46,    47,    48,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1257,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    49,
       0,     0,    50,    51,     0,    52,    53,    54,    55,    56,
      57,     0,    58,    59,     0,     0,     0,     0,     0,     0,
       0,    60,    61,     0,     0,     0,    62,     0,     0,    63,
      64,    65,    66,     0,     0,    67,    68,    69,    70,     0,
      71,    72,     0,     0,     0,     0,    73,    74,    75,     0,
       0,    76,    77,     0,    40,    41,    42,     0,    78,    43,
      44,    45,     0,     0,     0,     0,    79,    80,    81,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,    46,    47,    48,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1629,     0,     0,     0,
       0,     0,     0,     0,     0,    40,    41,    42,     0,     0,
      43,    44,    45,     0,     0,     0,    49,     0,     0,    50,
      51,     0,    52,    53,    54,    55,    56,    57,     0,    58,
      59,     0,     0,     0,     0,     0,     0,     0,    60,    61,
       0,     0,     0,    62,     0,     0,    63,    64,    65,    66,
       0,     0,    67,    68,    69,    70,     0,    71,    72,     0,
       0,     0,     0,    73,    74,    75,     0,     0,    76,    77,
       0,     0,    40,    41,    42,  1139,     0,    43,    44,    45,
       0,     0,     0,    79,    80,    81,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    40,    41,    42,     0,   963,
      43,    44,    45,     0,     0,     0,     0,     0,     0,     0,
      49,     0,     0,    50,    51,     0,    52,    53,    54,    55,
      56,    57,     0,    58,    59,     0,     0,     0,     0,   964,
       0,     0,    60,    61,     0,     0,     0,    62,     0,   965,
      63,    64,    65,    66,     0,     0,    67,    68,    69,    70,
       0,    71,    72,     0,     0,     0,     0,    73,    74,    75,
       0,    49,    76,    77,    50,    51,     0,    52,    53,    54,
      55,    56,    57,     0,    58,    59,     0,    79,    80,    81,
      40,    41,    42,    60,    61,    43,    44,    45,    62,     0,
       0,    63,    64,    65,    66,     0,     0,    67,    68,    69,
      70,     0,    71,    72,     0,     0,     0,     0,   132,   133,
     134,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      78,     0,     0,     0,     0,     0,     0,     0,    49,     0,
      81,    50,    51,     0,    52,    53,    54,    55,    56,    57,
       0,    58,    59,     0,     0,     0,     0,    40,    41,    42,
      60,    61,    43,    44,    45,    62,     0,     0,    63,    64,
      65,    66,     0,     0,    67,    68,    69,    70,     0,    71,
      72,    49,     0,     0,    50,    51,     0,    52,    53,    54,
      55,    56,    57,     0,    58,    59,     0,    78,     0,     0,
       0,     0,     0,    60,    61,     0,     0,    81,    62,     0,
    1096,    63,    64,    65,    66,     0,     0,    67,    68,    69,
      70,     0,    71,    72,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      78,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      81,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    49,     0,     0,    50,
      51,     0,    52,    53,    54,    55,    56,    57,     0,    58,
      59,     0,     0,     0,     0,     0,     0,     0,    60,    61,
       0,     0,     0,    62,     0,  1097,    63,    64,    65,    66,
       0,     0,    67,    68,    69,    70,     0,    71,    72,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    78,     0,     0,     0,     0,
       0,     0,     0,    49,     0,    81,    50,    51,     0,    52,
      53,    54,    55,    56,    57,     0,    58,    59,     0,     0,
       0,     0,     0,     0,     0,    60,    61,     0,     0,     0,
      62,     0,     0,    63,    64,    65,    66,     0,     0,    67,
      68,    69,    70,     0,    71,    72,   477,     0,   -13,   140,
     141,   478,   142,   143,   144,   145,   146,   147,   148,     0,
       0,     0,    78,   149,     0,     0,   150,   151,   152,   153,
     154,     1,    81,     0,     0,     0,     0,     0,     0,     0,
     -13,   -13,   479,   682,   -13,   -13,   -13,   480,     0,     0,
     -13,     0,     0,   481,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   482,   483,     0,     0,     0,
     484,     0,     0,   485,     0,   -13,   486,   487,   -13,     0,
       0,     0,     0,   488,   -13,     0,   -13,   -13,   -13,   -13,
     -13,   -13,   489,   490,   -13,     0,     0,     0,     0,   491,
     492,   -13,   -13,   -13,   -13,     0,     0,   -13,   -13,   -13,
     -13,   -13,     0,     0,   493,     0,     0,     0,   -13,   -13,
       0,   494,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,
     -13,   495,     0,     0,   -13,     0,     0,     0,   -13,   -13,
     -13,   -13,     0,     0,     0,     0,     0,     0,     0,     0,
     496,     0,     0,     0,     0,   497,   498,   499,  1434,     0,
       0,     0,     0,     0,     0,     0,   140,   141,     0,   142,
     143,   144,   145,   146,   147,   148,     0,     0,   -13,   -13,
     149,     0,     0,   150,   151,   152,   153,   154,     0,   -13,
     140,   141,     0,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   155,     0,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   140,   141,     0,   142,   143,   144,
     145,   146,   147,   148,     0,     0,   683,     0,   149,  1696,
       0,   150,   151,   152,   153,   154,   140,   141,     0,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,   140,   141,
       0,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
     140,   141,     0,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,   140,   141,     0,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,   140,   141,     0,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,  1435,     0,     0,     0,     0,     0,
       0,     0,     0,   155,     0,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,     0,     0,     0,     0,   140,
     141,   276,   142,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,   149,     0,     0,   150,   151,   152,   153,
     154,     0,     0,     0,     0,     0,     0,   155,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,     0,     0,   277,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,     0,     0,   278,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,     0,     0,     0,   279,
       0,     0,     0,   155,     0,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,     0,     0,     0,     0,     0,
       0,   280,     0,     0,     0,   155,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       0,     0,     0,   281,     0,     0,     0,   155,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,   140,   141,   283,   142,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,   149,     0,     0,
     150,   151,   152,   153,   154,   140,   141,     0,   142,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,   149,
       0,     0,   150,   151,   152,   153,   154,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   155,     0,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,     0,     0,     0,     0,   140,   141,
     284,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
     140,   141,     0,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,   140,   141,     0,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,   140,   141,     0,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,   140,   141,     0,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,   140,   141,
       0,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
       0,     0,     0,     0,     0,     0,   155,     0,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,     0,     0,
       0,     0,     0,     0,   285,     0,     0,     0,   155,     0,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
       0,     0,     0,     0,   140,   141,   286,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,     0,     0,     0,   287,
       0,     0,     0,   155,     0,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,     0,     0,     0,     0,     0,
       0,   288,     0,     0,     0,   155,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       0,     0,     0,   290,     0,     0,     0,   155,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,     0,     0,   291,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,     0,     0,   295,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,     0,   140,   141,   296,
     142,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,   149,     0,     0,   150,   151,   152,   153,   154,   140,
     141,     0,   142,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,   149,     0,     0,   150,   151,   152,   153,
     154,     0,     0,     0,     0,     0,     0,   155,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,   140,   141,   297,   142,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,   149,     0,     0,
     150,   151,   152,   153,   154,   140,   141,     0,   142,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,   149,
       0,     0,   150,   151,   152,   153,   154,   140,   141,     0,
     142,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,   149,     0,     0,   150,   151,   152,   153,   154,   140,
     141,     0,   142,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,   149,     0,     0,   150,   151,   152,   153,
     154,   140,   141,     0,   142,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,   149,     0,     0,   150,   151,
     152,   153,   154,   140,   141,     0,   142,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,   149,     0,     0,
     150,   151,   152,   153,   154,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     155,     0,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,     0,     0,     0,     0,     0,     0,   298,     0,
       0,     0,   155,     0,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,     0,     0,     0,     0,   140,   141,
     299,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
       0,     0,     0,     0,     0,     0,   155,     0,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,     0,     0,
       0,     0,     0,     0,   394,     0,     0,     0,   155,     0,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
       0,     0,     0,     0,     0,     0,   395,     0,     0,     0,
     155,     0,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,     0,     0,     0,     0,     0,     0,   396,     0,
       0,     0,   155,     0,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,     0,     0,     0,     0,     0,     0,
     397,     0,     0,     0,   155,     0,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,     0,     0,     0,     0,
       0,     0,   398,     0,     0,     0,   155,     0,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,     0,     0,
       0,     0,   140,   141,   929,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,   140,   141,     0,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,     0,   140,   141,   935,
     142,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,   149,     0,     0,   150,   151,   152,   153,   154,   140,
     141,     0,   142,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,   149,     0,     0,   150,   151,   152,   153,
     154,   140,   141,     0,   142,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,   149,     0,     0,   150,   151,
     152,   153,   154,   140,   141,     0,   142,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,   149,     0,     0,
     150,   151,   152,   153,   154,   140,   141,     0,   142,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,   149,
       0,     0,   150,   151,   152,   153,   154,   140,   141,     0,
     142,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,   149,     0,     0,   150,   151,   152,   153,   154,     0,
       0,     0,     0,     0,     0,   155,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       0,     0,     0,  1136,     0,     0,     0,   155,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,   140,   141,  1352,   142,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,   149,     0,     0,
     150,   151,   152,   153,   154,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     155,     0,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,     0,     0,     0,     0,     0,     0,  1353,     0,
       0,     0,   155,     0,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,     0,     0,     0,     0,     0,     0,
    1354,     0,     0,     0,   155,     0,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,     0,     0,     0,     0,
       0,     0,  1361,     0,     0,     0,   155,     0,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,     0,     0,
       0,     0,     0,     0,  1362,     0,     0,     0,   155,     0,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
       0,     0,     0,     0,     0,     0,  1363,     0,     0,     0,
     155,     0,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,     0,     0,     0,     0,   140,   141,  1365,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,   140,   141,
       0,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
       0,     0,     0,     0,     0,     0,   155,     0,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,     0,     0,
       0,     0,   140,   141,  1547,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,   140,   141,     0,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,   140,   141,     0,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,   140,   141,
       0,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
     140,   141,     0,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,   140,   141,     0,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,     0,     0,  1627,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,     0,   140,   141,  1628,
     142,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,   149,     0,     0,   150,   151,   152,   153,   154,     0,
       0,     0,     0,     0,     0,   155,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       0,     0,     0,  1647,     0,     0,     0,   155,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,     0,     0,  1684,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,     0,     0,  1716,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,     0,     0,     0,  1717,
       0,     0,     0,   155,     0,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,     0,     0,     0,     0,     0,
       0,  1743,     0,     0,     0,   155,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       0,   140,   141,  1744,   142,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,   149,     0,     0,   150,   151,
     152,   153,   154,   140,   141,     0,   142,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,   149,     0,     0,
     150,   151,   152,   153,   154,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     155,     0,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,     0,     0,     0,     0,   140,   141,  1756,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,   140,   141,
       0,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
     140,   141,     0,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,   140,   141,     0,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,   140,   141,     0,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,   140,   141,     0,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,     0,     0,
       0,     0,     0,     0,   155,     0,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,     0,     0,     0,     0,
       0,     0,  1776,     0,     0,     0,   155,     0,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,     0,     0,
       0,     0,   140,   141,  1777,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,     0,   371,     0,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,     0,     0,  1103,     0,
       0,     0,     0,   155,     0,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,     0,     0,     0,     0,     0,
    1273,     0,     0,     0,     0,   155,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       0,     0,  1346,     0,     0,     0,     0,   155,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,     0,  1347,     0,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,   140,   141,  1381,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,   140,   141,     0,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,     0,     0,
       0,     0,     0,     0,     0,   155,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,     0,
     140,   141,  1385,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,   140,   141,     0,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,   140,   141,     0,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,   140,   141,     0,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,   140,   141,
       0,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
     140,   141,     0,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   155,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,     0,  1392,     0,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,   140,   141,  1492,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,     0,     0,     0,     0,
       0,     0,     0,   155,     0,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,     0,     0,     0,     0,     0,
    1507,     0,     0,     0,     0,   155,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       0,     0,  1520,     0,     0,     0,     0,   155,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,     0,  1521,     0,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,     0,  1523,     0,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,     0,     0,  1524,     0,
       0,     0,     0,   155,     0,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,     0,     0,     0,   140,   141,
    1541,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
     140,   141,     0,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   155,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,   140,   141,  1622,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,   140,   141,     0,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,   140,   141,     0,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,   140,   141,
       0,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
     140,   141,     0,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,   140,   141,     0,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,     0,     0,     0,     0,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,     0,     0,  1727,     0,
       0,     0,     0,   155,     0,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,     0,     0,     0,   140,   141,
    1754,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   155,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       0,     0,  1755,     0,     0,     0,     0,   155,   215,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,  1427,     0,     0,     0,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,   282,     0,     0,     0,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,   289,     0,     0,     0,
       0,     0,     0,   155,     0,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   510,   699,     0,   292,     0,
       0,     0,   511,     0,   512,   155,   513,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,     0,
     293,     0,     0,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   477,     0,
     -13,     0,     0,   478,     0,     0,     0,     0,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     1,     0,     0,   294,     0,     0,     0,
       0,     0,   -13,   -13,   479,     0,   -13,   -13,   -13,   480,
       0,     0,   -13,     0,     0,   481,     0,     0,     0,  -382,
       0,     0,     0,     0,     0,     0,     0,   482,   483,     0,
       0,     0,   484,     0,     0,   485,     0,   -13,   486,   487,
     -13,     0,     0,     0,     0,   488,   -13,     0,   -13,   -13,
     -13,   -13,   -13,   -13,   489,   490,   -13,     0,     0,     0,
       0,   491,   492,   -13,   -13,   -13,   -13,     0,     0,   -13,
     -13,   -13,   -13,   -13,     0,     0,   493,     0,     0,     0,
     -13,   -13,     0,   494,   -13,   -13,   -13,   -13,   -13,   -13,
     -13,   -13,   -13,   495,     0,     0,   -13,     0,     0,     0,
     -13,   -13,   -13,   -13,     0,     0,     0,     0,     0,     0,
       0,     0,   496,     0,     0,     0,     0,   497,   498,   499,
       0,     0,     0,     0,   477,     0,   -13,     0,     0,   478,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     -13,   -13,     0,     0,     0,     0,     0,     0,     0,     1,
       0,   -13,     0,     0,     0,     0,     0,     0,   -13,   -13,
     479,     0,   -13,   -13,   -13,   480,     0,     0,   -13,     0,
       0,   481,     0,     0,     0,  -382,     0,     0,     0,     0,
       0,     0,     0,   482,   483,     0,     0,     0,   484,     0,
       0,   485,   816,   -13,   486,   487,   -13,     0,     0,     0,
       0,   488,   -13,     0,   -13,   -13,   -13,   -13,   -13,   -13,
     489,   490,   -13,     0,     0,     0,     0,   491,   492,   -13,
     -13,   -13,   -13,     0,     0,   -13,   -13,   -13,   -13,   -13,
       0,     0,   493,     0,     0,     0,   -13,   -13,     0,   494,
     -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   495,
       0,     0,   -13,     0,     0,     0,   -13,   -13,   -13,   -13,
       0,     0,     0,     0,     0,     0,     0,     0,   496,     0,
       0,     0,     0,   497,   498,   499,     0,     0,     0,     0,
       0,   140,   141,     0,   142,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,   149,   -13,   -13,   150,   151,
     152,   153,   154,     0,     0,   140,   141,   -13,   142,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,   149,
       0,     0,   150,   151,   152,   153,   154,     0,     0,     0,
       0,     0,   140,   141,     0,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,   888,   150,
     151,   152,   153,   154,   140,   141,     0,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,   140,   141,     0,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,   140,   141,
       0,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
     140,   141,     0,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,   140,   141,     0,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,     0,     0,     0,     0,     0,     0,
     546,     0,   140,   141,   547,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,   155,     0,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   155,   215,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   155,   303,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   155,   347,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   155,
     912,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   155,  1266,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   155,  1293,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   155,  1386,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   155,  1526,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   140,   141,     0,
     142,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,   149,     0,     0,   150,   151,   152,   153,   154,   140,
     141,     0,   142,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,   149,     0,     0,   150,   151,   152,   153,
     154,   140,   141,     0,   142,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,   149,   510,   894,   150,   151,
     152,   153,   154,   511,     0,   512,     0,   513,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   510,   895,     0,     0,     0,     0,     0,
     511,     0,   512,     0,   513,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     510,     0,     0,     0,     0,     0,     0,   511,   896,   512,
       0,   513,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   897,   898,
     899,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     155,  1538,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   155,  1548,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   477,     0,   -13,     0,     0,   478,
       0,     0,     0,     0,   155,     0,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,     0,     0,     0,     1,
       0,     0,     0,     0,     0,     0,     0,     0,   -13,   -13,
     479,     0,   -13,   -13,   -13,   480,     0,     0,   -13,     0,
       0,   481,     0,     0,     0,  -381,     0,     0,  -381,     0,
       0,     0,     0,   482,   483,     0,     0,     0,   484,     0,
       0,   485,     0,   -13,   486,   487,   -13,     0,     0,     0,
       0,   488,   -13,     0,   -13,   -13,   -13,   -13,   -13,   -13,
     489,   490,   -13,     0,     0,     0,     0,   491,   492,   -13,
     -13,   -13,   -13,     0,     0,   -13,   -13,   -13,   -13,   -13,
       0,     0,   493,     0,     0,     0,   -13,   -13,     0,   494,
     -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   495,
       0,     0,   -13,     0,     0,     0,   -13,   -13,   -13,   -13,
       0,     0,     0,     0,   477,     0,   -13,     0,   496,   478,
       0,     0,  -381,   497,   498,   499,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     1,
       0,     0,     0,     0,     0,     0,   -13,   -13,   -13,   -13,
     479,   633,   -13,   -13,   -13,   480,     0,   -13,   -13,     0,
       0,   481,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   482,   483,     0,     0,     0,   484,     0,
       0,   485,     0,   -13,   486,   487,   -13,     0,     0,     0,
       0,   488,   -13,     0,   -13,   -13,   -13,   -13,   -13,   -13,
     489,   490,   -13,     0,     0,     0,     0,   491,   492,   -13,
     -13,   -13,   -13,     0,     0,   -13,   -13,   -13,   -13,   -13,
       0,     0,   493,     0,     0,     0,   -13,   -13,     0,   494,
     -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   495,
       0,     0,   -13,     0,     0,     0,   -13,   -13,   -13,   -13,
       0,     0,     0,     0,   477,     0,   -13,     0,   496,   478,
       0,     0,  -382,   497,   498,   499,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     1,
       0,     0,     0,     0,     0,     0,   -13,   -13,   -13,   -13,
     479,     0,   -13,   -13,   -13,   480,     0,   -13,   -13,     0,
       0,   481,     0,     0,     0,     0,     0,     0,  -382,     0,
       0,     0,     0,   482,   483,     0,     0,     0,   484,     0,
       0,   485,     0,   -13,   486,   487,   -13,     0,     0,     0,
       0,   488,   -13,     0,   -13,   -13,   -13,   -13,   -13,   -13,
     489,   490,   -13,     0,     0,     0,     0,   491,   492,   -13,
     -13,   -13,   -13,     0,     0,   -13,   -13,   -13,   -13,   -13,
       0,     0,   493,     0,     0,     0,   -13,   -13,     0,   494,
     -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   495,
       0,     0,   -13,     0,     0,     0,   -13,   -13,   -13,   -13,
       0,     0,     0,     0,   477,     0,   -13,     0,   496,   478,
       0,     0,     0,   497,   498,   499,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     1,
       0,     0,     0,     0,     0,     0,   -13,   -13,   -13,   -13,
     479,     0,   -13,   -13,   -13,   480,     0,   -13,   -13,     0,
       0,   481,     0,     0,     0,  -382,     0,     0,     0,     0,
       0,     0,     0,   482,   483,     0,     0,     0,   484,     0,
       0,   485,     0,   -13,   486,   487,   -13,     0,     0,     0,
       0,   488,   -13,     0,   -13,   -13,   -13,   -13,   -13,   -13,
     489,   490,   -13,     0,     0,     0,     0,   491,   492,   -13,
     -13,   -13,   -13,     0,     0,   -13,   -13,   -13,   -13,   -13,
       0,     0,   493,     0,     0,     0,   -13,   -13,     0,   494,
     -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   495,
       0,     0,   -13,     0,     0,     0,   -13,   -13,   -13,   -13,
       0,     0,     0,     0,   477,     0,   -13,     0,   496,   478,
       0,     0,     0,   497,   498,   499,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     1,
       0,     0,     0,     0,     0,     0,   -13,   -13,   -13,   -13,
     479,   682,   -13,   -13,   -13,   480,     0,   -13,   -13,     0,
       0,   481,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   482,   483,     0,     0,     0,   484,     0,
       0,   485,     0,   -13,   486,   487,   -13,     0,     0,     0,
       0,   488,   -13,     0,   -13,   -13,   -13,   -13,   -13,   -13,
     489,   490,   -13,     0,     0,     0,     0,   491,   492,   -13,
     -13,   -13,   -13,     0,     0,   -13,   -13,   -13,   -13,   -13,
       0,     0,   493,     0,   646,     0,   -13,   -13,     0,   494,
     -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   495,
       0,     0,   -13,     0,     0,     0,   -13,   -13,   -13,   -13,
       0,     0,     0,     0,     0,     0,   647,   648,   496,     0,
     649,   650,   651,   497,   498,   499,   652,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   -13,   -13,     0,     0,
       0,   653,     0,     0,   654,     0,     0,   -13,     0,     0,
     655,     0,   656,   657,   658,   659,   660,   661,     0,     0,
     662,     0,     0,     0,     0,     0,     0,   663,   664,   665,
     666,     0,     0,   667,   668,   669,   670,   671,     0,     0,
       0,     0,     0,     0,   426,   427,     0,     0,   672,   673,
     674,   675,   428,   429,   430,   431,   432,     0,     0,     0,
     433,     0,     0,     0,   434,   435,   676,   677,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   510,     0,
       0,     0,     0,     0,     0,   511,     0,   512,     0,   513,
       0,     0,     0,     0,   436,   437,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   678,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532
};

static const yytype_int16 yycheck[] =
{
      30,   499,   503,   504,  1088,   328,   603,     0,   844,   473,
     474,   475,    81,   672,   679,     8,   813,   492,   497,     1,
     538,   613,   614,   615,   616,   595,    95,   709,    11,   621,
      27,   764,   647,   598,     3,     1,     3,     3,   653,  1057,
    1058,   735,    53,     1,    53,     3,     3,  1359,    78,    53,
       3,    81,  1275,    97,     3,   378,     1,     3,     3,  1172,
       3,     3,     1,     3,     3,    95,   572,   923,     3,     3,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   891,     3,   419,   166,     3,     1,
       3,    11,   146,   147,     3,     1,    25,     9,     8,     9,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   481,   168,     3,
     834,     3,     3,     1,  1456,   839,   490,     1,   842,     3,
    1054,   220,   846,   369,   633,   499,     3,   238,    97,     3,
       3,    11,  1275,     3,     3,     9,    10,   631,   225,     9,
      10,    23,    24,   478,     3,     3,     3,   482,   696,    26,
     698,   699,   239,   775,    87,   215,     3,    26,     3,  1045,
     220,   221,  1415,   498,     3,   440,   239,   442,   443,    27,
       9,    10,    52,   682,   679,   680,   249,   146,   147,   801,
    1453,   679,   680,     1,   225,     3,   225,   950,   157,    86,
     835,   225,   957,   242,  1337,   689,    87,   367,   843,   844,
       3,   737,   251,   577,    25,   265,     9,    10,  1351,   239,
       3,    75,   239,    77,   588,    88,  1359,   242,     3,   249,
     594,   986,   282,    18,    19,    20,   251,   240,   241,   289,
      25,   506,   292,   293,   294,   481,     1,   249,     3,     1,
       3,     3,   241,   303,   108,   305,   306,   307,  1590,   309,
     273,  1014,   248,   250,   241,    73,     0,  1020,   752,   753,
     248,   755,   241,   238,  1150,   241,   640,   250,   243,  1155,
     238,   244,  1415,   248,   238,   248,   248,   238,  1212,    97,
      98,   250,   250,   248,   233,   234,   235,   347,   822,   823,
     460,   825,   462,   200,   828,  1568,  1569,   204,   233,   117,
     240,   239,  1644,   238,   579,   580,   238,   582,    73,   238,
    1034,    73,   238,  1456,   243,   241,    76,   917,    78,   919,
     380,   916,   170,   918,   172,   830,   572,   225,   757,   758,
     148,   760,    97,    98,   763,    97,    98,    47,   806,   157,
     808,   239,   239,   225,   238,   242,   238,   895,    72,   243,
     238,  1494,   117,   241,   238,   117,   239,   239,   418,   242,
     240,   241,   239,    87,   238,   242,   389,   244,   238,   332,
     239,   248,   241,   242,   748,    99,   881,   882,  1264,   238,
     885,   238,   850,  1028,   882,  1074,  1098,  1099,   238,  1113,
    1085,   238,   157,   238,  1039,   157,   244,   240,   892,   238,
     250,   647,   250,     1,  1338,     3,   466,   653,   238,   762,
     231,   232,   233,   234,   235,   690,    11,    12,    73,     0,
     250,  1248,   244,    18,    19,    20,  1360,  1361,   250,  1363,
      25,     3,   250,    93,  1320,   238,   231,   232,   233,   234,
     235,   239,    97,    98,     3,    26,   951,  1590,     7,   500,
     955,   249,   112,   163,   114,   506,   166,    71,    72,   169,
     423,   424,   117,   782,   783,   784,   785,   786,   787,   788,
       3,   131,    73,    87,  1008,   794,   795,   796,   797,   180,
     181,   239,    80,   241,   239,   250,   546,    67,   250,   735,
     241,   737,    90,   194,   249,   555,    97,    98,    99,    71,
      72,  1644,   157,    13,   240,   468,   207,   241,   568,  1136,
      91,    21,   941,    93,   250,    87,   117,     0,   578,    11,
      12,   222,    14,    15,    16,    17,    18,    19,    20,    71,
      72,   197,   112,    25,   114,   595,     3,   203,   598,    46,
      47,    48,  1164,    26,   239,    87,  1432,  1433,   214,   239,
    1239,   131,  1438,  1439,  1440,  1441,   251,  1088,    26,  1445,
    1446,  1447,  1448,  1497,   145,     3,    73,    74,    75,    76,
      77,   165,    79,    80,   239,  1080,   240,  1086,   860,  1627,
    1628,  1515,   864,   164,   249,   238,   250,   833,   834,   835,
      92,  1085,    60,   839,   840,   250,   842,   843,   844,   874,
     846,   936,   937,    71,    72,   851,     8,   853,    91,   111,
     238,   113,   887,   240,   195,   238,    70,   244,    72,    87,
      88,    66,   170,   250,   172,   132,   133,   134,   130,  1495,
      73,   238,   213,    87,   229,   230,   231,   232,   233,   234,
     235,  1575,  1508,   240,   241,    99,   238,    92,   708,   709,
    1536,   240,   244,  1767,    97,    98,    99,   239,   250,   719,
     242,   250,   145,    73,    13,  1000,   111,  1176,   113,   239,
    1292,   241,    21,   241,   117,   238,   244,  1611,  1612,   739,
     238,   164,   250,  1617,   152,   130,   238,    97,    98,    99,
    1624,  1625,   197,   198,  1316,    13,  1318,   238,   203,   238,
    1074,   191,   241,    21,   764,   244,   196,   117,   238,   214,
    1355,   250,   195,   238,   774,   231,   232,  1362,    26,  1364,
    1365,  1499,    73,   239,  1502,     1,  1504,     3,     4,     5,
     213,    99,     8,     9,    10,   238,  1670,   229,   230,   231,
     232,   233,   234,   235,   180,   181,    97,    98,    99,   238,
      73,   238,    60,   852,  1089,  1090,   242,   232,   194,   241,
     238,   821,   244,   199,  1650,    73,   117,   238,   250,  1655,
    1415,   207,  1658,  1659,    97,    98,    99,   252,   253,   254,
      88,    73,  1028,   238,   486,   487,   222,   489,  1034,    97,
      98,    99,   852,  1039,   117,  1353,  1354,  1325,  1326,  1327,
    1057,  1058,  1330,  1331,  1332,    97,    98,    99,  1054,   117,
      66,    67,  1326,  1327,   385,   386,  1330,  1331,  1332,   239,
     880,    73,   242,   239,   884,   117,   242,  1449,  1450,  1148,
    1149,   854,  1151,  1152,  1153,  1154,    92,    93,   238,  1158,
    1159,  1160,  1161,   238,   152,    97,    98,    99,   239,   238,
    1495,   242,   912,   913,   238,   111,   112,   113,   114,   239,
     238,   241,   242,  1508,   238,   117,   239,  1113,   241,   242,
     239,   238,   932,   242,   130,   131,   239,   239,   241,   242,
     242,   238,     5,   239,   241,   239,   242,   239,   242,   241,
     950,   239,   952,   239,   242,   239,   242,   238,   242,   959,
     960,  1372,  1373,   179,   964,   965,   182,   183,   238,   185,
     186,   187,   188,   189,   190,   239,   192,   193,   242,   239,
    1539,  1540,   242,  1552,   239,   201,   202,   242,  1557,  1558,
     206,  1560,  1561,   209,   210,   211,   212,  1566,  1567,   215,
     216,   217,   218,   239,   220,   221,   242,     3,   239,   239,
     239,   242,   242,   242,  1014,   243,  1055,  1017,  1018,   239,
    1020,   241,   238,     3,  1609,   239,  1212,     3,   242,  1029,
    1030,  1031,   248,   239,   239,   239,   242,   242,  1623,  1225,
    1040,   241,  1042,  1043,  1044,   239,   239,   241,  1048,   242,
     239,     1,   241,     3,   239,  1055,   241,  1057,  1058,    26,
    1060,  1061,  1726,  1727,     1,     3,     3,  1067,  1539,  1540,
       1,     1,     3,     3,   240,     1,  1115,     3,  1078,     1,
       3,     3,    11,    12,  1047,    14,    15,    16,    17,    18,
      19,    20,   239,    60,   241,   239,    25,   241,  1098,  1099,
     239,    30,   241,   240,    71,    72,    73,   239,   239,   241,
     241,   239,  1112,   241,   240,  1115,  1701,   239,   238,   241,
      87,    88,   239,   239,   241,   241,   239,   239,   241,   241,
      97,    98,    99,   240,   239,  1704,   241,   240,  1707,  1139,
     238,  1710,  1711,    25,   239,  1579,   241,  1147,   240,  1583,
     117,     5,  1338,  1587,   239,   239,   241,   241,   244,   239,
    1594,   241,   241,     1,  1598,     3,   535,   536,  1602,  1355,
     239,   239,   241,   241,  1360,  1361,  1362,  1363,  1364,  1365,
    1765,   239,   239,   241,   241,   152,   239,   241,   241,  1189,
     241,  1776,  1777,   239,   239,   241,   241,   241,  1473,  1474,
    1475,  1201,  1477,  1478,  1479,     3,  1481,  1482,  1483,  1172,
     239,   239,   241,   241,  1214,  1215,   239,   239,   241,   241,
     239,   239,   241,   241,     3,     3,  1226,  1227,     5,  1415,
    1230,  1231,  1271,    99,   239,  1235,   241,   239,   239,   241,
     241,   239,   239,   241,   241,    88,  1461,   113,   114,  1435,
    1465,   239,    26,   241,  1469,   121,   122,   123,   124,   125,
     239,  1476,   241,   129,   239,  1480,  1266,   133,   134,  1484,
     239,  1271,   241,  1273,   239,   239,   241,   241,   239,  1279,
     241,   239,  1282,   241,   239,   459,   241,   461,     3,     3,
     242,   250,     3,  1293,   241,   241,  1767,  1297,  1298,   228,
     229,   230,   231,   232,   233,   234,   235,   173,   174,  1495,
       3,  1497,  1275,   241,   241,     3,     3,     3,    72,     3,
     241,   241,  1508,   241,     3,   115,   170,     1,     3,  1515,
       3,   240,   238,    73,   781,   782,   783,   784,   785,   786,
     787,   788,   249,     3,     3,   241,   240,   794,   795,   796,
     797,    56,  1352,  1353,  1354,   157,  1356,     3,   251,    72,
     241,   250,   242,   240,   238,   241,   238,   238,    99,     1,
    1556,   238,  1372,  1373,  1337,   148,   238,  1377,  1378,    55,
       3,   241,  1382,    57,   225,     3,  1386,    58,  1351,  1575,
       5,     3,     3,     3,    68,    69,  1359,   243,     3,  1674,
      54,   113,   114,  1678,   241,   241,   241,  1682,  1371,   121,
     122,   123,   124,   125,   239,    57,   238,   129,   238,   238,
     238,   133,   134,  1609,   238,  1611,  1612,  1427,   238,   238,
     238,  1617,   238,   238,     3,   238,   110,  1623,  1624,  1625,
     241,   238,  1442,   238,   238,   157,     3,   240,   149,   241,
     241,   240,  1415,   240,   239,   241,     3,    51,    56,   906,
     907,   173,   174,   137,   138,   139,   140,   141,   142,   143,
     144,   243,   164,   241,   241,   240,   242,   241,   239,   153,
     154,   155,   156,   239,  1670,   159,   160,   161,   162,  1489,
     239,   239,     3,  1456,   240,   238,     3,   242,   242,  1499,
     113,   114,  1502,   241,  1504,   240,   240,   239,   121,   122,
     123,   124,   125,   250,   242,  1701,   129,   964,   965,   242,
     133,   134,   242,   242,   242,    52,  1526,     3,   975,  1529,
     238,  1494,   238,    26,   238,   238,   238,    22,  1538,   238,
    1726,  1727,   238,   238,   241,  1545,     3,   241,  1548,    52,
     241,   241,   241,   238,    27,   225,   225,   225,   241,   241,
     173,   174,     3,   241,   238,   242,     3,   223,     1,   241,
       3,     4,     5,  1573,  1574,     8,     9,    10,   240,  1765,
       3,   239,   239,   250,   239,    59,   239,   239,   239,   239,
    1776,  1777,   239,   242,   239,   239,   239,    30,    31,    32,
     239,   241,     5,   149,   241,   240,     3,   241,     3,   240,
       3,   241,   250,     3,     3,   242,   242,   242,   242,    54,
     242,   242,  1622,   240,   238,   244,   242,  1590,    34,   238,
     238,   223,   223,     3,    52,    74,   242,   241,     1,   239,
       3,     4,     5,   242,   251,     8,     9,    10,  1648,   250,
     240,     3,    52,   242,   242,   242,   242,   242,   241,   238,
     238,   241,  1662,  1663,   241,   225,     3,    30,    31,    32,
     241,   241,   239,   239,   239,   239,   239,   239,   239,     5,
     239,  1644,     3,   239,   239,   238,   238,    52,   238,   240,
     244,     3,   241,   241,  1694,  1695,   240,   242,    34,   242,
    1700,  1148,  1149,   239,  1151,  1152,  1153,  1154,   241,   251,
       3,  1158,  1159,  1160,  1161,     3,    11,    12,     3,    14,
      15,    16,    17,    18,    19,    20,     3,     3,    23,    24,
      25,     3,     3,    28,    29,    30,    31,    32,     3,     3,
     241,    59,   242,    51,   149,    51,   179,   242,     3,   182,
     183,    54,   185,   186,   187,   188,   189,   190,   241,   192,
     193,   223,   239,   241,  1764,   225,  1766,   239,   201,   202,
     239,   239,     3,   206,   241,   245,   209,   210,   211,   212,
      59,   242,   215,   216,   217,   218,   240,   220,   221,   242,
     242,   242,   242,   226,   227,   228,   242,   242,   231,   232,
     242,     3,     3,     3,   242,   238,   239,   241,    59,   242,
     250,   244,   241,   246,   247,   248,   179,   241,    54,   182,
     183,   241,   185,   186,   187,   188,   189,   190,   241,   192,
     193,   241,   241,   241,    32,   242,   240,   992,   201,   202,
     242,   242,   241,   206,   242,   241,   209,   210,   211,   212,
     242,   242,   215,   216,   217,   218,   242,   220,   221,   242,
     240,     8,  1309,   226,   227,   228,   241,   241,   231,   232,
      24,   455,   185,   178,   769,   238,   239,   389,  1113,   242,
     545,   244,  1415,   246,   247,   248,     1,  1271,     3,     4,
       5,   494,  1530,     8,     9,    10,  1397,   681,  1344,   387,
     468,   549,   827,  1128,  1064,  1069,   665,   950,  1636,  1136,
       1,   961,     3,     4,   623,    30,    31,    32,  1337,  1470,
      -1,  1276,  1094,    -1,    -1,    -1,   508,   315,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   536,    33,    -1,    -1,    -1,    37,    38,    -1,    -1,
      -1,    42,    43,    44,   535,    46,   251,    -1,    49,     1,
      -1,     3,     4,     5,    -1,    80,     8,     9,    10,    -1,
      61,    62,    63,    64,    -1,    90,    -1,    68,    -1,    -1,
      -1,    -1,  1429,    74,    -1,    -1,    -1,    -1,    30,    31,
      32,    -1,    -1,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,   100,
     101,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   128,    80,    -1,
      -1,   132,    -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,
      -1,    -1,     1,    -1,     3,     4,     5,    -1,    -1,     8,
       9,    10,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,    -1,
      -1,    30,    31,    32,    -1,    -1,   201,   202,    -1,    -1,
      -1,   206,    -1,    -1,   209,   210,   211,   212,    47,    -1,
     215,   216,   217,   218,    53,   220,   221,    -1,    -1,    -1,
      -1,   226,   227,   228,    -1,    -1,   231,   232,   233,    -1,
      -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   246,   247,   248,   225,    -1,    -1,   179,    -1,    -1,
     182,   183,    -1,   185,   186,   187,   188,   189,   190,    -1,
     192,   193,   243,    -1,   245,    -1,    -1,   248,    -1,   201,
     202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,    -1,   220,   221,
      -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,
     232,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   246,   247,   248,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,     1,    -1,
       3,     4,     5,    -1,    -1,     8,     9,    10,    -1,    -1,
     179,    -1,    -1,   182,   183,    -1,   185,   186,   187,   188,
     189,   190,    -1,   192,   193,    -1,    -1,    30,    31,    32,
      -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,
     209,   210,   211,   212,    47,    -1,   215,   216,   217,   218,
      53,   220,   221,    57,    -1,    -1,    -1,   226,   227,   228,
      -1,    -1,   231,   232,    68,    69,    -1,    -1,    -1,   238,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,   247,   248,
       1,    -1,     3,     4,     5,    -1,    -1,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,    -1,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    47,    -1,    -1,    -1,
      -1,    -1,    53,   137,   138,   139,   140,   141,   142,   143,
     144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   153,
     154,   155,   156,    -1,    -1,   159,   160,   161,   162,    -1,
      -1,    -1,     1,    -1,     3,     4,     5,    -1,    -1,     8,
       9,    10,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    30,    31,    32,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,    -1,
      -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,
      -1,    -1,    -1,    -1,   238,   238,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   246,   247,   248,     1,    -1,     3,     4,
       5,    -1,    -1,     8,     9,    10,    -1,    -1,   179,    -1,
      -1,   182,   183,    -1,   185,   186,   187,   188,   189,   190,
      -1,   192,   193,    -1,    -1,    30,    31,    32,    -1,    -1,
     201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,
     211,   212,    47,    -1,   215,   216,   217,   218,    -1,   220,
     221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,
     231,   232,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   246,   247,   248,     1,    -1,
       3,     4,     5,    -1,    -1,     8,     9,    10,    -1,    -1,
     179,    -1,    -1,   182,   183,    -1,   185,   186,   187,   188,
     189,   190,    -1,   192,   193,    -1,    -1,    30,    31,    32,
      -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,
     209,   210,   211,   212,    47,    -1,   215,   216,   217,   218,
      -1,   220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,
      -1,    -1,   231,   232,    -1,    -1,    -1,    -1,    -1,   238,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   246,   247,   248,
      -1,    -1,     1,    -1,     3,     4,     5,    -1,    -1,     8,
       9,    10,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,    -1,
      -1,    30,    31,    32,    -1,    -1,   201,   202,    -1,    -1,
      -1,   206,    -1,    -1,   209,   210,   211,   212,    47,    -1,
     215,   216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,
      -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,    -1,
      -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   246,   247,   248,     1,    -1,     3,     4,     5,    -1,
      -1,     8,     9,    10,    -1,    -1,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    30,    31,    32,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,    -1,
      -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,
      -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   246,   247,   248,     1,    -1,     3,     4,
       5,    -1,    -1,     8,     9,    10,    -1,    -1,    -1,    -1,
     179,    -1,    -1,   182,   183,    -1,   185,   186,   187,   188,
     189,   190,    -1,   192,   193,    30,    31,    32,    -1,    -1,
      -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,
     209,   210,   211,   212,    -1,    -1,   215,   216,   217,   218,
      -1,   220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,
      -1,    -1,   231,   232,    -1,    -1,    -1,    -1,    -1,   238,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,   247,   248,
       1,    -1,     3,     4,     5,    -1,    -1,     8,     9,    10,
      -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,   186,
     187,   188,   189,   190,    -1,   192,   193,    -1,    -1,    30,
      31,    32,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,
      -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,   216,
     217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,
     227,   228,    -1,    -1,   231,   232,    -1,    -1,    -1,    -1,
      -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,
     247,   248,     1,    -1,     3,     4,     5,    -1,    -1,     8,
       9,    10,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,    -1,
      -1,    30,    31,    32,    -1,    -1,   201,   202,    -1,    -1,
      -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,
      -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,    -1,
      -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   246,   247,   248,     1,    -1,     3,     4,     5,    -1,
      -1,     8,     9,    10,    -1,    -1,    -1,    -1,   179,    -1,
      -1,   182,   183,    -1,   185,   186,   187,   188,   189,   190,
      -1,   192,   193,    30,    31,    32,    -1,    -1,    -1,    -1,
     201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,    -1,   220,
     221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,
     231,   232,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   246,   247,   248,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     179,    -1,    -1,   182,   183,    -1,   185,   186,   187,   188,
     189,   190,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,
     209,   210,   211,   212,    -1,    -1,   215,   216,   217,   218,
      -1,   220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,
      -1,    -1,   231,   232,    -1,    -1,    -1,    11,    12,   238,
      14,    15,    16,    17,    18,    19,    20,   246,   247,   248,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
      -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,   186,
     187,   188,   189,   190,    -1,   192,   193,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,
      -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,   216,
     217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,
     227,   228,    -1,    -1,   231,   232,     1,    -1,     3,     4,
      -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,
     247,   248,    -1,    -1,    -1,     1,    -1,     3,     4,     5,
      -1,    26,     8,     9,    10,    -1,    -1,    -1,    33,    -1,
      -1,    -1,    37,    38,    -1,    -1,    -1,    42,    43,    44,
      -1,    46,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    -1,    68,    -1,    -1,    71,    72,    73,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    97,    98,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   117,    -1,     1,    -1,     3,     4,    -1,    -1,
      -1,    -1,    -1,   128,    -1,    -1,    -1,   132,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    33,   152,    -1,    -1,
      37,    38,    -1,    -1,   248,    42,    43,    44,    -1,    46,
      -1,    -1,    49,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    61,    62,    63,    64,    -1,    -1,
      -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,    -1,    -1,
      -1,    -1,    -1,   100,   101,   201,   202,    -1,    -1,    -1,
     206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,    -1,   220,   221,    -1,    -1,   243,    -1,
     245,   128,    -1,   248,     1,   132,     3,     4,    -1,    -1,
      -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,    -1,    -1,
      37,    38,    -1,    -1,    -1,    42,    43,    44,     1,    46,
       3,     4,    49,    -1,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    61,    62,    63,    64,    25,    -1,
      -1,    68,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      33,    -1,    -1,    -1,    37,    38,    -1,    -1,    -1,    42,
      43,    44,    -1,    46,    -1,    -1,    49,    -1,   225,    -1,
      -1,    -1,    -1,   100,   101,    -1,    -1,    -1,    61,    62,
      63,    64,    -1,    -1,    -1,    68,   243,    -1,   245,    -1,
      -1,   248,     1,    -1,     3,     4,    -1,    -1,    -1,    -1,
      -1,   128,    -1,    -1,    -1,   132,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,    -1,
      -1,    -1,    -1,    -1,    33,    -1,    -1,    -1,    37,    38,
      -1,    -1,    -1,    42,    43,    44,    -1,    46,    -1,     1,
      49,     3,     4,    52,    -1,   128,    -1,    -1,    -1,   132,
      -1,    -1,    61,    62,    63,    64,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    -1,    -1,    -1,    37,    38,    -1,    -1,    -1,
      42,    43,    44,    -1,    46,    -1,    -1,    49,    -1,    -1,
      -1,   100,   101,    -1,    -1,    -1,    -1,    -1,   225,    61,
      62,    63,    64,    -1,    -1,    -1,    68,    -1,    -1,    -1,
      -1,    -1,    74,    -1,   241,    -1,   243,    -1,   245,   128,
      -1,   248,    -1,   132,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    -1,     3,     4,    -1,    -1,    -1,   100,   101,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,    -1,
     243,    -1,   245,    33,    -1,   248,   128,    37,    38,    -1,
     132,    -1,    42,    43,    44,    -1,    46,    -1,    -1,    49,
      -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    61,    62,    63,    64,    -1,    -1,    -1,    68,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,    -1,    -1,   243,    -1,   245,    33,    -1,   248,
      -1,    37,    38,    -1,    -1,    -1,    42,    43,    44,    -1,
      46,    -1,     1,    49,     3,     4,    -1,    -1,   128,    -1,
      -1,    -1,   132,    -1,    -1,    61,    62,    63,    64,    -1,
      -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    74,    -1,
      -1,   243,    -1,   245,    33,    -1,   248,    -1,    37,    38,
      -1,    -1,    -1,    42,    43,    44,    -1,    46,    -1,    -1,
      49,    -1,    -1,    -1,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    61,    62,    63,    64,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,    -1,   128,     8,     9,    10,   132,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,    -1,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   243,    -1,   245,    -1,    -1,   248,   128,
      -1,    11,    12,   132,    14,    15,    16,    17,    18,    19,
      20,    66,    67,    -1,    -1,    25,    -1,    -1,    -1,    -1,
      30,    31,    32,    -1,    -1,    -1,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    92,    93,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   243,    -1,   245,
      -1,    -1,   248,    -1,    -1,   130,   131,    -1,     3,     4,
       5,    -1,    -1,     8,     9,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,   243,    -1,   245,    -1,    -1,   248,
      -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,
      -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,    -1,   220,   221,    92,    -1,    -1,
      -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,    -1,
      -1,    -1,    -1,   238,    -1,    -1,   111,    -1,   113,    -1,
      -1,   246,   247,   248,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   130,    -1,     3,     4,     5,
      -1,    -1,     8,     9,    10,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    -1,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,
     185,   186,   187,   188,   189,   190,   251,   192,   193,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,
      -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,    -1,   220,   221,    93,    -1,    -1,
      -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,    -1,
      -1,    -1,    -1,   238,    -1,    -1,   112,    -1,   114,    -1,
      -1,   246,   247,   248,    -1,     3,     4,     5,    -1,    -1,
       8,     9,    10,    -1,    -1,   131,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    30,    31,    32,    -1,    -1,    -1,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,
     206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,   101,   220,   221,    -1,    -1,    -1,    -1,
     226,   227,   228,    -1,    -1,   231,   232,    -1,     3,     4,
       5,    -1,   238,     8,     9,    10,    -1,    -1,    -1,    -1,
     246,   247,   248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,    -1,
      -1,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   179,    -1,    -1,   182,   183,    -1,   185,   186,   187,
     188,   189,   190,    -1,   192,   193,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,
      -1,   209,   210,   211,   212,    -1,   101,   215,   216,   217,
     218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,   227,
     228,    -1,    -1,   231,   232,    -1,     3,     4,     5,    -1,
     238,     8,     9,    10,    -1,   243,    -1,   245,   246,   247,
     248,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      47,    -1,    -1,    -1,    -1,    -1,    53,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,
      -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,
      -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,    -1,
       3,     4,     5,   238,    -1,     8,     9,    10,   243,    -1,
     245,   246,   247,   248,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,   186,
     187,   188,   189,   190,    -1,   192,   193,    80,    -1,    -1,
      -1,    -1,    -1,    -1,   201,   202,    -1,    90,    -1,   206,
      -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,   216,
     217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,
     227,   228,    -1,    -1,   231,   232,    -1,     3,     4,     5,
      -1,   238,     8,     9,    10,    -1,    -1,    -1,    -1,   246,
     247,   248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    -1,    -1,    -1,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,    -1,
      -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,
      -1,     3,     4,     5,    -1,   238,     8,     9,    10,    -1,
      -1,    -1,    -1,   246,   247,   248,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,
      32,    -1,    -1,    -1,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,
     206,    -1,   208,   209,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,
     226,   227,   228,    -1,    -1,   231,   232,    -1,     3,     4,
       5,    -1,   238,     8,     9,    10,    -1,    -1,    -1,    -1,
     246,   247,   248,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,
     182,   183,    -1,   185,   186,   187,   188,   189,   190,    -1,
     192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,
     202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,    -1,   220,   221,
      -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,
     232,    -1,     3,     4,     5,    -1,   238,     8,     9,    10,
      -1,    -1,   244,    -1,   246,   247,   248,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    -1,    47,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,
      -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,
      -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,     3,
       4,     5,    -1,   238,     8,     9,    10,   242,    -1,    -1,
      -1,   246,   247,   248,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,
      -1,    -1,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,   179,    -1,
      -1,   182,   183,    -1,   185,   186,   187,   188,   189,   190,
      -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,    -1,   220,
     221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,
     231,   232,    -1,     3,     4,     5,    -1,   238,     8,     9,
      10,    -1,    -1,    -1,    -1,   246,   247,   248,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      30,    31,    32,    -1,    -1,    -1,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,
      -1,   185,   186,   187,   188,   189,   190,    -1,   192,   193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,
      -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,    -1,   220,   221,    -1,    -1,
      -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,
       3,     4,     5,    -1,   238,     8,     9,    10,   242,    -1,
      -1,    -1,   246,   247,   248,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,
      -1,    -1,   182,   183,    -1,   185,   186,   187,   188,   189,
     190,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,    -1,
     220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,
      -1,   231,   232,    -1,     3,     4,     5,    -1,   238,     8,
       9,    10,    -1,    -1,    -1,    -1,   246,   247,   248,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,    -1,    -1,
       8,     9,    10,    -1,    -1,    -1,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,    -1,
      -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,
      -1,    -1,     3,     4,     5,   238,    -1,     8,     9,    10,
      -1,    -1,    -1,   246,   247,   248,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,    -1,    50,
       8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     179,    -1,    -1,   182,   183,    -1,   185,   186,   187,   188,
     189,   190,    -1,   192,   193,    -1,    -1,    -1,    -1,    80,
      -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,    90,
     209,   210,   211,   212,    -1,    -1,   215,   216,   217,   218,
      -1,   220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,
      -1,   179,   231,   232,   182,   183,    -1,   185,   186,   187,
     188,   189,   190,    -1,   192,   193,    -1,   246,   247,   248,
       3,     4,     5,   201,   202,     8,     9,    10,   206,    -1,
      -1,   209,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,   227,
     228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,
     248,   182,   183,    -1,   185,   186,   187,   188,   189,   190,
      -1,   192,   193,    -1,    -1,    -1,    -1,     3,     4,     5,
     201,   202,     8,     9,    10,   206,    -1,    -1,   209,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,    -1,   220,
     221,   179,    -1,    -1,   182,   183,    -1,   185,   186,   187,
     188,   189,   190,    -1,   192,   193,    -1,   238,    -1,    -1,
      -1,    -1,    -1,   201,   202,    -1,    -1,   248,   206,    -1,
     208,   209,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,    -1,   220,   221,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,   208,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   179,    -1,   248,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,
     206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,    -1,   220,   221,     1,    -1,     3,    11,
      12,     6,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,   238,    25,    -1,    -1,    28,    29,    30,    31,
      32,    26,   248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    36,    37,    38,    39,    40,    41,    42,    -1,    -1,
      45,    -1,    -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,
      65,    -1,    -1,    68,    -1,    70,    71,    72,    73,    -1,
      -1,    -1,    -1,    78,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,    -1,    -1,   102,   103,   104,
     105,   106,    -1,    -1,   109,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,    -1,    -1,   129,    -1,    -1,    -1,   133,   134,
     135,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     145,    -1,    -1,    -1,    -1,   150,   151,   152,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,   173,   174,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,   184,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,   241,    -1,    25,   251,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,   239,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    11,
      12,   242,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    11,    12,   242,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    11,    12,
     242,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    11,    12,   242,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    11,    12,   242,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    11,    12,   242,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    11,    12,
     242,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,
     242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    11,    12,   242,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    11,    12,   242,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    11,    12,   242,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,
     242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    11,    12,   242,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    11,    12,   242,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    11,    12,   242,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    11,    12,   242,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    11,    12,   242,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    11,    12,   242,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,   241,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
     241,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,   241,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    11,    12,   241,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      11,    12,   241,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    11,    12,   241,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
     241,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,   241,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,   241,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    11,    12,
     241,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    11,    12,   241,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,   241,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    11,    12,
     241,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,   241,    -1,    -1,    -1,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,   239,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,   239,    -1,    -1,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,   239,    -1,    -1,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   224,   225,    -1,   239,    -1,
      -1,    -1,   231,    -1,   233,   224,   235,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
     239,    -1,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
       3,    -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    26,    -1,    -1,   239,    -1,    -1,    -1,
      -1,    -1,    35,    36,    37,    -1,    39,    40,    41,    42,
      -1,    -1,    45,    -1,    -1,    48,    -1,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    -1,
      -1,    -1,    65,    -1,    -1,    68,    -1,    70,    71,    72,
      73,    -1,    -1,    -1,    -1,    78,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,    -1,    -1,   102,
     103,   104,   105,   106,    -1,    -1,   109,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,    -1,   129,    -1,    -1,    -1,
     133,   134,   135,   136,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   145,    -1,    -1,    -1,    -1,   150,   151,   152,
      -1,    -1,    -1,    -1,     1,    -1,     3,    -1,    -1,     6,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     173,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    26,
      -1,   184,    -1,    -1,    -1,    -1,    -1,    -1,    35,    36,
      37,    -1,    39,    40,    41,    42,    -1,    -1,    45,    -1,
      -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    -1,
      -1,    68,   225,    70,    71,    72,    73,    -1,    -1,    -1,
      -1,    78,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,    -1,    -1,   102,   103,   104,   105,   106,
      -1,    -1,   109,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
      -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,   136,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,
      -1,    -1,    -1,   150,   151,   152,    -1,    -1,    -1,    -1,
      -1,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,   173,   174,    28,    29,
      30,    31,    32,    -1,    -1,    11,    12,   184,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,   225,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
     200,    -1,    11,    12,   204,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,   224,   225,    28,    29,
      30,    31,    32,   231,    -1,   233,    -1,   235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   224,   225,    -1,    -1,    -1,    -1,    -1,
     231,    -1,   233,    -1,   235,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     224,    -1,    -1,    -1,    -1,    -1,    -1,   231,   232,   233,
      -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,     1,    -1,     3,    -1,    -1,     6,
      -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    26,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    36,
      37,    -1,    39,    40,    41,    42,    -1,    -1,    45,    -1,
      -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    -1,
      -1,    68,    -1,    70,    71,    72,    73,    -1,    -1,    -1,
      -1,    78,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,    -1,    -1,   102,   103,   104,   105,   106,
      -1,    -1,   109,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
      -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,   136,
      -1,    -1,    -1,    -1,     1,    -1,     3,    -1,   145,     6,
      -1,    -1,   149,   150,   151,   152,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    26,
      -1,    -1,    -1,    -1,    -1,    -1,   173,   174,    35,    36,
      37,    38,    39,    40,    41,    42,    -1,   184,    45,    -1,
      -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    -1,
      -1,    68,    -1,    70,    71,    72,    73,    -1,    -1,    -1,
      -1,    78,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,    -1,    -1,   102,   103,   104,   105,   106,
      -1,    -1,   109,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
      -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,   136,
      -1,    -1,    -1,    -1,     1,    -1,     3,    -1,   145,     6,
      -1,    -1,   149,   150,   151,   152,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    26,
      -1,    -1,    -1,    -1,    -1,    -1,   173,   174,    35,    36,
      37,    -1,    39,    40,    41,    42,    -1,   184,    45,    -1,
      -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    -1,
      -1,    68,    -1,    70,    71,    72,    73,    -1,    -1,    -1,
      -1,    78,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,    -1,    -1,   102,   103,   104,   105,   106,
      -1,    -1,   109,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
      -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,   136,
      -1,    -1,    -1,    -1,     1,    -1,     3,    -1,   145,     6,
      -1,    -1,    -1,   150,   151,   152,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    26,
      -1,    -1,    -1,    -1,    -1,    -1,   173,   174,    35,    36,
      37,    -1,    39,    40,    41,    42,    -1,   184,    45,    -1,
      -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    -1,
      -1,    68,    -1,    70,    71,    72,    73,    -1,    -1,    -1,
      -1,    78,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,    -1,    -1,   102,   103,   104,   105,   106,
      -1,    -1,   109,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
      -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,   136,
      -1,    -1,    -1,    -1,     1,    -1,     3,    -1,   145,     6,
      -1,    -1,    -1,   150,   151,   152,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    26,
      -1,    -1,    -1,    -1,    -1,    -1,   173,   174,    35,    36,
      37,    38,    39,    40,    41,    42,    -1,   184,    45,    -1,
      -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    -1,
      -1,    68,    -1,    70,    71,    72,    73,    -1,    -1,    -1,
      -1,    78,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,    -1,    -1,   102,   103,   104,   105,   106,
      -1,    -1,   109,    -1,     3,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
      -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,   136,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    36,   145,    -1,
      39,    40,    41,   150,   151,   152,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   173,   174,    -1,    -1,
      -1,    70,    -1,    -1,    73,    -1,    -1,   184,    -1,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    -1,    -1,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    96,    97,    98,
      99,    -1,    -1,   102,   103,   104,   105,   106,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
     129,    -1,    -1,    -1,   133,   134,   135,   136,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,
      -1,    -1,    -1,    -1,    -1,   231,    -1,   233,    -1,   235,
      -1,    -1,    -1,    -1,   173,   174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   184,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    26,    91,   145,   164,   195,   213,   272,   273,   276,
     294,   296,   300,   304,   341,   464,     3,    27,   277,   278,
       3,   238,     3,     3,     3,     0,   294,    76,    78,   344,
     240,    27,   239,   238,     3,   241,   241,   295,   295,     3,
       3,     4,     5,     8,     9,    10,    30,    31,    32,   179,
     182,   183,   185,   186,   187,   188,   189,   190,   192,   193,
     201,   202,   206,   209,   210,   211,   212,   215,   216,   217,
     218,   220,   221,   226,   227,   228,   231,   232,   238,   246,
     247,   248,   274,   319,   323,   330,   278,     3,    87,   460,
     239,   165,   297,   301,   342,   238,     8,   323,   323,   323,
     238,   238,   238,   238,   238,   238,   238,   238,   238,   238,
     238,   238,   238,   238,   238,   238,   238,   238,   238,   238,
     238,   238,   238,   238,   323,     1,   323,   323,   323,   323,
     319,   320,   226,   227,   228,   323,     1,   323,   319,   322,
      11,    12,    14,    15,    16,    17,    18,    19,    20,    25,
      28,    29,    30,    31,    32,   224,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   238,   244,   250,    99,
     461,   239,   242,     5,   305,   197,   203,   214,   298,   299,
     180,   181,   194,   207,   222,   302,   303,   243,   347,   319,
     322,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   225,   242,   323,   323,   323,
     248,   239,   249,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   322,
       3,   319,     3,     3,   241,   239,     3,   241,   309,   191,
     196,     3,     3,   198,   299,   240,   240,   240,   240,   240,
     199,   303,   238,   238,   346,   242,   242,   242,   242,   242,
     242,   242,   239,   242,   242,   242,   242,   242,   242,   239,
     242,   242,   239,   239,   239,   242,   242,   242,   242,   242,
     319,   322,   319,   225,   242,    23,    24,   225,   251,   240,
     462,    72,    87,    99,   458,   459,     5,   244,   306,   241,
     241,   241,   241,   319,     3,     3,     3,     5,    88,   348,
       3,   244,   248,   276,   333,   334,   335,   399,   400,   401,
      26,   345,   319,   319,   319,   319,   319,   225,   249,   319,
     319,   319,   319,   319,   239,     3,   331,     3,     3,    87,
      70,   453,   454,   458,   242,     3,    47,   163,   166,   169,
     307,   241,   241,   241,   241,   241,     3,   382,   239,   242,
     250,     3,   401,   402,    71,    72,    87,   239,   242,   239,
     241,   242,     3,   241,   242,   242,   242,   242,   242,   319,
       1,   249,   251,   251,   251,    72,   463,   239,   241,   241,
     241,     3,     3,   115,   446,   170,   309,   330,   240,    88,
     382,     1,   319,   238,   239,   249,   113,   114,   121,   122,
     123,   124,   125,   129,   133,   134,   173,   174,   336,   373,
     336,    99,   336,   374,   400,     3,   335,    73,   343,   249,
       3,   239,   242,     3,   241,   240,   447,    56,   310,   170,
     172,   170,   172,   319,   382,   251,   225,   251,   248,   401,
     401,   157,   337,   337,   337,   337,     3,     1,     6,    37,
      42,    48,    60,    61,    65,    68,    71,    72,    78,    87,
      88,    94,    95,   109,   116,   126,   145,   150,   151,   152,
     276,   279,   349,   360,   365,   366,   405,    72,   241,   274,
     224,   231,   233,   235,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   448,   449,   450,   451,   452,   455,   456,
       3,   241,   310,   309,   310,   309,   200,   204,   383,   384,
     385,   387,   319,   402,   242,   250,   406,   407,   407,   407,
     407,   240,   241,   331,     1,   238,   311,   312,   238,   286,
     287,   330,   406,   331,   238,     1,   148,   359,   238,   374,
     374,     1,   374,     1,    73,    97,    98,   117,   157,   275,
     375,   381,   382,   406,     3,   238,   326,   327,   238,   327,
       1,    57,    68,    69,   110,   137,   138,   139,   140,   141,
     142,   143,   144,   153,   154,   155,   156,   159,   160,   161,
     162,   238,   417,   418,   419,   421,   423,   424,   359,   238,
     284,   285,   238,    38,   366,   331,     1,     3,    73,   117,
     157,   275,   388,   389,   395,   406,     3,    35,    36,    39,
      40,    41,    45,    70,    73,    79,    81,    82,    83,    84,
      85,    86,    89,    96,    97,    98,    99,   102,   103,   104,
     105,   106,   117,   118,   119,   120,   135,   136,   184,   328,
     329,   373,    38,   241,   349,   367,   368,   349,    55,   337,
     373,     3,   446,   241,    58,   449,   455,   452,   455,   225,
     456,   241,   225,   308,   241,   308,   319,   385,   238,   250,
     251,   249,   319,     3,     3,     3,     3,     5,   241,   240,
     241,    66,    67,    92,    93,   111,   112,   113,   114,   130,
     131,   313,   314,   243,   289,   290,   319,   239,   241,   240,
     286,   241,     3,    54,    73,    97,    98,   117,   157,   406,
     410,   319,   337,   337,   241,   337,   241,   378,   379,   406,
     380,   241,   239,   376,   238,   406,   313,   319,   321,   239,
     241,   314,   241,    57,   238,   238,   423,     3,     7,   426,
     427,   238,   238,   238,   238,   238,   238,   238,   238,     3,
     425,   425,   425,   425,   238,   238,   238,   238,     1,    80,
      90,   420,   425,    57,   417,   241,   240,   241,   240,     3,
      75,    77,   108,   407,     1,     3,   225,   366,   149,   241,
     241,   240,   392,   393,   406,   394,   241,   239,   390,   243,
     396,     1,     4,    33,    37,    38,    42,    43,    44,    46,
      49,    61,    62,    63,    64,    68,   100,   101,   128,   132,
     243,   245,   248,   288,   315,   330,   338,   433,   433,     1,
       3,   411,   412,     1,     3,   413,   414,     1,   414,     1,
      97,   146,   147,   371,   372,     1,   412,     3,   318,   438,
     238,   289,   311,   327,   238,   289,   327,   372,   225,   366,
      51,   407,   337,    56,   225,   225,   232,   252,   253,   254,
     456,   457,   164,   241,   241,   208,   231,   232,   319,   386,
     386,   242,   225,   240,   241,   319,   239,   239,   239,   239,
       3,     9,    10,   238,   293,   330,   338,   339,   340,   242,
     286,   319,   240,   406,     3,   242,   407,   407,   407,   381,
     381,   377,   381,   382,   381,     1,   244,   321,   403,   404,
     238,   242,   239,   242,   326,   242,   319,   425,   241,   240,
     240,   239,   241,    50,    80,    90,   323,   429,   429,   429,
     429,   429,   429,   429,   429,   250,   239,   241,   241,   241,
     241,   429,   429,   429,   429,   242,   425,   231,   232,   428,
     238,   293,   238,   293,     1,   238,   241,   242,   242,   242,
     290,   242,   239,     3,    52,   319,   395,   395,   391,   395,
     388,   395,     1,     9,   238,     1,   327,    11,   240,   241,
     238,   241,   330,   338,     1,    52,   225,   433,   436,   238,
     238,   238,   338,   330,   238,   338,   433,    74,   225,   436,
     238,   338,   238,   238,   238,   238,   293,   233,   238,   330,
     322,   241,   433,   437,   276,   238,   241,    11,   240,   241,
     240,   250,   408,   409,   239,   241,   241,   240,   408,   239,
     241,   241,   241,   241,   337,   241,   241,   238,    22,   327,
     289,   327,   241,   327,   241,   337,     3,    52,   356,   290,
     407,   252,   253,   254,   225,   241,   208,   208,   225,   225,
     319,   319,    27,   241,   314,   313,    67,   314,    66,   313,
     292,   319,   240,   239,   241,   357,   319,     1,   241,   354,
     331,   331,     3,   332,   381,   242,     3,   242,   239,   242,
       1,   321,   404,   327,   319,   327,   242,   428,   319,   238,
     319,   426,   250,   319,   323,   319,   323,   223,   239,   239,
     239,   239,   239,   239,   239,   239,   323,     3,   239,   239,
     239,   239,   428,    13,    21,   291,   292,     1,   291,    59,
     242,   351,   350,   331,   241,     5,   358,   149,   395,   244,
     321,   397,   398,   241,   241,   319,   319,   321,   241,   240,
      52,     3,    52,   433,   319,   319,   319,   241,   241,     1,
     338,   240,     3,    74,     1,   319,   241,   319,   319,     1,
     319,   292,   276,     1,    80,    90,   233,   316,   317,   319,
     249,   437,   242,   322,   101,   245,   288,   315,   319,   101,
     288,   315,   319,   319,   319,   250,   411,   319,   413,   406,
     412,     3,   319,   241,   327,   241,   241,   311,   407,   366,
     367,     1,   331,   331,   457,   386,   386,   251,   242,   242,
     242,   242,   242,   242,   239,   242,   225,   319,   339,    47,
     322,   361,   362,   241,    54,   353,   238,   241,   241,   240,
     239,   241,   238,   403,   242,   242,   242,   241,   241,   419,
     423,    13,    21,   225,   319,    34,   430,   223,   223,   319,
     429,   429,   292,   429,   429,   429,   429,   292,   251,   250,
     429,   429,   429,   429,    13,    21,   238,   425,   238,   425,
     239,   242,   242,   242,   241,    71,    72,    87,   444,   445,
      71,    72,    87,   276,   279,   439,   441,   442,   443,   241,
     239,   366,     3,   242,   239,   242,   241,   241,   242,   319,
      52,   434,   242,   242,   242,   242,   240,   319,    74,   435,
     242,   242,   242,   242,   242,   242,   242,   437,   242,   319,
     319,   242,    86,   239,   242,   241,   242,   238,   238,   319,
     319,   241,   238,   319,   319,   241,   225,   319,   412,   241,
     239,   242,   241,   241,     3,   369,   370,   290,    52,   241,
     241,   241,   241,   242,   251,   242,   251,   292,   319,   225,
     225,    53,   362,   319,   279,   324,   325,   441,   445,   319,
       3,     1,   242,   319,   241,   241,   319,   239,   239,   251,
     319,   319,   239,   239,     3,   239,   431,   432,   239,   239,
     239,   239,   239,   242,   323,   239,   239,   239,   239,   238,
     238,   425,   242,   425,   242,   292,   352,    73,    99,   117,
     275,   440,    73,   117,   275,   440,    73,   117,   275,   440,
     239,   241,   242,    73,   117,   275,   440,    73,   117,   275,
     440,    73,   117,   275,   440,   439,   437,     5,    52,   238,
     397,   241,   241,   279,   280,   281,     1,    47,   282,   283,
     322,     1,   283,     1,   283,   433,   319,   241,   281,   437,
     437,   433,   437,   433,   433,   276,   317,   317,   241,   319,
     241,   241,   319,   241,   241,   319,   225,   241,     3,   240,
     239,   241,     3,   370,   415,   416,   239,   242,   225,   364,
     363,   241,   325,   433,   242,   240,   242,   242,   225,   319,
      34,   323,   292,   292,   330,   242,   239,   292,   292,   292,
     292,   319,   241,   251,   292,   292,   292,   292,   425,   425,
      23,    24,   225,   422,   422,   281,     3,     3,     3,   337,
       3,     3,     3,   337,     3,     3,     3,   337,     3,   444,
     241,   331,   331,   331,   337,   331,   331,   331,   337,   331,
     331,   331,   337,    59,   242,   149,   242,   319,   279,   436,
      53,   225,   225,   437,     1,    53,   282,   225,    53,    53,
      53,    53,   241,   436,    51,    51,   437,   242,   242,   251,
     319,   242,   319,   369,   408,   241,   239,   241,   292,   319,
     368,   368,     3,    54,   241,   319,   319,   242,   223,   431,
     239,   241,   330,   431,   431,   239,   431,   431,   239,   239,
     431,   431,   422,   422,   319,   319,   437,   407,   407,   407,
     281,   241,   241,   241,   407,   241,   241,   241,   407,   241,
     241,   241,   407,   241,   242,    52,   437,   437,   437,     1,
     319,    74,   437,   437,   315,   315,   251,     3,   415,   242,
     240,   281,   319,   242,   292,   242,   242,   292,   242,   242,
     292,   292,   242,   242,   319,   319,   242,   242,    59,     3,
       3,     3,   437,   331,   331,   331,   241,   241,   319,   319,
     319,   433,   241,   431,   241,   241,   431,   241,   241,   431,
     431,   241,   241,   242,   242,   242,   242,    59,   241,   241,
     241,   338,     1,   338,   241,   241,   242,    54,   242,   242,
     242,   242,   242,   242,   240,   242,   240,   355,   241,   241,
     241,   241,   319,   433,   319,   367,   242,   242,   433,   433
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   271,   272,   272,   273,   273,   274,   274,   274,   275,
     275,   276,   276,   276,   277,   277,   278,   278,   279,   279,
     279,   279,   279,   279,   279,   279,   279,   279,   279,   279,
     279,   279,   279,   279,   280,   280,   281,   281,   282,   282,
     282,   282,   283,   283,   284,   284,   284,   285,   285,   286,
     287,   287,   287,   288,   288,   289,   289,   289,   289,   290,
     290,   291,   291,   292,   292,   293,   293,   293,   294,   294,
     294,   294,   294,   294,   295,   295,   297,   296,   298,   298,
     299,   299,   299,   299,   301,   300,   302,   302,   303,   303,
     303,   303,   303,   304,   305,   305,   306,   306,   307,   307,
     307,   307,   307,   308,   308,   309,   309,   310,   310,   311,
     311,   311,   311,   311,   311,   312,   312,   313,   313,   313,
     313,   314,   314,   314,   314,   315,   315,   315,   316,   316,
     316,   317,   317,   317,   318,   318,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   320,   320,
     321,   321,   321,   321,   322,   322,   323,   323,   323,   323,
     323,   323,   323,   323,   323,   323,   323,   323,   323,   323,
     323,   323,   323,   323,   323,   323,   323,   323,   323,   323,
     323,   323,   323,   323,   323,   323,   323,   323,   323,   323,
     323,   324,   324,   325,   325,   326,   326,   326,   326,   326,
     326,   326,   326,   327,   327,   328,   328,   328,   328,   328,
     328,   328,   328,   328,   328,   328,   328,   329,   329,   329,
     329,   329,   329,   329,   329,   329,   329,   329,   329,   330,
     330,   330,   330,   330,   330,   331,   331,   332,   332,   332,
     332,   333,   333,   334,   334,   334,   334,   334,   335,   335,
     335,   335,   335,   336,   336,   337,   337,   338,   338,   339,
     340,   340,   342,   343,   341,   344,   344,   345,   345,   346,
     346,   346,   347,   347,   348,   348,   348,   349,   349,   349,
     349,   349,   349,   349,   349,   349,   349,   349,   349,   349,
     349,   349,   349,   349,   349,   349,   349,   349,   349,   349,
     349,   349,   349,   349,   349,   349,   350,   349,   351,   349,
     352,   349,   349,   353,   349,   354,   349,   349,   349,   349,
     355,   349,   356,   349,   349,   357,   349,   349,   358,   349,
     349,   349,   349,   349,   349,   349,   349,   349,   349,   349,
     359,   359,   360,   361,   361,   363,   362,   364,   362,   365,
     365,   366,   366,   367,   367,   367,   368,   368,   369,   370,
     370,   371,   371,   371,   372,   372,   373,   373,   373,   373,
     373,   373,   373,   373,   373,   373,   373,   373,   374,   375,
     376,   375,   377,   375,   378,   375,   379,   375,   380,   375,
     381,   381,   382,   383,   383,   384,   384,   385,   385,   385,
     385,   385,   386,   386,   386,   386,   387,   387,   388,   389,
     390,   389,   391,   389,   392,   389,   393,   389,   394,   389,
     395,   395,   396,   396,   396,   396,   396,   397,   397,   398,
     398,   399,   399,   399,   399,   400,   400,   401,   401,   401,
     401,   402,   402,   403,   403,   403,   404,   404,   405,   405,
     405,   406,   407,   407,   408,   408,   409,   409,   410,   410,
     410,   410,   410,   410,   410,   411,   411,   412,   412,   413,
     413,   414,   414,   415,   416,   416,   417,   417,   417,   417,
     417,   417,   417,   417,   417,   417,   417,   417,   417,   417,
     417,   417,   417,   417,   417,   417,   417,   417,   417,   418,
     418,   419,   419,   420,   420,   421,   421,   421,   421,   422,
     422,   422,   423,   423,   423,   424,   424,   424,   425,   425,
     425,   425,   426,   426,   426,   426,   427,   427,   428,   428,
     428,   429,   429,   429,   429,   429,   429,   429,   429,   430,
     430,   431,   431,   432,   432,   432,   432,   432,   433,   433,
     433,   433,   433,   434,   433,   433,   433,   433,   435,   433,
     433,   433,   433,   433,   433,   433,   433,   433,   433,   433,
     433,   433,   433,   433,   433,   433,   433,   433,   433,   433,
     433,   433,   433,   433,   433,   433,   433,   433,   433,   433,
     433,   433,   433,   433,   433,   433,   433,   433,   433,   433,
     433,   433,   433,   433,   436,   436,   437,   437,   438,   439,
     439,   440,   440,   441,   441,   441,   441,   441,   441,   441,
     441,   441,   441,   441,   441,   442,   442,   443,   443,   444,
     444,   444,   444,   444,   444,   444,   444,   444,   444,   444,
     444,   445,   445,   445,   445,   445,   447,   446,   448,   448,
     449,   450,   450,   451,   451,   452,   453,   454,   454,   455,
     455,   456,   456,   456,   456,   456,   456,   456,   456,   456,
     456,   456,   456,   456,   456,   456,   456,   456,   456,   456,
     456,   456,   456,   456,   457,   457,   457,   457,   458,   458,
     458,   458,   459,   459,   460,   460,   461,   461,   462,   462,
     463,   463,   464,   464
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     1,     2,     1,     1,     2,     1,
       1,     3,     2,     0,     3,     1,     1,     3,     7,     6,
       4,     4,     4,     4,     3,     3,     3,     4,     4,     4,
       4,     4,     3,     3,     1,     2,     1,     0,     3,     3,
       2,     3,     2,     1,     3,     3,     3,     1,     0,     3,
       1,     2,     3,     2,     4,     2,     4,     6,     8,     1,
       0,     1,     3,     1,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     8,     1,     0,     0,     6,     2,     1,
       3,     3,     3,     3,     0,     6,     2,     1,     4,     4,
       4,     4,     4,     8,     0,     2,     0,     2,     4,     5,
       6,     5,     6,     0,     2,     1,     3,     0,     2,     5,
       5,     5,     5,     5,     5,     1,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     4,     4,     1,     3,
       3,     2,     2,     1,     6,     4,     1,     2,     2,     2,
       2,     2,     2,     2,     3,     3,     3,     2,     2,     2,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     5,     1,     5,
       3,     1,     0,     2,     3,     1,     1,     1,     1,     1,
       1,     4,     4,     4,     4,     4,     4,     4,     4,     6,
       4,     4,     4,     4,     4,     6,     4,     4,     6,     4,
       4,     4,     4,     4,     4,     6,     6,     3,     3,     6,
       7,     1,     2,     1,     1,     4,     5,     3,     2,     4,
       5,     4,     5,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     4,     6,     6,     6,     1,     3,     1,     3,     3,
       5,     1,     3,     1,     3,     3,     2,     2,     6,     6,
       6,     6,     8,     1,     0,     1,     0,     1,     3,     3,
       3,     1,     0,     0,    11,     1,     1,     8,     0,     3,
       3,     0,     0,     4,     2,     3,     4,     8,     8,     7,
       6,     6,     6,     6,     6,     6,     6,     3,     1,     3,
       4,     5,     5,     6,     4,     5,     3,     3,     6,     6,
       5,     5,     5,     3,     3,     3,     0,     8,     0,    11,
       0,    10,     5,     0,     9,     0,    12,     6,     3,     3,
       0,    14,     0,     5,     2,     0,     7,     5,     0,     8,
       2,     3,     3,     3,     2,     5,     3,     3,     9,     5,
       1,     0,     4,     2,     1,     0,     4,     0,     4,     2,
       1,     1,     0,     1,     3,     5,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     3,     0,     4,     0,     3,     0,     3,     0,     3,
       1,     3,     4,     1,     0,     2,     1,     6,     6,     6,
       6,     2,     1,     1,     2,     2,     1,     1,     3,     1,
       0,     3,     0,     4,     0,     3,     0,     3,     0,     3,
       1,     3,     4,     4,     2,     2,     0,     5,     4,     1,
       3,     1,     5,     3,     7,     1,     0,     1,     6,     4,
       4,     1,     3,     5,     5,     4,     3,     1,     1,     1,
       1,     5,     1,     0,     0,     1,     5,     6,     1,     2,
       1,     1,     1,     1,     0,     2,     3,     1,     3,     2,
       3,     1,     3,     2,     1,     3,     3,     2,     2,     6,
       6,     3,    12,    10,    12,     8,    10,    12,    10,    10,
      12,    10,    10,    10,     7,     3,     3,     3,     3,     1,
       2,     5,     3,     1,     1,    10,    11,    10,    11,     1,
       1,     1,     5,     3,     5,     6,     6,     3,     1,     4,
       3,     6,     3,     7,     3,     7,     1,     3,     1,     1,
       0,     2,     2,     4,     4,     5,     7,     3,     1,     3,
       1,     0,     1,     1,     2,     2,     3,     1,     5,     3,
       5,     3,     3,     0,     7,     2,     4,     3,     0,     7,
       2,     4,     3,     3,     2,     3,     5,     6,     6,     6,
       6,     6,     6,     5,     7,     5,     7,    13,    11,    13,
       5,     5,     5,     2,     3,     4,     6,     4,     4,     4,
       4,     5,     5,     5,     9,     5,     9,     5,     5,     2,
       5,     4,     2,     2,     2,     1,     1,     1,     4,     1,
       1,     1,     0,     6,     6,     6,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     2,     1,     1,     0,     5,
       5,     5,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     1,     3,     2,     2,     0,     4,     1,     1,
       4,     1,     2,     1,     2,     6,     5,     1,     0,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     4,     1,     2,     1,     3,     1,     0,     2,     0,
       2,     4,    10,    13
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

__attribute__((__unused__))
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:
#line 401 "./parse.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[0].number); based_size = 0;}
#line 4959 "parse.cc" /* yacc.c:1646  */
    break;

  case 7:
#line 403 "./parse.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[0].number); based_size = 0;}
#line 4965 "parse.cc" /* yacc.c:1646  */
    break;

  case 8:
#line 405 "./parse.y" /* yacc.c:1646  */
    { (yyval.number) = pform_verinum_with_size((yyvsp[-1].number),(yyvsp[0].number), (yylsp[0]).text, (yylsp[0]).first_line);
	       based_size = 0; }
#line 4972 "parse.cc" /* yacc.c:1646  */
    break;

  case 11:
#line 420 "./parse.y" /* yacc.c:1646  */
    { (yyval.named_pexprs) = (yyvsp[-1].named_pexprs); }
#line 4978 "parse.cc" /* yacc.c:1646  */
    break;

  case 12:
#line 421 "./parse.y" /* yacc.c:1646  */
    { (yyval.named_pexprs) = 0; }
#line 4984 "parse.cc" /* yacc.c:1646  */
    break;

  case 13:
#line 422 "./parse.y" /* yacc.c:1646  */
    { (yyval.named_pexprs) = 0; }
#line 4990 "parse.cc" /* yacc.c:1646  */
    break;

  case 14:
#line 427 "./parse.y" /* yacc.c:1646  */
    { svector<named_pexpr_t*>*tmp =
			new svector<named_pexpr_t*>(*(yyvsp[-2].named_pexprs),(yyvsp[0].named_pexpr));
		  delete (yyvsp[-2].named_pexprs);
		  (yyval.named_pexprs) = tmp;
		}
#line 5000 "parse.cc" /* yacc.c:1646  */
    break;

  case 15:
#line 433 "./parse.y" /* yacc.c:1646  */
    { svector<named_pexpr_t*>*tmp = new svector<named_pexpr_t*>(1);
		  (*tmp)[0] = (yyvsp[0].named_pexpr);
		  (yyval.named_pexprs) = tmp;
		}
#line 5009 "parse.cc" /* yacc.c:1646  */
    break;

  case 16:
#line 442 "./parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[0].text));
		  tmp->parm = 0;
		  delete[](yyvsp[0].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 5020 "parse.cc" /* yacc.c:1646  */
    break;

  case 17:
#line 449 "./parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[0].expr);
		  named_pexpr_t*tmp2 = new named_pexpr_t;
		  tmp2->name = lex_strings.make((yyvsp[-2].text));
		  tmp2->parm = tmp;
		  delete[](yyvsp[-2].text);
		  (yyval.named_pexpr) = tmp2;
		}
#line 5032 "parse.cc" /* yacc.c:1646  */
    break;

  case 18:
#line 469 "./parse.y" /* yacc.c:1646  */
    { ivl_variable_type_t dtype = (yyvsp[-4].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_set_net_range((yyvsp[-1].perm_strings), (yyvsp[-2].exprs), (yyvsp[-3].flag), dtype);
		  if ((yyvsp[-6].named_pexprs)) delete (yyvsp[-6].named_pexprs);
		}
#line 5043 "parse.cc" /* yacc.c:1646  */
    break;

  case 19:
#line 482 "./parse.y" /* yacc.c:1646  */
    { ivl_variable_type_t dtype = (yyvsp[-3].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_set_net_range((yyvsp[-1].perm_strings), 0, (yyvsp[-2].flag), dtype);
		  if ((yyvsp[-5].named_pexprs)) delete (yyvsp[-5].named_pexprs);
		}
#line 5054 "parse.cc" /* yacc.c:1646  */
    break;

  case 20:
#line 494 "./parse.y" /* yacc.c:1646  */
    { pform_set_reg_integer((yyvsp[-1].perm_strings));
		  if ((yyvsp[-3].named_pexprs)) delete (yyvsp[-3].named_pexprs);
		}
#line 5062 "parse.cc" /* yacc.c:1646  */
    break;

  case 21:
#line 499 "./parse.y" /* yacc.c:1646  */
    { pform_set_reg_time((yyvsp[-1].perm_strings));
		}
#line 5069 "parse.cc" /* yacc.c:1646  */
    break;

  case 22:
#line 508 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings); }
#line 5075 "parse.cc" /* yacc.c:1646  */
    break;

  case 23:
#line 510 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings); }
#line 5081 "parse.cc" /* yacc.c:1646  */
    break;

  case 24:
#line 513 "./parse.y" /* yacc.c:1646  */
    { pform_make_events((yyvsp[-1].perm_strings), (yylsp[-2]).text, (yylsp[-2]).first_line);
		}
#line 5088 "parse.cc" /* yacc.c:1646  */
    break;

  case 27:
#line 523 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in reg variable list.");
		  yyerrok;
		  if ((yyvsp[-3].named_pexprs)) delete (yyvsp[-3].named_pexprs);
		}
#line 5097 "parse.cc" /* yacc.c:1646  */
    break;

  case 28:
#line 528 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in integer variable list.");
		  yyerrok;
		  if ((yyvsp[-3].named_pexprs)) delete (yyvsp[-3].named_pexprs);
		}
#line 5106 "parse.cc" /* yacc.c:1646  */
    break;

  case 29:
#line 533 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in time variable list.");
		  yyerrok;
		}
#line 5114 "parse.cc" /* yacc.c:1646  */
    break;

  case 30:
#line 537 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in real variable list.");
		  yyerrok;
		}
#line 5122 "parse.cc" /* yacc.c:1646  */
    break;

  case 31:
#line 541 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in realtime variable list.");
		  yyerrok;
		}
#line 5130 "parse.cc" /* yacc.c:1646  */
    break;

  case 32:
#line 545 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in parameter list.");
		  yyerrok;
		}
#line 5138 "parse.cc" /* yacc.c:1646  */
    break;

  case 33:
#line 549 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error localparam list.");
		  yyerrok;
		}
#line 5146 "parse.cc" /* yacc.c:1646  */
    break;

  case 38:
#line 566 "./parse.y" /* yacc.c:1646  */
    { PCase::Item*tmp = new PCase::Item;
		  tmp->expr = *(yyvsp[-2].exprs);
		  tmp->stat = (yyvsp[0].statement);
		  delete (yyvsp[-2].exprs);
		  (yyval.citem) = tmp;
		}
#line 5157 "parse.cc" /* yacc.c:1646  */
    break;

  case 39:
#line 573 "./parse.y" /* yacc.c:1646  */
    { PCase::Item*tmp = new PCase::Item;
		  tmp->stat = (yyvsp[0].statement);
		  (yyval.citem) = tmp;
		}
#line 5166 "parse.cc" /* yacc.c:1646  */
    break;

  case 40:
#line 578 "./parse.y" /* yacc.c:1646  */
    { PCase::Item*tmp = new PCase::Item;
		  tmp->stat = (yyvsp[0].statement);
		  (yyval.citem) = tmp;
		}
#line 5175 "parse.cc" /* yacc.c:1646  */
    break;

  case 41:
#line 583 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: Incomprehensible case expression.");
		  yyerrok;
		}
#line 5183 "parse.cc" /* yacc.c:1646  */
    break;

  case 42:
#line 590 "./parse.y" /* yacc.c:1646  */
    { svector<PCase::Item*>*tmp;
		  tmp = new svector<PCase::Item*>(*(yyvsp[-1].citems), (yyvsp[0].citem));
		  delete (yyvsp[-1].citems);
		  (yyval.citems) = tmp;
		}
#line 5193 "parse.cc" /* yacc.c:1646  */
    break;

  case 43:
#line 596 "./parse.y" /* yacc.c:1646  */
    { svector<PCase::Item*>*tmp = new svector<PCase::Item*>(1);
		  (*tmp)[0] = (yyvsp[0].citem);
		  (yyval.citems) = tmp;
		}
#line 5202 "parse.cc" /* yacc.c:1646  */
    break;

  case 49:
#line 615 "./parse.y" /* yacc.c:1646  */
    { pform_set_defparam(*(yyvsp[-2].pform_name), (yyvsp[0].expr));
		  delete (yyvsp[-2].pform_name);
		}
#line 5210 "parse.cc" /* yacc.c:1646  */
    break;

  case 51:
#line 623 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: defparam may not include a range.");
		  delete (yyvsp[-1].exprs);
		}
#line 5218 "parse.cc" /* yacc.c:1646  */
    break;

  case 53:
#line 631 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[0].expr);
		  (yyval.exprs) = tmp;
		}
#line 5227 "parse.cc" /* yacc.c:1646  */
    break;

  case 54:
#line 636 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[-1].expr);
		  (yyval.exprs) = tmp;
		}
#line 5236 "parse.cc" /* yacc.c:1646  */
    break;

  case 55:
#line 644 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[0].expr);
		  (yyval.exprs) = tmp;
		}
#line 5245 "parse.cc" /* yacc.c:1646  */
    break;

  case 56:
#line 649 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[-1].expr);
		  (yyval.exprs) = tmp;
		}
#line 5254 "parse.cc" /* yacc.c:1646  */
    break;

  case 57:
#line 654 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(2);
		  (*tmp)[0] = (yyvsp[-3].expr);
		  (*tmp)[1] = (yyvsp[-1].expr);
		  (yyval.exprs) = tmp;
		}
#line 5264 "parse.cc" /* yacc.c:1646  */
    break;

  case 58:
#line 660 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(3);
		  (*tmp)[0] = (yyvsp[-5].expr);
		  (*tmp)[1] = (yyvsp[-3].expr);
		  (*tmp)[2] = (yyvsp[-1].expr);
		  (yyval.exprs) = tmp;
		}
#line 5275 "parse.cc" /* yacc.c:1646  */
    break;

  case 59:
#line 669 "./parse.y" /* yacc.c:1646  */
    { (yyval.exprs) = (yyvsp[0].exprs); }
#line 5281 "parse.cc" /* yacc.c:1646  */
    break;

  case 60:
#line 670 "./parse.y" /* yacc.c:1646  */
    { (yyval.exprs) = 0; }
#line 5287 "parse.cc" /* yacc.c:1646  */
    break;

  case 61:
#line 675 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
	        (*tmp)[0] = (yyvsp[0].expr);
		(yyval.exprs) = tmp;
	      }
#line 5296 "parse.cc" /* yacc.c:1646  */
    break;

  case 62:
#line 680 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[-2].exprs), (yyvsp[0].expr));
		delete (yyvsp[-2].exprs);
		(yyval.exprs) = tmp;
	      }
#line 5305 "parse.cc" /* yacc.c:1646  */
    break;

  case 63:
#line 688 "./parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[0].expr);
		  (yyval.expr) = tmp;
		}
#line 5313 "parse.cc" /* yacc.c:1646  */
    break;

  case 64:
#line 692 "./parse.y" /* yacc.c:1646  */
    { (yyval.expr) = pform_select_mtm_expr((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 5319 "parse.cc" /* yacc.c:1646  */
    break;

  case 65:
#line 698 "./parse.y" /* yacc.c:1646  */
    { verinum*tmp = (yyvsp[0].number);
		  if (tmp == 0) {
			yyerror((yylsp[0]), "internal error: delay.");
			(yyval.expr) = 0;
		  } else {
			(yyval.expr) = new PENumber(tmp);
			FILE_NAME((yyval.expr), (yylsp[0]));
		  }
		  based_size = 0;
		}
#line 5334 "parse.cc" /* yacc.c:1646  */
    break;

  case 66:
#line 709 "./parse.y" /* yacc.c:1646  */
    { verireal*tmp = (yyvsp[0].realtime);
		  if (tmp == 0) {
			yyerror((yylsp[0]), "internal error: delay.");
			(yyval.expr) = 0;
		  } else {
			(yyval.expr) = new PEFNumber(tmp);
			FILE_NAME((yyval.expr), (yylsp[0]));
		  }
		}
#line 5348 "parse.cc" /* yacc.c:1646  */
    break;

  case 67:
#line 719 "./parse.y" /* yacc.c:1646  */
    { PEIdent*tmp = new PEIdent(lex_strings.make((yyvsp[0].text)));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 5358 "parse.cc" /* yacc.c:1646  */
    break;

  case 73:
#line 733 "./parse.y" /* yacc.c:1646  */
    { perm_string tmp3 = lex_strings.make((yyvsp[-5].text));
	pform_set_type_attrib(tmp3, (yyvsp[-3].text), (yyvsp[-1].text));
	delete[] (yyvsp[-5].text);
	delete[] (yyvsp[-3].text);
      }
#line 5368 "parse.cc" /* yacc.c:1646  */
    break;

  case 76:
#line 748 "./parse.y" /* yacc.c:1646  */
    { pform_start_discipline((yyvsp[-1].text)); }
#line 5374 "parse.cc" /* yacc.c:1646  */
    break;

  case 77:
#line 750 "./parse.y" /* yacc.c:1646  */
    { pform_end_discipline((yylsp[-5])); delete[] (yyvsp[-4].text); }
#line 5380 "parse.cc" /* yacc.c:1646  */
    break;

  case 80:
#line 760 "./parse.y" /* yacc.c:1646  */
    { pform_discipline_domain((yylsp[-2]), IVL_DIS_DISCRETE); }
#line 5386 "parse.cc" /* yacc.c:1646  */
    break;

  case 81:
#line 762 "./parse.y" /* yacc.c:1646  */
    { pform_discipline_domain((yylsp[-2]), IVL_DIS_CONTINUOUS); }
#line 5392 "parse.cc" /* yacc.c:1646  */
    break;

  case 82:
#line 764 "./parse.y" /* yacc.c:1646  */
    { pform_discipline_potential((yylsp[-2]), (yyvsp[-1].text)); delete[] (yyvsp[-1].text); }
#line 5398 "parse.cc" /* yacc.c:1646  */
    break;

  case 83:
#line 766 "./parse.y" /* yacc.c:1646  */
    { pform_discipline_flow((yylsp[-2]), (yyvsp[-1].text)); delete[] (yyvsp[-1].text); }
#line 5404 "parse.cc" /* yacc.c:1646  */
    break;

  case 84:
#line 771 "./parse.y" /* yacc.c:1646  */
    { pform_start_nature((yyvsp[-1].text)); }
#line 5410 "parse.cc" /* yacc.c:1646  */
    break;

  case 85:
#line 774 "./parse.y" /* yacc.c:1646  */
    { pform_end_nature((yylsp[-5])); delete[] (yyvsp[-4].text); }
#line 5416 "parse.cc" /* yacc.c:1646  */
    break;

  case 88:
#line 784 "./parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[-1].text); }
#line 5422 "parse.cc" /* yacc.c:1646  */
    break;

  case 90:
#line 787 "./parse.y" /* yacc.c:1646  */
    { pform_nature_access((yylsp[-3]), (yyvsp[-1].text)); delete[] (yyvsp[-1].text); }
#line 5428 "parse.cc" /* yacc.c:1646  */
    break;

  case 91:
#line 789 "./parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[-1].text); }
#line 5434 "parse.cc" /* yacc.c:1646  */
    break;

  case 92:
#line 791 "./parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[-1].text); }
#line 5440 "parse.cc" /* yacc.c:1646  */
    break;

  case 93:
#line 799 "./parse.y" /* yacc.c:1646  */
    { cerr << (yylsp[-7]) << ": sorry: config declarations are not supported and "
                "will be skipped." << endl;
	delete[] (yyvsp[-6].text);
      }
#line 5449 "parse.cc" /* yacc.c:1646  */
    break;

  case 99:
#line 819 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].pform_name); }
#line 5455 "parse.cc" /* yacc.c:1646  */
    break;

  case 100:
#line 821 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-4].pform_name); }
#line 5461 "parse.cc" /* yacc.c:1646  */
    break;

  case 105:
#line 832 "./parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[0].text); }
#line 5467 "parse.cc" /* yacc.c:1646  */
    break;

  case 106:
#line 834 "./parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[-2].text); delete[] (yyvsp[0].text); }
#line 5473 "parse.cc" /* yacc.c:1646  */
    break;

  case 108:
#line 840 "./parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[0].text); }
#line 5479 "parse.cc" /* yacc.c:1646  */
    break;

  case 109:
#line 844 "./parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = (yyvsp[-3].drive).str0;
		  (yyval.drive).str1 = (yyvsp[-1].drive).str1;
		}
#line 5487 "parse.cc" /* yacc.c:1646  */
    break;

  case 110:
#line 848 "./parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = (yyvsp[-1].drive).str0;
		  (yyval.drive).str1 = (yyvsp[-3].drive).str1;
		}
#line 5495 "parse.cc" /* yacc.c:1646  */
    break;

  case 111:
#line 852 "./parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = (yyvsp[-3].drive).str0;
		  (yyval.drive).str1 = PGate::HIGHZ;
		}
#line 5503 "parse.cc" /* yacc.c:1646  */
    break;

  case 112:
#line 856 "./parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::HIGHZ;
		  (yyval.drive).str1 = (yyvsp[-3].drive).str1;
		}
#line 5511 "parse.cc" /* yacc.c:1646  */
    break;

  case 113:
#line 860 "./parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = (yyvsp[-1].drive).str0;
		  (yyval.drive).str1 = PGate::HIGHZ;
		}
#line 5519 "parse.cc" /* yacc.c:1646  */
    break;

  case 114:
#line 864 "./parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::HIGHZ;
		  (yyval.drive).str1 = (yyvsp[-1].drive).str1;
		}
#line 5527 "parse.cc" /* yacc.c:1646  */
    break;

  case 115:
#line 870 "./parse.y" /* yacc.c:1646  */
    { (yyval.drive) = (yyvsp[0].drive); }
#line 5533 "parse.cc" /* yacc.c:1646  */
    break;

  case 116:
#line 871 "./parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::STRONG; (yyval.drive).str1 = PGate::STRONG; }
#line 5539 "parse.cc" /* yacc.c:1646  */
    break;

  case 117:
#line 875 "./parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::SUPPLY; }
#line 5545 "parse.cc" /* yacc.c:1646  */
    break;

  case 118:
#line 876 "./parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::STRONG; }
#line 5551 "parse.cc" /* yacc.c:1646  */
    break;

  case 119:
#line 877 "./parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::PULL; }
#line 5557 "parse.cc" /* yacc.c:1646  */
    break;

  case 120:
#line 878 "./parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::WEAK; }
#line 5563 "parse.cc" /* yacc.c:1646  */
    break;

  case 121:
#line 882 "./parse.y" /* yacc.c:1646  */
    { (yyval.drive).str1 = PGate::SUPPLY; }
#line 5569 "parse.cc" /* yacc.c:1646  */
    break;

  case 122:
#line 883 "./parse.y" /* yacc.c:1646  */
    { (yyval.drive).str1 = PGate::STRONG; }
#line 5575 "parse.cc" /* yacc.c:1646  */
    break;

  case 123:
#line 884 "./parse.y" /* yacc.c:1646  */
    { (yyval.drive).str1 = PGate::PULL; }
#line 5581 "parse.cc" /* yacc.c:1646  */
    break;

  case 124:
#line 885 "./parse.y" /* yacc.c:1646  */
    { (yyval.drive).str1 = PGate::WEAK; }
#line 5587 "parse.cc" /* yacc.c:1646  */
    break;

  case 125:
#line 890 "./parse.y" /* yacc.c:1646  */
    { PEIdent*tmpi = new PEIdent(*(yyvsp[0].pform_name));
		  PEEvent*tmpe = new PEEvent(PEEvent::ANYEDGE, tmpi);
		  PEventStatement*tmps = new PEventStatement(tmpe);
		  FILE_NAME(tmps, (yylsp[-1]));
		  (yyval.event_statement) = tmps;
		  delete (yyvsp[0].pform_name);
		}
#line 5599 "parse.cc" /* yacc.c:1646  */
    break;

  case 126:
#line 898 "./parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp = new PEventStatement(*(yyvsp[-1].event_expr));
		  FILE_NAME(tmp, (yylsp[-3]));
		  delete (yyvsp[-1].event_expr);
		  (yyval.event_statement) = tmp;
		}
#line 5609 "parse.cc" /* yacc.c:1646  */
    break;

  case 127:
#line 904 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: Malformed event control expression.");
		  (yyval.event_statement) = 0;
		}
#line 5617 "parse.cc" /* yacc.c:1646  */
    break;

  case 128:
#line 911 "./parse.y" /* yacc.c:1646  */
    { (yyval.event_expr) = (yyvsp[0].event_expr); }
#line 5623 "parse.cc" /* yacc.c:1646  */
    break;

  case 129:
#line 913 "./parse.y" /* yacc.c:1646  */
    { svector<PEEvent*>*tmp = new svector<PEEvent*>(*(yyvsp[-2].event_expr), *(yyvsp[0].event_expr));
		  delete (yyvsp[-2].event_expr);
		  delete (yyvsp[0].event_expr);
		  (yyval.event_expr) = tmp;
		}
#line 5633 "parse.cc" /* yacc.c:1646  */
    break;

  case 130:
#line 919 "./parse.y" /* yacc.c:1646  */
    { svector<PEEvent*>*tmp = new svector<PEEvent*>(*(yyvsp[-2].event_expr), *(yyvsp[0].event_expr));
		  delete (yyvsp[-2].event_expr);
		  delete (yyvsp[0].event_expr);
		  (yyval.event_expr) = tmp;
		}
#line 5643 "parse.cc" /* yacc.c:1646  */
    break;

  case 131:
#line 928 "./parse.y" /* yacc.c:1646  */
    { PEEvent*tmp = new PEEvent(PEEvent::POSEDGE, (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		}
#line 5654 "parse.cc" /* yacc.c:1646  */
    break;

  case 132:
#line 935 "./parse.y" /* yacc.c:1646  */
    { PEEvent*tmp = new PEEvent(PEEvent::NEGEDGE, (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		}
#line 5665 "parse.cc" /* yacc.c:1646  */
    break;

  case 133:
#line 942 "./parse.y" /* yacc.c:1646  */
    { PEEvent*tmp = new PEEvent(PEEvent::ANYEDGE, (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		}
#line 5676 "parse.cc" /* yacc.c:1646  */
    break;

  case 134:
#line 956 "./parse.y" /* yacc.c:1646  */
    { (yyval.expr) = pform_make_branch_probe_expression((yylsp[-5]), (yyvsp[-5].text), (yyvsp[-3].text), (yyvsp[-1].text)); }
#line 5682 "parse.cc" /* yacc.c:1646  */
    break;

  case 135:
#line 958 "./parse.y" /* yacc.c:1646  */
    { (yyval.expr) = pform_make_branch_probe_expression((yylsp[-3]), (yyvsp[-3].text), (yyvsp[-1].text)); }
#line 5688 "parse.cc" /* yacc.c:1646  */
    break;

  case 136:
#line 963 "./parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 5694 "parse.cc" /* yacc.c:1646  */
    break;

  case 137:
#line 965 "./parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 5700 "parse.cc" /* yacc.c:1646  */
    break;

  case 138:
#line 967 "./parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('-', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5709 "parse.cc" /* yacc.c:1646  */
    break;

  case 139:
#line 972 "./parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('~', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5718 "parse.cc" /* yacc.c:1646  */
    break;

  case 140:
#line 977 "./parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('&', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5727 "parse.cc" /* yacc.c:1646  */
    break;

  case 141:
#line 982 "./parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('!', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5736 "parse.cc" /* yacc.c:1646  */
    break;

  case 142:
#line 987 "./parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('|', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5745 "parse.cc" /* yacc.c:1646  */
    break;

  case 143:
#line 992 "./parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('^', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5754 "parse.cc" /* yacc.c:1646  */
    break;

  case 144:
#line 997 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: '~' '&'  is not a valid expression. "
			  "Please use operator '~&' instead.");
		  (yyval.expr) = 0;
		}
#line 5763 "parse.cc" /* yacc.c:1646  */
    break;

  case 145:
#line 1002 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: '~' '|'  is not a valid expression. "
			  "Please use operator '~|' instead.");
		  (yyval.expr) = 0;
		}
#line 5772 "parse.cc" /* yacc.c:1646  */
    break;

  case 146:
#line 1007 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: '~' '^'  is not a valid expression. "
			  "Please use operator '~^' instead.");
		  (yyval.expr) = 0;
		}
#line 5781 "parse.cc" /* yacc.c:1646  */
    break;

  case 147:
#line 1012 "./parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('A', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5790 "parse.cc" /* yacc.c:1646  */
    break;

  case 148:
#line 1017 "./parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('N', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5799 "parse.cc" /* yacc.c:1646  */
    break;

  case 149:
#line 1022 "./parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('X', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5808 "parse.cc" /* yacc.c:1646  */
    break;

  case 150:
#line 1027 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: Operand of unary ! "
			  "is not a primary expression.");
		  (yyval.expr) = 0;
		}
#line 5817 "parse.cc" /* yacc.c:1646  */
    break;

  case 151:
#line 1032 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: Operand of reduction ^ "
			  "is not a primary expression.");
		  (yyval.expr) = 0;
		}
#line 5826 "parse.cc" /* yacc.c:1646  */
    break;

  case 152:
#line 1037 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('^', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5835 "parse.cc" /* yacc.c:1646  */
    break;

  case 153:
#line 1042 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBPower('p', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5844 "parse.cc" /* yacc.c:1646  */
    break;

  case 154:
#line 1047 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('*', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5853 "parse.cc" /* yacc.c:1646  */
    break;

  case 155:
#line 1052 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('/', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5862 "parse.cc" /* yacc.c:1646  */
    break;

  case 156:
#line 1057 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('%', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5871 "parse.cc" /* yacc.c:1646  */
    break;

  case 157:
#line 1062 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('+', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5880 "parse.cc" /* yacc.c:1646  */
    break;

  case 158:
#line 1067 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('-', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5889 "parse.cc" /* yacc.c:1646  */
    break;

  case 159:
#line 1072 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('&', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5898 "parse.cc" /* yacc.c:1646  */
    break;

  case 160:
#line 1077 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('|', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5907 "parse.cc" /* yacc.c:1646  */
    break;

  case 161:
#line 1082 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('A', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5916 "parse.cc" /* yacc.c:1646  */
    break;

  case 162:
#line 1087 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('O', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5925 "parse.cc" /* yacc.c:1646  */
    break;

  case 163:
#line 1092 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('X', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5934 "parse.cc" /* yacc.c:1646  */
    break;

  case 164:
#line 1097 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('<', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5943 "parse.cc" /* yacc.c:1646  */
    break;

  case 165:
#line 1102 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('>', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5952 "parse.cc" /* yacc.c:1646  */
    break;

  case 166:
#line 1107 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBShift('l', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5961 "parse.cc" /* yacc.c:1646  */
    break;

  case 167:
#line 1112 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBShift('r', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5970 "parse.cc" /* yacc.c:1646  */
    break;

  case 168:
#line 1117 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBShift('R', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5979 "parse.cc" /* yacc.c:1646  */
    break;

  case 169:
#line 1122 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('e', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5988 "parse.cc" /* yacc.c:1646  */
    break;

  case 170:
#line 1127 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('E', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5997 "parse.cc" /* yacc.c:1646  */
    break;

  case 171:
#line 1132 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('L', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6006 "parse.cc" /* yacc.c:1646  */
    break;

  case 172:
#line 1137 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('G', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6015 "parse.cc" /* yacc.c:1646  */
    break;

  case 173:
#line 1142 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('n', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6024 "parse.cc" /* yacc.c:1646  */
    break;

  case 174:
#line 1147 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('N', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6033 "parse.cc" /* yacc.c:1646  */
    break;

  case 175:
#line 1152 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBLogic('o', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6042 "parse.cc" /* yacc.c:1646  */
    break;

  case 176:
#line 1157 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBLogic('a', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6051 "parse.cc" /* yacc.c:1646  */
    break;

  case 177:
#line 1162 "./parse.y" /* yacc.c:1646  */
    { PETernary*tmp = new PETernary((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-3]));
		  (yyval.expr) = tmp;
		}
#line 6060 "parse.cc" /* yacc.c:1646  */
    break;

  case 178:
#line 1170 "./parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 6066 "parse.cc" /* yacc.c:1646  */
    break;

  case 179:
#line 1172 "./parse.y" /* yacc.c:1646  */
    { switch (min_typ_max_flag) {
		      case MIN:
			(yyval.expr) = (yyvsp[-4].expr);
			delete (yyvsp[-2].expr);
			delete (yyvsp[0].expr);
			break;
		      case TYP:
			delete (yyvsp[-4].expr);
			(yyval.expr) = (yyvsp[-2].expr);
			delete (yyvsp[0].expr);
			break;
		      case MAX:
			delete (yyvsp[-4].expr);
			delete (yyvsp[-2].expr);
			(yyval.expr) = (yyvsp[0].expr);
			break;
		  }
		  if (min_typ_max_warn > 0) {
		        cerr << (yyval.expr)->get_fileline() << ": warning: choosing ";
		        switch (min_typ_max_flag) {
		            case MIN:
		              cerr << "min";
		              break;
		            case TYP:
		              cerr << "typ";
		              break;
		            case MAX:
		              cerr << "max";
		              break;
		        }
		        cerr << " expression." << endl;
		        min_typ_max_warn -= 1;
		  }
		}
#line 6105 "parse.cc" /* yacc.c:1646  */
    break;

  case 180:
#line 1219 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[-2].exprs), (yyvsp[0].expr));
		  delete (yyvsp[-2].exprs);
		  (yyval.exprs) = tmp;
		}
#line 6114 "parse.cc" /* yacc.c:1646  */
    break;

  case 181:
#line 1224 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[0].expr);
		  (yyval.exprs) = tmp;
		}
#line 6123 "parse.cc" /* yacc.c:1646  */
    break;

  case 182:
#line 1229 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = 0;
		  (yyval.exprs) = tmp;
		}
#line 6132 "parse.cc" /* yacc.c:1646  */
    break;

  case 183:
#line 1235 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[-1].exprs), 0);
		  delete (yyvsp[-1].exprs);
		  (yyval.exprs) = tmp;
		}
#line 6141 "parse.cc" /* yacc.c:1646  */
    break;

  case 184:
#line 1243 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[-2].exprs), (yyvsp[0].expr));
		  delete (yyvsp[-2].exprs);
		  (yyval.exprs) = tmp;
		}
#line 6150 "parse.cc" /* yacc.c:1646  */
    break;

  case 185:
#line 1248 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[0].expr);
		  (yyval.exprs) = tmp;
		}
#line 6159 "parse.cc" /* yacc.c:1646  */
    break;

  case 186:
#line 1256 "./parse.y" /* yacc.c:1646  */
    { assert((yyvsp[0].number));
		  PENumber*tmp = new PENumber((yyvsp[0].number));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 6169 "parse.cc" /* yacc.c:1646  */
    break;

  case 187:
#line 1262 "./parse.y" /* yacc.c:1646  */
    { PEFNumber*tmp = new PEFNumber((yyvsp[0].realtime));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 6178 "parse.cc" /* yacc.c:1646  */
    break;

  case 188:
#line 1267 "./parse.y" /* yacc.c:1646  */
    { PEString*tmp = new PEString((yyvsp[0].text));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 6187 "parse.cc" /* yacc.c:1646  */
    break;

  case 189:
#line 1272 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = lex_strings.make((yyvsp[0].text));
		  PECallFunction*tmp = new PECallFunction(tn);
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 6198 "parse.cc" /* yacc.c:1646  */
    break;

  case 190:
#line 1283 "./parse.y" /* yacc.c:1646  */
    { PEIdent*tmp = new PEIdent(*(yyvsp[0].pform_name));
	  FILE_NAME(tmp, (yylsp[0]));
	  (yyval.expr) = tmp;
	  delete (yyvsp[0].pform_name);
	}
#line 6208 "parse.cc" /* yacc.c:1646  */
    break;

  case 191:
#line 1294 "./parse.y" /* yacc.c:1646  */
    { PECallFunction*tmp = new PECallFunction(*(yyvsp[-3].pform_name), *(yyvsp[-1].exprs));
	FILE_NAME(tmp, (yylsp[-3]));
	delete (yyvsp[-3].pform_name);
	(yyval.expr) = tmp;
      }
#line 6218 "parse.cc" /* yacc.c:1646  */
    break;

  case 192:
#line 1300 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = lex_strings.make((yyvsp[-3].text));
	PECallFunction*tmp = new PECallFunction(tn, *(yyvsp[-1].exprs));
	FILE_NAME(tmp, (yylsp[-3]));
	delete[](yyvsp[-3].text);
	(yyval.expr) = tmp;
      }
#line 6229 "parse.cc" /* yacc.c:1646  */
    break;

  case 193:
#line 1311 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$acos");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6239 "parse.cc" /* yacc.c:1646  */
    break;

  case 194:
#line 1318 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$acosh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6249 "parse.cc" /* yacc.c:1646  */
    break;

  case 195:
#line 1325 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$asin");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6259 "parse.cc" /* yacc.c:1646  */
    break;

  case 196:
#line 1332 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$asinh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6269 "parse.cc" /* yacc.c:1646  */
    break;

  case 197:
#line 1339 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$atan");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6279 "parse.cc" /* yacc.c:1646  */
    break;

  case 198:
#line 1346 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$atanh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6289 "parse.cc" /* yacc.c:1646  */
    break;

  case 199:
#line 1353 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$atan2");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 6299 "parse.cc" /* yacc.c:1646  */
    break;

  case 200:
#line 1360 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$ceil");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6309 "parse.cc" /* yacc.c:1646  */
    break;

  case 201:
#line 1367 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$cos");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6319 "parse.cc" /* yacc.c:1646  */
    break;

  case 202:
#line 1374 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$cosh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6329 "parse.cc" /* yacc.c:1646  */
    break;

  case 203:
#line 1381 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$exp");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6339 "parse.cc" /* yacc.c:1646  */
    break;

  case 204:
#line 1388 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$floor");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6349 "parse.cc" /* yacc.c:1646  */
    break;

  case 205:
#line 1395 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$hypot");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 6359 "parse.cc" /* yacc.c:1646  */
    break;

  case 206:
#line 1402 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$ln");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6369 "parse.cc" /* yacc.c:1646  */
    break;

  case 207:
#line 1409 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$log10");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6379 "parse.cc" /* yacc.c:1646  */
    break;

  case 208:
#line 1416 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$pow");
        PECallFunction*tmp = make_call_function(tn, (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 6389 "parse.cc" /* yacc.c:1646  */
    break;

  case 209:
#line 1423 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$sin");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6399 "parse.cc" /* yacc.c:1646  */
    break;

  case 210:
#line 1430 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$sinh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6409 "parse.cc" /* yacc.c:1646  */
    break;

  case 211:
#line 1437 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$sqrt");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6419 "parse.cc" /* yacc.c:1646  */
    break;

  case 212:
#line 1444 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$tan");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6429 "parse.cc" /* yacc.c:1646  */
    break;

  case 213:
#line 1451 "./parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$tanh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6439 "parse.cc" /* yacc.c:1646  */
    break;

  case 214:
#line 1462 "./parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('m', (yyvsp[-1].expr));
        FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6448 "parse.cc" /* yacc.c:1646  */
    break;

  case 215:
#line 1468 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('M', (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 6457 "parse.cc" /* yacc.c:1646  */
    break;

  case 216:
#line 1474 "./parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('m', (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 6466 "parse.cc" /* yacc.c:1646  */
    break;

  case 217:
#line 1482 "./parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 6472 "parse.cc" /* yacc.c:1646  */
    break;

  case 218:
#line 1487 "./parse.y" /* yacc.c:1646  */
    { PEConcat*tmp = new PEConcat(*(yyvsp[-1].exprs));
		  FILE_NAME(tmp, (yylsp[-2]));
		  delete (yyvsp[-1].exprs);
		  (yyval.expr) = tmp;
		}
#line 6482 "parse.cc" /* yacc.c:1646  */
    break;

  case 219:
#line 1493 "./parse.y" /* yacc.c:1646  */
    { PExpr*rep = (yyvsp[-4].expr);
		  PEConcat*tmp = new PEConcat(*(yyvsp[-2].exprs), rep);
		  FILE_NAME(tmp, (yylsp[-5]));
		  delete (yyvsp[-2].exprs);
		  (yyval.expr) = tmp;
		}
#line 6493 "parse.cc" /* yacc.c:1646  */
    break;

  case 220:
#line 1500 "./parse.y" /* yacc.c:1646  */
    { PExpr*rep = (yyvsp[-5].expr);
		  PEConcat*tmp = new PEConcat(*(yyvsp[-3].exprs), rep);
		  FILE_NAME(tmp, (yylsp[-6]));
		  delete (yyvsp[-3].exprs);
		  (yyval.expr) = tmp;
		  yyerror((yylsp[-2]), "error: Syntax error between internal '}' "
			  "and closing '}' of repeat concatenation.");
		  yyerrok;
		}
#line 6507 "parse.cc" /* yacc.c:1646  */
    break;

  case 221:
#line 1516 "./parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 6513 "parse.cc" /* yacc.c:1646  */
    break;

  case 222:
#line 1518 "./parse.y" /* yacc.c:1646  */
    { if ((yyvsp[-1].wires) && (yyvsp[0].wires)) {
		        svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[-1].wires), *(yyvsp[0].wires));
			delete (yyvsp[-1].wires);
			delete (yyvsp[0].wires);
			(yyval.wires) = tmp;
		  } else if ((yyvsp[-1].wires)) {
			(yyval.wires) = (yyvsp[-1].wires);
		  } else {
			(yyval.wires) = (yyvsp[0].wires);
		  }
		}
#line 6529 "parse.cc" /* yacc.c:1646  */
    break;

  case 223:
#line 1533 "./parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 6535 "parse.cc" /* yacc.c:1646  */
    break;

  case 224:
#line 1535 "./parse.y" /* yacc.c:1646  */
    { (yyval.wires) = 0; }
#line 6541 "parse.cc" /* yacc.c:1646  */
    break;

  case 225:
#line 1542 "./parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[-3].text);
		  tmp->parms = (yyvsp[-1].exprs);
		  tmp->file  = (yylsp[-3]).text;
		  tmp->lineno = (yylsp[-3]).first_line;
		  delete[](yyvsp[-3].text);
		  (yyval.gate) = tmp;
		}
#line 6554 "parse.cc" /* yacc.c:1646  */
    break;

  case 226:
#line 1552 "./parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  svector<PExpr*>*rng = (yyvsp[-3].exprs);
		  tmp->name = (yyvsp[-4].text);
		  tmp->parms = (yyvsp[-1].exprs);
		  tmp->range[0] = (*rng)[0];
		  tmp->range[1] = (*rng)[1];
		  tmp->file  = (yylsp[-4]).text;
		  tmp->lineno = (yylsp[-4]).first_line;
		  delete[](yyvsp[-4].text);
		  delete rng;
		  (yyval.gate) = tmp;
		}
#line 6571 "parse.cc" /* yacc.c:1646  */
    break;

  case 227:
#line 1565 "./parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  tmp->name = "";
		  tmp->parms = (yyvsp[-1].exprs);
		  tmp->file  = (yylsp[-2]).text;
		  tmp->lineno = (yylsp[-2]).first_line;
		  (yyval.gate) = tmp;
		}
#line 6583 "parse.cc" /* yacc.c:1646  */
    break;

  case 228:
#line 1576 "./parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  svector<PExpr*>*rng = (yyvsp[0].exprs);
		  tmp->name = (yyvsp[-1].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->range[0] = (*rng)[0];
		  tmp->range[1] = (*rng)[1];
		  tmp->file  = (yylsp[-1]).text;
		  tmp->lineno = (yylsp[-1]).first_line;
		  delete[](yyvsp[-1].text);
		  delete rng;
		  (yyval.gate) = tmp;
		}
#line 6601 "parse.cc" /* yacc.c:1646  */
    break;

  case 229:
#line 1593 "./parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[-3].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = (yyvsp[-1].named_pexprs);
		  tmp->file  = (yylsp[-3]).text;
		  tmp->lineno = (yylsp[-3]).first_line;
		  delete[](yyvsp[-3].text);
		  (yyval.gate) = tmp;
		}
#line 6615 "parse.cc" /* yacc.c:1646  */
    break;

  case 230:
#line 1604 "./parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  svector<PExpr*>*rng = (yyvsp[-3].exprs);
		  tmp->name = (yyvsp[-4].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = (yyvsp[-1].named_pexprs);
		  tmp->range[0] = (*rng)[0];
		  tmp->range[1] = (*rng)[1];
		  tmp->file  = (yylsp[-4]).text;
		  tmp->lineno = (yylsp[-4]).first_line;
		  delete[](yyvsp[-4].text);
		  delete rng;
		  (yyval.gate) = tmp;
		}
#line 6633 "parse.cc" /* yacc.c:1646  */
    break;

  case 231:
#line 1619 "./parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[-3].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->file  = (yylsp[-3]).text;
		  tmp->lineno = (yylsp[-3]).first_line;
		  yyerror((yylsp[-2]), "error: Syntax error in instance port "
			  "expression(s).");
		  delete[](yyvsp[-3].text);
		  (yyval.gate) = tmp;
		}
#line 6649 "parse.cc" /* yacc.c:1646  */
    break;

  case 232:
#line 1632 "./parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[-4].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->file  = (yylsp[-4]).text;
		  tmp->lineno = (yylsp[-4]).first_line;
		  yyerror((yylsp[-2]), "error: Syntax error in instance port "
			  "expression(s).");
		  delete[](yyvsp[-4].text);
		  (yyval.gate) = tmp;
		}
#line 6665 "parse.cc" /* yacc.c:1646  */
    break;

  case 233:
#line 1647 "./parse.y" /* yacc.c:1646  */
    { svector<lgate>*tmp1 = (yyvsp[-2].gates);
		  lgate*tmp2 = (yyvsp[0].gate);
		  svector<lgate>*out = new svector<lgate> (*tmp1, *tmp2);
		  delete tmp1;
		  delete tmp2;
		  (yyval.gates) = out;
		}
#line 6677 "parse.cc" /* yacc.c:1646  */
    break;

  case 234:
#line 1655 "./parse.y" /* yacc.c:1646  */
    { svector<lgate>*tmp = new svector<lgate>(1);
		  (*tmp)[0] = *(yyvsp[0].gate);
		  delete (yyvsp[0].gate);
		  (yyval.gates) = tmp;
		}
#line 6687 "parse.cc" /* yacc.c:1646  */
    break;

  case 235:
#line 1663 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::AND; }
#line 6693 "parse.cc" /* yacc.c:1646  */
    break;

  case 236:
#line 1664 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NAND; }
#line 6699 "parse.cc" /* yacc.c:1646  */
    break;

  case 237:
#line 1665 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::OR; }
#line 6705 "parse.cc" /* yacc.c:1646  */
    break;

  case 238:
#line 1666 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NOR; }
#line 6711 "parse.cc" /* yacc.c:1646  */
    break;

  case 239:
#line 1667 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::XOR; }
#line 6717 "parse.cc" /* yacc.c:1646  */
    break;

  case 240:
#line 1668 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::XNOR; }
#line 6723 "parse.cc" /* yacc.c:1646  */
    break;

  case 241:
#line 1669 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::BUF; }
#line 6729 "parse.cc" /* yacc.c:1646  */
    break;

  case 242:
#line 1670 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::BUFIF0; }
#line 6735 "parse.cc" /* yacc.c:1646  */
    break;

  case 243:
#line 1671 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::BUFIF1; }
#line 6741 "parse.cc" /* yacc.c:1646  */
    break;

  case 244:
#line 1672 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NOT; }
#line 6747 "parse.cc" /* yacc.c:1646  */
    break;

  case 245:
#line 1673 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NOTIF0; }
#line 6753 "parse.cc" /* yacc.c:1646  */
    break;

  case 246:
#line 1674 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NOTIF1; }
#line 6759 "parse.cc" /* yacc.c:1646  */
    break;

  case 247:
#line 1678 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NMOS; }
#line 6765 "parse.cc" /* yacc.c:1646  */
    break;

  case 248:
#line 1679 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RNMOS; }
#line 6771 "parse.cc" /* yacc.c:1646  */
    break;

  case 249:
#line 1680 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::PMOS; }
#line 6777 "parse.cc" /* yacc.c:1646  */
    break;

  case 250:
#line 1681 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RPMOS; }
#line 6783 "parse.cc" /* yacc.c:1646  */
    break;

  case 251:
#line 1682 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::CMOS; }
#line 6789 "parse.cc" /* yacc.c:1646  */
    break;

  case 252:
#line 1683 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RCMOS; }
#line 6795 "parse.cc" /* yacc.c:1646  */
    break;

  case 253:
#line 1684 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::TRAN; }
#line 6801 "parse.cc" /* yacc.c:1646  */
    break;

  case 254:
#line 1685 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RTRAN; }
#line 6807 "parse.cc" /* yacc.c:1646  */
    break;

  case 255:
#line 1686 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::TRANIF0; }
#line 6813 "parse.cc" /* yacc.c:1646  */
    break;

  case 256:
#line 1687 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::TRANIF1; }
#line 6819 "parse.cc" /* yacc.c:1646  */
    break;

  case 257:
#line 1688 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RTRANIF0; }
#line 6825 "parse.cc" /* yacc.c:1646  */
    break;

  case 258:
#line 1689 "./parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RTRANIF1; }
#line 6831 "parse.cc" /* yacc.c:1646  */
    break;

  case 259:
#line 1700 "./parse.y" /* yacc.c:1646  */
    { (yyval.pform_name) = new pform_name_t;
	  (yyval.pform_name)->push_back(name_component_t(lex_strings.make((yyvsp[0].text))));
	  delete[](yyvsp[0].text);
	}
#line 6840 "parse.cc" /* yacc.c:1646  */
    break;

  case 260:
#line 1705 "./parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-2].pform_name);
	  tmp->push_back(name_component_t(lex_strings.make((yyvsp[0].text))));
	  delete[](yyvsp[0].text);
	  (yyval.pform_name) = tmp;
	}
#line 6850 "parse.cc" /* yacc.c:1646  */
    break;

  case 261:
#line 1711 "./parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-3].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_BIT;
	  itmp.msb = (yyvsp[-1].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
#line 6863 "parse.cc" /* yacc.c:1646  */
    break;

  case 262:
#line 1720 "./parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-5].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_PART;
	  itmp.msb = (yyvsp[-3].expr);
	  itmp.lsb = (yyvsp[-1].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
#line 6877 "parse.cc" /* yacc.c:1646  */
    break;

  case 263:
#line 1730 "./parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-5].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_IDX_UP;
	  itmp.msb = (yyvsp[-3].expr);
	  itmp.lsb = (yyvsp[-1].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
#line 6891 "parse.cc" /* yacc.c:1646  */
    break;

  case 264:
#line 1740 "./parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-5].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_IDX_DO;
	  itmp.msb = (yyvsp[-3].expr);
	  itmp.lsb = (yyvsp[-1].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
#line 6905 "parse.cc" /* yacc.c:1646  */
    break;

  case 265:
#line 1756 "./parse.y" /* yacc.c:1646  */
    { (yyval.perm_strings) = list_from_identifier((yyvsp[0].text)); }
#line 6911 "parse.cc" /* yacc.c:1646  */
    break;

  case 266:
#line 1758 "./parse.y" /* yacc.c:1646  */
    { (yyval.perm_strings) = list_from_identifier((yyvsp[-2].perm_strings), (yyvsp[0].text)); }
#line 6917 "parse.cc" /* yacc.c:1646  */
    break;

  case 267:
#line 1763 "./parse.y" /* yacc.c:1646  */
    { (yyval.port_list) = make_port_list((yyvsp[0].text), 0); }
#line 6923 "parse.cc" /* yacc.c:1646  */
    break;

  case 268:
#line 1765 "./parse.y" /* yacc.c:1646  */
    { (yyval.port_list) = make_port_list((yyvsp[-2].text), (yyvsp[0].expr)); }
#line 6929 "parse.cc" /* yacc.c:1646  */
    break;

  case 269:
#line 1767 "./parse.y" /* yacc.c:1646  */
    { (yyval.port_list) = make_port_list((yyvsp[-2].port_list), (yyvsp[0].text), 0); }
#line 6935 "parse.cc" /* yacc.c:1646  */
    break;

  case 270:
#line 1769 "./parse.y" /* yacc.c:1646  */
    { (yyval.port_list) = make_port_list((yyvsp[-4].port_list), (yyvsp[-2].text), (yyvsp[0].expr)); }
#line 6941 "parse.cc" /* yacc.c:1646  */
    break;

  case 271:
#line 1791 "./parse.y" /* yacc.c:1646  */
    { vector<Module::port_t*>*tmp
			  = new vector<Module::port_t*>(1);
		  (*tmp)[0] = (yyvsp[0].mport);
		  (yyval.mports) = tmp;
		}
#line 6951 "parse.cc" /* yacc.c:1646  */
    break;

  case 272:
#line 1797 "./parse.y" /* yacc.c:1646  */
    { vector<Module::port_t*>*tmp = (yyvsp[-2].mports);
		  tmp->push_back((yyvsp[0].mport));
		  (yyval.mports) = tmp;
		}
#line 6960 "parse.cc" /* yacc.c:1646  */
    break;

  case 273:
#line 1805 "./parse.y" /* yacc.c:1646  */
    { vector<Module::port_t*>*tmp
			  = new vector<Module::port_t*>(1);
		  (*tmp)[0] = (yyvsp[0].mport);
		  (yyval.mports) = tmp;
		}
#line 6970 "parse.cc" /* yacc.c:1646  */
    break;

  case 274:
#line 1811 "./parse.y" /* yacc.c:1646  */
    { vector<Module::port_t*>*tmp = (yyvsp[-2].mports);
		  tmp->push_back((yyvsp[0].mport));
		  (yyval.mports) = tmp;
		}
#line 6979 "parse.cc" /* yacc.c:1646  */
    break;

  case 275:
#line 1816 "./parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
		  perm_string name = lex_strings.make((yyvsp[0].text));
		  ptmp = pform_module_port_reference(name, (yylsp[0]).text,
						     (yylsp[0]).first_line);
		  vector<Module::port_t*>*tmp = (yyvsp[-2].mports);
		  tmp->push_back(ptmp);

		    /* Get the port declaration details, the port type
		       and what not, from context data stored by the
		       last port_declaration rule. */
		  pform_module_define_port((yylsp[0]), name,
					port_declaration_context.port_type,
					port_declaration_context.port_net_type,
					port_declaration_context.sign_flag,
					port_declaration_context.range, 0);
		  delete[](yyvsp[0].text);
		  (yyval.mports) = tmp;
		}
#line 7002 "parse.cc" /* yacc.c:1646  */
    break;

  case 276:
#line 1835 "./parse.y" /* yacc.c:1646  */
    {
		  yyerror((yylsp[0]), "error: NULL port declarations are not "
		              "allowed.");
		}
#line 7011 "parse.cc" /* yacc.c:1646  */
    break;

  case 277:
#line 1840 "./parse.y" /* yacc.c:1646  */
    {
		  yyerror((yylsp[0]), "error: ';' is an invalid port declaration "
		              "separator.");
		}
#line 7020 "parse.cc" /* yacc.c:1646  */
    break;

  case 278:
#line 1849 "./parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[0].text));
	ptmp = pform_module_port_reference(name, (yylsp[-4]).text,
					   (yylsp[-4]).first_line);
	pform_module_define_port((yylsp[-4]), name, NetNet::PINPUT,
				 (yyvsp[-3].nettype), (yyvsp[-2].flag), (yyvsp[-1].exprs), (yyvsp[-5].named_pexprs));
	port_declaration_context.port_type = NetNet::PINPUT;
	port_declaration_context.port_net_type = (yyvsp[-3].nettype);
	port_declaration_context.sign_flag = (yyvsp[-2].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[-1].exprs);
	delete (yyvsp[-5].named_pexprs);
	delete[](yyvsp[0].text);
	(yyval.mport) = ptmp;
      }
#line 7040 "parse.cc" /* yacc.c:1646  */
    break;

  case 279:
#line 1866 "./parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[0].text));
	ptmp = pform_module_port_reference(name, (yylsp[-4]).text,
					   (yylsp[-4]).first_line);
	pform_module_define_port((yylsp[-4]), name, NetNet::PINOUT,
				 (yyvsp[-3].nettype), (yyvsp[-2].flag), (yyvsp[-1].exprs), (yyvsp[-5].named_pexprs));
	port_declaration_context.port_type = NetNet::PINOUT;
	port_declaration_context.port_net_type = (yyvsp[-3].nettype);
	port_declaration_context.sign_flag = (yyvsp[-2].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[-1].exprs);
	delete (yyvsp[-5].named_pexprs);
	delete[](yyvsp[0].text);
	(yyval.mport) = ptmp;
      }
#line 7060 "parse.cc" /* yacc.c:1646  */
    break;

  case 280:
#line 1883 "./parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[0].text));
	ptmp = pform_module_port_reference(name, (yylsp[-4]).text,
					   (yylsp[-4]).first_line);
	pform_module_define_port((yylsp[-4]), name, NetNet::POUTPUT,
				 (yyvsp[-3].nettype), (yyvsp[-2].flag), (yyvsp[-1].exprs), (yyvsp[-5].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = (yyvsp[-3].nettype);
	port_declaration_context.sign_flag = (yyvsp[-2].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[-1].exprs);
	delete (yyvsp[-5].named_pexprs);
	delete[](yyvsp[0].text);
	(yyval.mport) = ptmp;
      }
#line 7080 "parse.cc" /* yacc.c:1646  */
    break;

  case 281:
#line 1900 "./parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[0].text));
	ptmp = pform_module_port_reference(name, (yylsp[-4]).text,
					   (yylsp[-4]).first_line);
	pform_module_define_port((yylsp[-4]), name, NetNet::POUTPUT,
				 (yyvsp[-3].nettype), (yyvsp[-2].flag), (yyvsp[-1].exprs), (yyvsp[-5].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = (yyvsp[-3].nettype);
	port_declaration_context.sign_flag = (yyvsp[-2].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[-1].exprs);
	delete (yyvsp[-5].named_pexprs);
	delete[](yyvsp[0].text);
	(yyval.mport) = ptmp;
      }
#line 7100 "parse.cc" /* yacc.c:1646  */
    break;

  case 282:
#line 1917 "./parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[-2].text));
	ptmp = pform_module_port_reference(name, (yylsp[-6]).text,
					   (yylsp[-6]).first_line);
	pform_module_define_port((yylsp[-6]), name, NetNet::POUTPUT,
				 (yyvsp[-5].nettype), (yyvsp[-4].flag), (yyvsp[-3].exprs), (yyvsp[-7].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = (yyvsp[-5].nettype);
	port_declaration_context.sign_flag = (yyvsp[-4].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[-3].exprs);

	pform_make_reginit((yylsp[-2]), name, (yyvsp[0].expr));

	delete (yyvsp[-7].named_pexprs);
	delete[](yyvsp[-2].text);
	(yyval.mport) = ptmp;
      }
#line 7123 "parse.cc" /* yacc.c:1646  */
    break;

  case 283:
#line 1940 "./parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = (yyvsp[0].nettype); }
#line 7129 "parse.cc" /* yacc.c:1646  */
    break;

  case 284:
#line 1941 "./parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::IMPLICIT; }
#line 7135 "parse.cc" /* yacc.c:1646  */
    break;

  case 285:
#line 1944 "./parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 7141 "parse.cc" /* yacc.c:1646  */
    break;

  case 286:
#line 1944 "./parse.y" /* yacc.c:1646  */
    {(yyval.flag) = false; }
#line 7147 "parse.cc" /* yacc.c:1646  */
    break;

  case 287:
#line 1952 "./parse.y" /* yacc.c:1646  */
    { PEIdent*tmp = new PEIdent(*(yyvsp[0].pform_name));
	  FILE_NAME(tmp, (yylsp[0]));
	  (yyval.expr) = tmp;
	  delete (yyvsp[0].pform_name);
	}
#line 7157 "parse.cc" /* yacc.c:1646  */
    break;

  case 288:
#line 1958 "./parse.y" /* yacc.c:1646  */
    { PEConcat*tmp = new PEConcat(*(yyvsp[-1].exprs));
	  FILE_NAME(tmp, (yylsp[-2]));
	  delete (yyvsp[-1].exprs);
	  (yyval.expr) = tmp;
	}
#line 7167 "parse.cc" /* yacc.c:1646  */
    break;

  case 289:
#line 1970 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(2);
		  (*tmp)[0] = (yyvsp[-2].expr);
		  (*tmp)[1] = (yyvsp[0].expr);
		  (yyval.exprs) = tmp;
		}
#line 7177 "parse.cc" /* yacc.c:1646  */
    break;

  case 290:
#line 1979 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[-2].exprs), *(yyvsp[0].exprs));
		  delete (yyvsp[-2].exprs);
		  delete (yyvsp[0].exprs);
		  (yyval.exprs) = tmp;
		}
#line 7187 "parse.cc" /* yacc.c:1646  */
    break;

  case 291:
#line 1985 "./parse.y" /* yacc.c:1646  */
    { (yyval.exprs) = (yyvsp[0].exprs); }
#line 7193 "parse.cc" /* yacc.c:1646  */
    break;

  case 292:
#line 1994 "./parse.y" /* yacc.c:1646  */
    { pform_startmodule((yyvsp[0].text), (yylsp[-1]).text, (yylsp[-1]).first_line, (yyvsp[-2].named_pexprs)); }
#line 7199 "parse.cc" /* yacc.c:1646  */
    break;

  case 293:
#line 1998 "./parse.y" /* yacc.c:1646  */
    { pform_module_set_ports((yyvsp[-2].mports)); }
#line 7205 "parse.cc" /* yacc.c:1646  */
    break;

  case 294:
#line 2001 "./parse.y" /* yacc.c:1646  */
    { Module::UCDriveType ucd;
		  switch (uc_drive) {
		      case UCD_NONE:
		      default:
			ucd = Module::UCD_NONE;
			break;
		      case UCD_PULL0:
			ucd = Module::UCD_PULL0;
			break;
		      case UCD_PULL1:
			ucd = Module::UCD_PULL1;
			break;
		  }
		  pform_endmodule((yyvsp[-8].text), in_celldefine, ucd);
		  delete[](yyvsp[-8].text);
		}
#line 7226 "parse.cc" /* yacc.c:1646  */
    break;

  case 297:
#line 2023 "./parse.y" /* yacc.c:1646  */
    { (yyval.mports) = 0; }
#line 7232 "parse.cc" /* yacc.c:1646  */
    break;

  case 298:
#line 2024 "./parse.y" /* yacc.c:1646  */
    { (yyval.mports) = 0; }
#line 7238 "parse.cc" /* yacc.c:1646  */
    break;

  case 299:
#line 2028 "./parse.y" /* yacc.c:1646  */
    { (yyval.mports) = (yyvsp[-1].mports); }
#line 7244 "parse.cc" /* yacc.c:1646  */
    break;

  case 300:
#line 2029 "./parse.y" /* yacc.c:1646  */
    { (yyval.mports) = (yyvsp[-1].mports); }
#line 7250 "parse.cc" /* yacc.c:1646  */
    break;

  case 301:
#line 2030 "./parse.y" /* yacc.c:1646  */
    { (yyval.mports) = 0; }
#line 7256 "parse.cc" /* yacc.c:1646  */
    break;

  case 307:
#line 2060 "./parse.y" /* yacc.c:1646  */
    { ivl_variable_type_t dtype = (yyvsp[-5].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_makewire((yylsp[-6]), (yyvsp[-3].exprs), (yyvsp[-4].flag), (yyvsp[-1].perm_strings), (yyvsp[-6].nettype),
				 NetNet::NOT_A_PORT, dtype, (yyvsp[-7].named_pexprs));
		  if ((yyvsp[-2].exprs) != 0) {
			yyerror((yylsp[-2]), "sorry: net delays not supported.");
			delete (yyvsp[-2].exprs);
		  }
		  if ((yyvsp[-7].named_pexprs)) delete (yyvsp[-7].named_pexprs);
		}
#line 7272 "parse.cc" /* yacc.c:1646  */
    break;

  case 308:
#line 2080 "./parse.y" /* yacc.c:1646  */
    { ivl_variable_type_t dtype = (yyvsp[-5].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_makewire((yylsp[-6]), (yyvsp[-3].exprs), (yyvsp[-4].flag), (yyvsp[-2].exprs),
				 str_strength, (yyvsp[-1].net_decl_assign), (yyvsp[-6].nettype), dtype);
		  if ((yyvsp[-7].named_pexprs)) {
			yyerror((yylsp[-6]), "sorry: Attributes not supported "
				"on net declaration assignments.");
			delete (yyvsp[-7].named_pexprs);
		  }
		}
#line 7288 "parse.cc" /* yacc.c:1646  */
    break;

  case 309:
#line 2099 "./parse.y" /* yacc.c:1646  */
    { ivl_variable_type_t dtype = (yyvsp[-4].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_makewire((yylsp[-5]), 0, (yyvsp[-3].flag), 0, (yyvsp[-2].drive), (yyvsp[-1].net_decl_assign), (yyvsp[-5].nettype), dtype);
		  if ((yyvsp[-6].named_pexprs)) {
			yyerror((yylsp[-5]), "sorry: Attributes not supported "
				"on net declaration assignments.");
			delete (yyvsp[-6].named_pexprs);
		  }
		}
#line 7303 "parse.cc" /* yacc.c:1646  */
    break;

  case 310:
#line 2111 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-5]), "sorry: trireg nets not supported.");
		  delete (yyvsp[-3].exprs);
		  delete (yyvsp[-2].exprs);
		}
#line 7312 "parse.cc" /* yacc.c:1646  */
    break;

  case 311:
#line 2117 "./parse.y" /* yacc.c:1646  */
    { pform_set_port_type((yylsp[-5]), (yyvsp[-1].perm_strings), (yyvsp[-3].exprs), (yyvsp[-4].flag), (yyvsp[-5].porttype));
		}
#line 7319 "parse.cc" /* yacc.c:1646  */
    break;

  case 312:
#line 2125 "./parse.y" /* yacc.c:1646  */
    { pform_makewire((yylsp[-5]), (yyvsp[-2].exprs), (yyvsp[-3].flag), (yyvsp[-1].perm_strings), (yyvsp[-4].nettype), (yyvsp[-5].porttype), IVL_VT_NO_TYPE, 0,
		                 SR_BOTH);
		}
#line 7327 "parse.cc" /* yacc.c:1646  */
    break;

  case 313:
#line 2130 "./parse.y" /* yacc.c:1646  */
    { list<pair<perm_string,PExpr*> >::const_iterator pp;
		  list<perm_string>*tmp = new list<perm_string>;
		  for (pp = (yyvsp[-1].port_list)->begin(); pp != (yyvsp[-1].port_list)->end(); pp++) {
			tmp->push_back((*pp).first);
		  }
		  pform_makewire((yylsp[-5]), (yyvsp[-2].exprs), (yyvsp[-3].flag), tmp, (yyvsp[-4].nettype), NetNet::POUTPUT,
		                 IVL_VT_NO_TYPE, 0, SR_BOTH);
		  for (pp = (yyvsp[-1].port_list)->begin(); pp != (yyvsp[-1].port_list)->end(); pp++) {
			if ((*pp).second) {
			      pform_make_reginit((yylsp[-5]), (*pp).first, (*pp).second);
			}
		  }
		  delete (yyvsp[-1].port_list);
		}
#line 7346 "parse.cc" /* yacc.c:1646  */
    break;

  case 314:
#line 2150 "./parse.y" /* yacc.c:1646  */
    { pform_makewire((yylsp[-5]), (yyvsp[-2].exprs), (yyvsp[-3].flag), (yyvsp[-1].perm_strings), (yyvsp[-4].nettype), NetNet::PINPUT,
				 IVL_VT_NO_TYPE, 0);
		  yyerror((yylsp[-4]), "error: reg variables cannot be inputs.");
		}
#line 7355 "parse.cc" /* yacc.c:1646  */
    break;

  case 315:
#line 2156 "./parse.y" /* yacc.c:1646  */
    { pform_makewire((yylsp[-5]), (yyvsp[-2].exprs), (yyvsp[-3].flag), (yyvsp[-1].perm_strings), (yyvsp[-4].nettype), NetNet::PINOUT,
				 IVL_VT_NO_TYPE, 0);
		  yyerror((yylsp[-4]), "error: reg variables cannot be inouts.");
		}
#line 7364 "parse.cc" /* yacc.c:1646  */
    break;

  case 316:
#line 2162 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-5]), "error: Invalid variable list"
			  " in port declaration.");
		  if ((yyvsp[-3].exprs)) delete (yyvsp[-3].exprs);
		  if ((yyvsp[-2].exprs)) delete (yyvsp[-2].exprs);
		  yyerrok;
		}
#line 7375 "parse.cc" /* yacc.c:1646  */
    break;

  case 317:
#line 2173 "./parse.y" /* yacc.c:1646  */
    { pform_attach_discipline((yylsp[-2]), (yyvsp[-2].discipline), (yyvsp[-1].perm_strings)); }
#line 7381 "parse.cc" /* yacc.c:1646  */
    break;

  case 320:
#line 2189 "./parse.y" /* yacc.c:1646  */
    { pform_makegates((yyvsp[-2].gatetype), str_strength, 0, (yyvsp[-1].gates), (yyvsp[-3].named_pexprs));
		}
#line 7388 "parse.cc" /* yacc.c:1646  */
    break;

  case 321:
#line 2193 "./parse.y" /* yacc.c:1646  */
    { pform_makegates((yyvsp[-3].gatetype), str_strength, (yyvsp[-2].exprs), (yyvsp[-1].gates), (yyvsp[-4].named_pexprs));
		}
#line 7395 "parse.cc" /* yacc.c:1646  */
    break;

  case 322:
#line 2197 "./parse.y" /* yacc.c:1646  */
    { pform_makegates((yyvsp[-3].gatetype), (yyvsp[-2].drive), 0, (yyvsp[-1].gates), (yyvsp[-4].named_pexprs));
		}
#line 7402 "parse.cc" /* yacc.c:1646  */
    break;

  case 323:
#line 2201 "./parse.y" /* yacc.c:1646  */
    { pform_makegates((yyvsp[-4].gatetype), (yyvsp[-3].drive), (yyvsp[-2].exprs), (yyvsp[-1].gates), (yyvsp[-5].named_pexprs));
		}
#line 7409 "parse.cc" /* yacc.c:1646  */
    break;

  case 324:
#line 2206 "./parse.y" /* yacc.c:1646  */
    { pform_makegates((yyvsp[-2].gatetype), str_strength, 0, (yyvsp[-1].gates), (yyvsp[-3].named_pexprs));
		}
#line 7416 "parse.cc" /* yacc.c:1646  */
    break;

  case 325:
#line 2210 "./parse.y" /* yacc.c:1646  */
    { pform_makegates((yyvsp[-3].gatetype), str_strength, (yyvsp[-2].exprs), (yyvsp[-1].gates), (yyvsp[-4].named_pexprs));
		}
#line 7423 "parse.cc" /* yacc.c:1646  */
    break;

  case 326:
#line 2217 "./parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLUP, pull_strength, 0,
				  (yyvsp[-1].gates), 0);
		}
#line 7431 "parse.cc" /* yacc.c:1646  */
    break;

  case 327:
#line 2221 "./parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLDOWN, pull_strength,
				  0, (yyvsp[-1].gates), 0);
		}
#line 7439 "parse.cc" /* yacc.c:1646  */
    break;

  case 328:
#line 2226 "./parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLUP, (yyvsp[-3].drive), 0, (yyvsp[-1].gates), 0);
		}
#line 7446 "parse.cc" /* yacc.c:1646  */
    break;

  case 329:
#line 2230 "./parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLDOWN, (yyvsp[-3].drive), 0, (yyvsp[-1].gates), 0);
		}
#line 7453 "parse.cc" /* yacc.c:1646  */
    break;

  case 330:
#line 2239 "./parse.y" /* yacc.c:1646  */
    { perm_string tmp1 = lex_strings.make((yyvsp[-3].text));
		  pform_make_modgates(tmp1, (yyvsp[-2].parmvalue), (yyvsp[-1].gates));
		  delete[](yyvsp[-3].text);
		  if ((yyvsp[-4].named_pexprs)) delete (yyvsp[-4].named_pexprs);
		}
#line 7463 "parse.cc" /* yacc.c:1646  */
    break;

  case 331:
#line 2247 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: Invalid module instantiation");
		  delete[](yyvsp[-3].text);
		  if ((yyvsp[-4].named_pexprs)) delete (yyvsp[-4].named_pexprs);
		}
#line 7472 "parse.cc" /* yacc.c:1646  */
    break;

  case 332:
#line 2257 "./parse.y" /* yacc.c:1646  */
    { pform_make_pgassign_list((yyvsp[-1].exprs), (yyvsp[-2].exprs), (yyvsp[-3].drive), (yylsp[-4]).text, (yylsp[-4]).first_line); }
#line 7478 "parse.cc" /* yacc.c:1646  */
    break;

  case 333:
#line 2262 "./parse.y" /* yacc.c:1646  */
    { PProcess*tmp = pform_make_behavior(IVL_PR_ALWAYS, (yyvsp[0].statement), (yyvsp[-2].named_pexprs));
	FILE_NAME(tmp, (yylsp[-1]));
      }
#line 7486 "parse.cc" /* yacc.c:1646  */
    break;

  case 334:
#line 2266 "./parse.y" /* yacc.c:1646  */
    { PProcess*tmp = pform_make_behavior(IVL_PR_INITIAL, (yyvsp[0].statement), (yyvsp[-2].named_pexprs));
	FILE_NAME(tmp, (yylsp[-1]));
      }
#line 7494 "parse.cc" /* yacc.c:1646  */
    break;

  case 335:
#line 2271 "./parse.y" /* yacc.c:1646  */
    { pform_make_analog_behavior((yylsp[-1]), IVL_PR_ALWAYS, (yyvsp[0].statement)); }
#line 7500 "parse.cc" /* yacc.c:1646  */
    break;

  case 336:
#line 2282 "./parse.y" /* yacc.c:1646  */
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yylsp[-3]), (yyvsp[-1].text), (yyvsp[-2].flag));
      }
#line 7508 "parse.cc" /* yacc.c:1646  */
    break;

  case 337:
#line 2288 "./parse.y" /* yacc.c:1646  */
    { current_task->set_ports((yyvsp[-2].wires));
	current_task->set_statement((yyvsp[-1].statement));
	pform_pop_scope();
	current_task = 0;
	delete[](yyvsp[-5].text);
      }
#line 7519 "parse.cc" /* yacc.c:1646  */
    break;

  case 338:
#line 2296 "./parse.y" /* yacc.c:1646  */
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yylsp[-3]), (yyvsp[-1].text), (yyvsp[-2].flag));
      }
#line 7527 "parse.cc" /* yacc.c:1646  */
    break;

  case 339:
#line 2303 "./parse.y" /* yacc.c:1646  */
    { current_task->set_ports((yyvsp[-5].wires));
	current_task->set_statement((yyvsp[-1].statement));
	pform_pop_scope();
	current_task = 0;
	delete[](yyvsp[-8].text);
      }
#line 7538 "parse.cc" /* yacc.c:1646  */
    break;

  case 340:
#line 2311 "./parse.y" /* yacc.c:1646  */
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yylsp[-5]), (yyvsp[-3].text), (yyvsp[-4].flag));
      }
#line 7546 "parse.cc" /* yacc.c:1646  */
    break;

  case 341:
#line 2317 "./parse.y" /* yacc.c:1646  */
    { current_task->set_ports(0);
	current_task->set_statement((yyvsp[-1].statement));
	pform_pop_scope();
	current_task = 0;
	cerr << (yylsp[-7]) << ": warning: task definition for \"" << (yyvsp[-7].text)
	     << "\" has an empty port declaration list!" << endl;
	delete[](yyvsp[-7].text);
      }
#line 7559 "parse.cc" /* yacc.c:1646  */
    break;

  case 342:
#line 2327 "./parse.y" /* yacc.c:1646  */
    {
	assert(current_task == 0);
	delete[](yyvsp[-2].text);
      }
#line 7568 "parse.cc" /* yacc.c:1646  */
    break;

  case 343:
#line 2338 "./parse.y" /* yacc.c:1646  */
    { assert(current_function == 0);
	current_function = pform_push_function_scope((yylsp[-4]), (yyvsp[-1].text), (yyvsp[-3].flag));
      }
#line 7576 "parse.cc" /* yacc.c:1646  */
    break;

  case 344:
#line 2343 "./parse.y" /* yacc.c:1646  */
    { current_function->set_ports((yyvsp[-2].wires));
	current_function->set_statement((yyvsp[-1].statement));
	current_function->set_return((yyvsp[-6].function_type));
	pform_pop_scope();
	current_function = 0;
	delete[](yyvsp[-5].text);
      }
#line 7588 "parse.cc" /* yacc.c:1646  */
    break;

  case 345:
#line 2352 "./parse.y" /* yacc.c:1646  */
    { assert(current_function == 0);
	current_function = pform_push_function_scope((yylsp[-3]), (yyvsp[0].text), (yyvsp[-2].flag));
      }
#line 7596 "parse.cc" /* yacc.c:1646  */
    break;

  case 346:
#line 2359 "./parse.y" /* yacc.c:1646  */
    { current_function->set_ports((yyvsp[-5].wires));
	current_function->set_statement((yyvsp[-1].statement));
	current_function->set_return((yyvsp[-9].function_type));
	pform_pop_scope();
	current_function = 0;
	delete[](yyvsp[-8].text);
      }
#line 7608 "parse.cc" /* yacc.c:1646  */
    break;

  case 347:
#line 2367 "./parse.y" /* yacc.c:1646  */
    {
	assert(current_function == 0);
	delete[](yyvsp[-2].text);
      }
#line 7617 "parse.cc" /* yacc.c:1646  */
    break;

  case 349:
#line 2379 "./parse.y" /* yacc.c:1646  */
    { pform_genvars((yylsp[-2]), (yyvsp[-1].perm_strings)); }
#line 7623 "parse.cc" /* yacc.c:1646  */
    break;

  case 350:
#line 2384 "./parse.y" /* yacc.c:1646  */
    { pform_start_generate_for((yylsp[-11]), (yyvsp[-9].text), (yyvsp[-7].expr), (yyvsp[-5].expr), (yyvsp[-3].text), (yyvsp[-1].expr)); }
#line 7629 "parse.cc" /* yacc.c:1646  */
    break;

  case 351:
#line 2386 "./parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 7635 "parse.cc" /* yacc.c:1646  */
    break;

  case 352:
#line 2391 "./parse.y" /* yacc.c:1646  */
    { pform_start_generate_else((yylsp[-2])); }
#line 7641 "parse.cc" /* yacc.c:1646  */
    break;

  case 353:
#line 2393 "./parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 7647 "parse.cc" /* yacc.c:1646  */
    break;

  case 354:
#line 2397 "./parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 7653 "parse.cc" /* yacc.c:1646  */
    break;

  case 355:
#line 2400 "./parse.y" /* yacc.c:1646  */
    { pform_start_generate_case((yylsp[-3]), (yyvsp[-1].expr)); }
#line 7659 "parse.cc" /* yacc.c:1646  */
    break;

  case 356:
#line 2403 "./parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 7665 "parse.cc" /* yacc.c:1646  */
    break;

  case 357:
#line 2407 "./parse.y" /* yacc.c:1646  */
    { /* Detect and warn about anachronistic begin/end use */
	if (generation_flag > GN_VER2001) {
	      warn_count += 1;
	      cerr << (yylsp[-3]) << ": warning: Anachronistic use of begin/end to surround generate schemes." << endl;
	}
      }
#line 7676 "parse.cc" /* yacc.c:1646  */
    break;

  case 358:
#line 2413 "./parse.y" /* yacc.c:1646  */
    {
	pform_start_generate_nblock((yylsp[-2]), (yyvsp[0].text));
      }
#line 7684 "parse.cc" /* yacc.c:1646  */
    break;

  case 359:
#line 2416 "./parse.y" /* yacc.c:1646  */
    { /* Detect and warn about anachronistic named begin/end use */
	if (generation_flag > GN_VER2001) {
	      warn_count += 1;
	      cerr << (yylsp[-6]) << ": warning: Anachronistic use of named begin/end to surround generate schemes." << endl;
	}
	pform_endgenerate();
      }
#line 7696 "parse.cc" /* yacc.c:1646  */
    break;

  case 360:
#line 2427 "./parse.y" /* yacc.c:1646  */
    { /* empty lists are legal syntax. */ }
#line 7702 "parse.cc" /* yacc.c:1646  */
    break;

  case 361:
#line 2430 "./parse.y" /* yacc.c:1646  */
    {
		}
#line 7709 "parse.cc" /* yacc.c:1646  */
    break;

  case 362:
#line 2434 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in specify block");
		  yyerrok;
		}
#line 7717 "parse.cc" /* yacc.c:1646  */
    break;

  case 363:
#line 2443 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: missing endmodule or attempt to "
		              "nest modules.");
		  pform_error_nested_modules();
		  yyerrok;
		}
#line 7727 "parse.cc" /* yacc.c:1646  */
    break;

  case 364:
#line 2450 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[0]), "error: invalid module item.");
		  yyerrok;
		}
#line 7735 "parse.cc" /* yacc.c:1646  */
    break;

  case 365:
#line 2455 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-4]), "error: syntax error in left side "
			  "of continuous assignment.");
		  yyerrok;
		}
#line 7744 "parse.cc" /* yacc.c:1646  */
    break;

  case 366:
#line 2461 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in "
			  "continuous assignment");
		  yyerrok;
		}
#line 7753 "parse.cc" /* yacc.c:1646  */
    break;

  case 367:
#line 2467 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: I give up on this "
			  "function definition.");
		  yyerrok;
		}
#line 7762 "parse.cc" /* yacc.c:1646  */
    break;

  case 368:
#line 2476 "./parse.y" /* yacc.c:1646  */
    { perm_string tmp3 = lex_strings.make((yyvsp[-6].text));
		  perm_string tmp5 = lex_strings.make((yyvsp[-4].text));
		  pform_set_attrib(tmp3, tmp5, (yyvsp[-2].text));
		  delete[] (yyvsp[-6].text);
		  delete[] (yyvsp[-4].text);
		}
#line 7773 "parse.cc" /* yacc.c:1646  */
    break;

  case 369:
#line 2483 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-4]), "error: Malformed $attribute parameter list."); }
#line 7779 "parse.cc" /* yacc.c:1646  */
    break;

  case 370:
#line 2487 "./parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 7785 "parse.cc" /* yacc.c:1646  */
    break;

  case 371:
#line 2488 "./parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false;}
#line 7791 "parse.cc" /* yacc.c:1646  */
    break;

  case 372:
#line 2491 "./parse.y" /* yacc.c:1646  */
    { pform_start_generate_if((yylsp[-3]), (yyvsp[-1].expr)); }
#line 7797 "parse.cc" /* yacc.c:1646  */
    break;

  case 375:
#line 2499 "./parse.y" /* yacc.c:1646  */
    { pform_generate_case_item((yylsp[-1]), (yyvsp[-1].exprs)); }
#line 7803 "parse.cc" /* yacc.c:1646  */
    break;

  case 376:
#line 2500 "./parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 7809 "parse.cc" /* yacc.c:1646  */
    break;

  case 377:
#line 2501 "./parse.y" /* yacc.c:1646  */
    { pform_generate_case_item((yylsp[-1]), 0); }
#line 7815 "parse.cc" /* yacc.c:1646  */
    break;

  case 378:
#line 2502 "./parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 7821 "parse.cc" /* yacc.c:1646  */
    break;

  case 385:
#line 2525 "./parse.y" /* yacc.c:1646  */
    { pform_generate_block_name((yyvsp[-2].text)); }
#line 7827 "parse.cc" /* yacc.c:1646  */
    break;

  case 388:
#line 2540 "./parse.y" /* yacc.c:1646  */
    { net_decl_assign_t*tmp = new net_decl_assign_t;
	tmp->next = tmp;
	tmp->name = lex_strings.make((yyvsp[-2].text));
	tmp->expr = (yyvsp[0].expr);
	delete[](yyvsp[-2].text);
	(yyval.net_decl_assign) = tmp;
      }
#line 7839 "parse.cc" /* yacc.c:1646  */
    break;

  case 389:
#line 2551 "./parse.y" /* yacc.c:1646  */
    { net_decl_assign_t*tmp = (yyvsp[-2].net_decl_assign);
		  (yyvsp[0].net_decl_assign)->next = tmp->next;
		  tmp->next = (yyvsp[0].net_decl_assign);
		  (yyval.net_decl_assign) = tmp;
		}
#line 7849 "parse.cc" /* yacc.c:1646  */
    break;

  case 390:
#line 2557 "./parse.y" /* yacc.c:1646  */
    { (yyval.net_decl_assign) = (yyvsp[0].net_decl_assign);
		}
#line 7856 "parse.cc" /* yacc.c:1646  */
    break;

  case 391:
#line 2562 "./parse.y" /* yacc.c:1646  */
    { (yyval.datatype) = IVL_VT_LOGIC; }
#line 7862 "parse.cc" /* yacc.c:1646  */
    break;

  case 392:
#line 2563 "./parse.y" /* yacc.c:1646  */
    { (yyval.datatype) = IVL_VT_BOOL; }
#line 7868 "parse.cc" /* yacc.c:1646  */
    break;

  case 393:
#line 2564 "./parse.y" /* yacc.c:1646  */
    { (yyval.datatype) = IVL_VT_REAL; }
#line 7874 "parse.cc" /* yacc.c:1646  */
    break;

  case 394:
#line 2567 "./parse.y" /* yacc.c:1646  */
    { (yyval.datatype) = (yyvsp[0].datatype); }
#line 7880 "parse.cc" /* yacc.c:1646  */
    break;

  case 395:
#line 2567 "./parse.y" /* yacc.c:1646  */
    { (yyval.datatype) = IVL_VT_NO_TYPE; }
#line 7886 "parse.cc" /* yacc.c:1646  */
    break;

  case 396:
#line 2570 "./parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::WIRE; }
#line 7892 "parse.cc" /* yacc.c:1646  */
    break;

  case 397:
#line 2571 "./parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRI; }
#line 7898 "parse.cc" /* yacc.c:1646  */
    break;

  case 398:
#line 2572 "./parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRI1; }
#line 7904 "parse.cc" /* yacc.c:1646  */
    break;

  case 399:
#line 2573 "./parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::SUPPLY0; }
#line 7910 "parse.cc" /* yacc.c:1646  */
    break;

  case 400:
#line 2574 "./parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::WAND; }
#line 7916 "parse.cc" /* yacc.c:1646  */
    break;

  case 401:
#line 2575 "./parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRIAND; }
#line 7922 "parse.cc" /* yacc.c:1646  */
    break;

  case 402:
#line 2576 "./parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRI0; }
#line 7928 "parse.cc" /* yacc.c:1646  */
    break;

  case 403:
#line 2577 "./parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::SUPPLY1; }
#line 7934 "parse.cc" /* yacc.c:1646  */
    break;

  case 404:
#line 2578 "./parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::WOR; }
#line 7940 "parse.cc" /* yacc.c:1646  */
    break;

  case 405:
#line 2579 "./parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRIOR; }
#line 7946 "parse.cc" /* yacc.c:1646  */
    break;

  case 406:
#line 2580 "./parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::UWIRE;
		      cerr << (yylsp[0]).text << ":" << (yylsp[0]).first_line << ": warning: "
		              "'wone' is deprecated, please use 'uwire' "
		              "instead." << endl;
		    }
#line 7956 "parse.cc" /* yacc.c:1646  */
    break;

  case 407:
#line 2585 "./parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::UWIRE; }
#line 7962 "parse.cc" /* yacc.c:1646  */
    break;

  case 408:
#line 2589 "./parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::REG; }
#line 7968 "parse.cc" /* yacc.c:1646  */
    break;

  case 410:
#line 2598 "./parse.y" /* yacc.c:1646  */
    { param_active_range = (yyvsp[0].exprs);
        param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 7977 "parse.cc" /* yacc.c:1646  */
    break;

  case 411:
#line 2603 "./parse.y" /* yacc.c:1646  */
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 7986 "parse.cc" /* yacc.c:1646  */
    break;

  case 412:
#line 2608 "./parse.y" /* yacc.c:1646  */
    { param_active_range = (yyvsp[0].exprs);
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      }
#line 7995 "parse.cc" /* yacc.c:1646  */
    break;

  case 413:
#line 2613 "./parse.y" /* yacc.c:1646  */
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8004 "parse.cc" /* yacc.c:1646  */
    break;

  case 414:
#line 2618 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum(integer_width-1, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The default range is [31:0] */
        param_active_range = range_stub;
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8020 "parse.cc" /* yacc.c:1646  */
    break;

  case 415:
#line 2630 "./parse.y" /* yacc.c:1646  */
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8029 "parse.cc" /* yacc.c:1646  */
    break;

  case 416:
#line 2635 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum((uint64_t)63, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The range is [63:0] */
        param_active_range = range_stub;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8045 "parse.cc" /* yacc.c:1646  */
    break;

  case 417:
#line 2647 "./parse.y" /* yacc.c:1646  */
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8054 "parse.cc" /* yacc.c:1646  */
    break;

  case 418:
#line 2652 "./parse.y" /* yacc.c:1646  */
    { param_active_range = 0;
	param_active_signed = true;
	param_active_type = IVL_VT_REAL;
      }
#line 8063 "parse.cc" /* yacc.c:1646  */
    break;

  case 419:
#line 2657 "./parse.y" /* yacc.c:1646  */
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8072 "parse.cc" /* yacc.c:1646  */
    break;

  case 422:
#line 2670 "./parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[-1].expr);
	pform_set_parameter((yylsp[-3]), lex_strings.make((yyvsp[-3].text)), param_active_type,
			    param_active_signed, param_active_range, tmp, (yyvsp[0].value_range));
	delete[](yyvsp[-3].text);
      }
#line 8082 "parse.cc" /* yacc.c:1646  */
    break;

  case 423:
#line 2677 "./parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = (yyvsp[0].value_range); }
#line 8088 "parse.cc" /* yacc.c:1646  */
    break;

  case 424:
#line 2677 "./parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = 0; }
#line 8094 "parse.cc" /* yacc.c:1646  */
    break;

  case 425:
#line 2681 "./parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = (yyvsp[0].value_range); (yyval.value_range)->next = (yyvsp[-1].value_range); }
#line 8100 "parse.cc" /* yacc.c:1646  */
    break;

  case 426:
#line 2683 "./parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = (yyvsp[0].value_range); (yyval.value_range)->next = 0; }
#line 8106 "parse.cc" /* yacc.c:1646  */
    break;

  case 427:
#line 2688 "./parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[-5].flag), false, (yyvsp[-3].expr), false, (yyvsp[-1].expr)); }
#line 8112 "parse.cc" /* yacc.c:1646  */
    break;

  case 428:
#line 2690 "./parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[-5].flag), false, (yyvsp[-3].expr), true, (yyvsp[-1].expr)); }
#line 8118 "parse.cc" /* yacc.c:1646  */
    break;

  case 429:
#line 2692 "./parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[-5].flag), true, (yyvsp[-3].expr), false, (yyvsp[-1].expr)); }
#line 8124 "parse.cc" /* yacc.c:1646  */
    break;

  case 430:
#line 2694 "./parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[-5].flag), true, (yyvsp[-3].expr), true, (yyvsp[-1].expr)); }
#line 8130 "parse.cc" /* yacc.c:1646  */
    break;

  case 431:
#line 2696 "./parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range(true, false, (yyvsp[0].expr), false, (yyvsp[0].expr)); }
#line 8136 "parse.cc" /* yacc.c:1646  */
    break;

  case 432:
#line 2700 "./parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 8142 "parse.cc" /* yacc.c:1646  */
    break;

  case 433:
#line 2701 "./parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 8148 "parse.cc" /* yacc.c:1646  */
    break;

  case 434:
#line 2702 "./parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 8154 "parse.cc" /* yacc.c:1646  */
    break;

  case 435:
#line 2703 "./parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 8160 "parse.cc" /* yacc.c:1646  */
    break;

  case 436:
#line 2706 "./parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 8166 "parse.cc" /* yacc.c:1646  */
    break;

  case 437:
#line 2706 "./parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 8172 "parse.cc" /* yacc.c:1646  */
    break;

  case 438:
#line 2715 "./parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[0].expr);
	pform_set_localparam((yylsp[-2]), lex_strings.make((yyvsp[-2].text)),
			     param_active_type,
			     param_active_signed,
			     param_active_range, tmp);
	delete[](yyvsp[-2].text);
      }
#line 8184 "parse.cc" /* yacc.c:1646  */
    break;

  case 440:
#line 2727 "./parse.y" /* yacc.c:1646  */
    { param_active_range = (yyvsp[0].exprs);
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8193 "parse.cc" /* yacc.c:1646  */
    break;

  case 441:
#line 2732 "./parse.y" /* yacc.c:1646  */
    { param_active_range = 0;
        param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8202 "parse.cc" /* yacc.c:1646  */
    break;

  case 442:
#line 2737 "./parse.y" /* yacc.c:1646  */
    { param_active_range = (yyvsp[0].exprs);
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8211 "parse.cc" /* yacc.c:1646  */
    break;

  case 443:
#line 2742 "./parse.y" /* yacc.c:1646  */
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8220 "parse.cc" /* yacc.c:1646  */
    break;

  case 444:
#line 2747 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum(integer_width-1, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The default range is [31:0] */
        param_active_range = range_stub;
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8236 "parse.cc" /* yacc.c:1646  */
    break;

  case 445:
#line 2759 "./parse.y" /* yacc.c:1646  */
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8245 "parse.cc" /* yacc.c:1646  */
    break;

  case 446:
#line 2764 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum((uint64_t)63, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The range is [63:0] */
        param_active_range = range_stub;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8261 "parse.cc" /* yacc.c:1646  */
    break;

  case 447:
#line 2776 "./parse.y" /* yacc.c:1646  */
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8270 "parse.cc" /* yacc.c:1646  */
    break;

  case 448:
#line 2781 "./parse.y" /* yacc.c:1646  */
    { param_active_range = 0;
	param_active_signed = true;
	param_active_type = IVL_VT_REAL;
      }
#line 8279 "parse.cc" /* yacc.c:1646  */
    break;

  case 449:
#line 2786 "./parse.y" /* yacc.c:1646  */
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8288 "parse.cc" /* yacc.c:1646  */
    break;

  case 452:
#line 2815 "./parse.y" /* yacc.c:1646  */
    { struct parmvalue_t*tmp = new struct parmvalue_t;
		  tmp->by_order = (yyvsp[-1].exprs);
		  tmp->by_name = 0;
		  (yyval.parmvalue) = tmp;
		}
#line 8298 "parse.cc" /* yacc.c:1646  */
    break;

  case 453:
#line 2821 "./parse.y" /* yacc.c:1646  */
    { struct parmvalue_t*tmp = new struct parmvalue_t;
		  tmp->by_order = 0;
		  tmp->by_name = (yyvsp[-1].named_pexprs);
		  (yyval.parmvalue) = tmp;
		}
#line 8308 "parse.cc" /* yacc.c:1646  */
    break;

  case 454:
#line 2827 "./parse.y" /* yacc.c:1646  */
    { assert((yyvsp[0].number));
		  PENumber*tmp = new PENumber((yyvsp[0].number));
		  FILE_NAME(tmp, (yylsp[-1]));

		  struct parmvalue_t*lst = new struct parmvalue_t;
		  lst->by_order = new svector<PExpr*>(1);
		  (*lst->by_order)[0] = tmp;
		  lst->by_name = 0;
		  (yyval.parmvalue) = lst;
		  based_size = 0;
		}
#line 8324 "parse.cc" /* yacc.c:1646  */
    break;

  case 455:
#line 2839 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: syntax error in parameter value "
			  "assignment list.");
		  (yyval.parmvalue) = 0;
		}
#line 8333 "parse.cc" /* yacc.c:1646  */
    break;

  case 456:
#line 2844 "./parse.y" /* yacc.c:1646  */
    { (yyval.parmvalue) = 0; }
#line 8339 "parse.cc" /* yacc.c:1646  */
    break;

  case 457:
#line 2849 "./parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-3].text));
		  tmp->parm = (yyvsp[-1].expr);
		  delete[](yyvsp[-3].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 8350 "parse.cc" /* yacc.c:1646  */
    break;

  case 458:
#line 2856 "./parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-2].text));
		  tmp->parm = 0;
		  delete[](yyvsp[-2].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 8361 "parse.cc" /* yacc.c:1646  */
    break;

  case 459:
#line 2866 "./parse.y" /* yacc.c:1646  */
    { svector<named_pexpr_t*>*tmp = new svector<named_pexpr_t*>(1);
		  (*tmp)[0] = (yyvsp[0].named_pexpr);
		  (yyval.named_pexprs) = tmp;
		}
#line 8370 "parse.cc" /* yacc.c:1646  */
    break;

  case 460:
#line 2871 "./parse.y" /* yacc.c:1646  */
    { svector<named_pexpr_t*>*tmp =
			new svector<named_pexpr_t*>(*(yyvsp[-2].named_pexprs),(yyvsp[0].named_pexpr));
		  delete (yyvsp[-2].named_pexprs);
		  (yyval.named_pexprs) = tmp;
		}
#line 8380 "parse.cc" /* yacc.c:1646  */
    break;

  case 461:
#line 2894 "./parse.y" /* yacc.c:1646  */
    { (yyval.mport) = (yyvsp[0].mport); }
#line 8386 "parse.cc" /* yacc.c:1646  */
    break;

  case 462:
#line 2902 "./parse.y" /* yacc.c:1646  */
    { Module::port_t*tmp = (yyvsp[-1].mport);
		  tmp->name = lex_strings.make((yyvsp[-3].text));
		  delete[](yyvsp[-3].text);
		  (yyval.mport) = tmp;
		}
#line 8396 "parse.cc" /* yacc.c:1646  */
    break;

  case 463:
#line 2913 "./parse.y" /* yacc.c:1646  */
    { Module::port_t*tmp = (yyvsp[-1].mport);
		  tmp->name = perm_string();
		  (yyval.mport) = tmp;
		}
#line 8405 "parse.cc" /* yacc.c:1646  */
    break;

  case 464:
#line 2922 "./parse.y" /* yacc.c:1646  */
    { Module::port_t*tmp = (yyvsp[-2].mport);
		  tmp->name = lex_strings.make((yyvsp[-5].text));
		  delete[](yyvsp[-5].text);
		  (yyval.mport) = tmp;
		}
#line 8415 "parse.cc" /* yacc.c:1646  */
    break;

  case 465:
#line 2930 "./parse.y" /* yacc.c:1646  */
    { (yyval.mport) = (yyvsp[0].mport); }
#line 8421 "parse.cc" /* yacc.c:1646  */
    break;

  case 466:
#line 2931 "./parse.y" /* yacc.c:1646  */
    { (yyval.mport) = 0; }
#line 8427 "parse.cc" /* yacc.c:1646  */
    break;

  case 467:
#line 2948 "./parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	  perm_string name = lex_strings.make((yyvsp[0].text));
	  ptmp = pform_module_port_reference(name, (yylsp[0]).text, (yylsp[0]).first_line);
	  delete[](yyvsp[0].text);
	  (yyval.mport) = ptmp;
	}
#line 8438 "parse.cc" /* yacc.c:1646  */
    break;

  case 468:
#line 2956 "./parse.y" /* yacc.c:1646  */
    { index_component_t itmp;
	  itmp.sel = index_component_t::SEL_PART;
	  itmp.msb = (yyvsp[-3].expr);
	  itmp.lsb = (yyvsp[-1].expr);

	  name_component_t ntmp (lex_strings.make((yyvsp[-5].text)));
	  ntmp.index.push_back(itmp);

	  pform_name_t pname;
	  pname.push_back(ntmp);

	  PEIdent*wtmp = new PEIdent(pname);
	  FILE_NAME(wtmp, (yylsp[-5]));

	  Module::port_t*ptmp = new Module::port_t;
	  ptmp->name = perm_string();
	  ptmp->expr.push_back(wtmp);

	  delete[](yyvsp[-5].text);
	  (yyval.mport) = ptmp;
	}
#line 8464 "parse.cc" /* yacc.c:1646  */
    break;

  case 469:
#line 2979 "./parse.y" /* yacc.c:1646  */
    { index_component_t itmp;
	  itmp.sel = index_component_t::SEL_BIT;
	  itmp.msb = (yyvsp[-1].expr);
	  itmp.lsb = 0;

	  name_component_t ntmp (lex_strings.make((yyvsp[-3].text)));
	  ntmp.index.push_back(itmp);

	  pform_name_t pname;
	  pname.push_back(ntmp);

	  PEIdent*tmp = new PEIdent(pname);
	  FILE_NAME(tmp, (yylsp[-3]));

	  Module::port_t*ptmp = new Module::port_t;
	  ptmp->name = perm_string();
	  ptmp->expr.push_back(tmp);
	  delete[](yyvsp[-3].text);
	  (yyval.mport) = ptmp;
	}
#line 8489 "parse.cc" /* yacc.c:1646  */
    break;

  case 470:
#line 3001 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: invalid port bit select");
	  Module::port_t*ptmp = new Module::port_t;
	  PEIdent*wtmp = new PEIdent(lex_strings.make((yyvsp[-3].text)));
	  FILE_NAME(wtmp, (yylsp[-3]));
	  ptmp->name = lex_strings.make((yyvsp[-3].text));
	  ptmp->expr.push_back(wtmp);
	  delete[](yyvsp[-3].text);
	  (yyval.mport) = ptmp;
	}
#line 8503 "parse.cc" /* yacc.c:1646  */
    break;

  case 471:
#line 3015 "./parse.y" /* yacc.c:1646  */
    { (yyval.mport) = (yyvsp[0].mport); }
#line 8509 "parse.cc" /* yacc.c:1646  */
    break;

  case 472:
#line 3017 "./parse.y" /* yacc.c:1646  */
    { Module::port_t*tmp = (yyvsp[-2].mport);
		  append(tmp->expr, (yyvsp[0].mport)->expr);
		  delete (yyvsp[0].mport);
		  (yyval.mport) = tmp;
		}
#line 8519 "parse.cc" /* yacc.c:1646  */
    break;

  case 473:
#line 3030 "./parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-3].text));
		  tmp->parm = (yyvsp[-1].expr);
		  delete[](yyvsp[-3].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 8530 "parse.cc" /* yacc.c:1646  */
    break;

  case 474:
#line 3037 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: invalid port connection expression.");
		  named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-3].text));
		  tmp->parm = 0;
		  delete[](yyvsp[-3].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 8542 "parse.cc" /* yacc.c:1646  */
    break;

  case 475:
#line 3045 "./parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-2].text));
		  tmp->parm = 0;
		  delete[](yyvsp[-2].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 8553 "parse.cc" /* yacc.c:1646  */
    break;

  case 476:
#line 3055 "./parse.y" /* yacc.c:1646  */
    { svector<named_pexpr_t*>*tmp;
		  tmp = new svector<named_pexpr_t*>(*(yyvsp[-2].named_pexprs), (yyvsp[0].named_pexpr));
		  delete (yyvsp[-2].named_pexprs);
		  (yyval.named_pexprs) = tmp;
		}
#line 8563 "parse.cc" /* yacc.c:1646  */
    break;

  case 477:
#line 3061 "./parse.y" /* yacc.c:1646  */
    { svector<named_pexpr_t*>*tmp = new svector<named_pexpr_t*>(1);
		  (*tmp)[0] = (yyvsp[0].named_pexpr);
		  (yyval.named_pexprs) = tmp;
		}
#line 8572 "parse.cc" /* yacc.c:1646  */
    break;

  case 478:
#line 3068 "./parse.y" /* yacc.c:1646  */
    { (yyval.porttype) = NetNet::PINPUT; }
#line 8578 "parse.cc" /* yacc.c:1646  */
    break;

  case 479:
#line 3069 "./parse.y" /* yacc.c:1646  */
    { (yyval.porttype) = NetNet::POUTPUT; }
#line 8584 "parse.cc" /* yacc.c:1646  */
    break;

  case 480:
#line 3070 "./parse.y" /* yacc.c:1646  */
    { (yyval.porttype) = NetNet::PINOUT; }
#line 8590 "parse.cc" /* yacc.c:1646  */
    break;

  case 481:
#line 3075 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*> (2);
		  (*tmp)[0] = (yyvsp[-3].expr);
		  (*tmp)[1] = (yyvsp[-1].expr);
		  (yyval.exprs) = tmp;
		}
#line 8600 "parse.cc" /* yacc.c:1646  */
    break;

  case 483:
#line 3084 "./parse.y" /* yacc.c:1646  */
    { (yyval.exprs) = 0; }
#line 8606 "parse.cc" /* yacc.c:1646  */
    break;

  case 484:
#line 3087 "./parse.y" /* yacc.c:1646  */
    { (yyval.dimensions) = 0; }
#line 8612 "parse.cc" /* yacc.c:1646  */
    break;

  case 485:
#line 3088 "./parse.y" /* yacc.c:1646  */
    { (yyval.dimensions) = (yyvsp[0].dimensions); }
#line 8618 "parse.cc" /* yacc.c:1646  */
    break;

  case 486:
#line 3092 "./parse.y" /* yacc.c:1646  */
    { list<index_component_t> *tmp = new list<index_component_t>;
		  index_component_t index;
		  index.msb = (yyvsp[-3].expr);
		  index.lsb = (yyvsp[-1].expr);
		  tmp->push_back(index);
		  (yyval.dimensions) = tmp;
		}
#line 8630 "parse.cc" /* yacc.c:1646  */
    break;

  case 487:
#line 3100 "./parse.y" /* yacc.c:1646  */
    { list<index_component_t> *tmp = (yyvsp[-5].dimensions);
		  index_component_t index;
		  index.msb = (yyvsp[-3].expr);
		  index.lsb = (yyvsp[-1].expr);
		  tmp->push_back(index);
		  (yyval.dimensions) = tmp;
		}
#line 8642 "parse.cc" /* yacc.c:1646  */
    break;

  case 488:
#line 3110 "./parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = (yyvsp[0].exprs); (yyval.function_type).type = PTF_REG; }
#line 8648 "parse.cc" /* yacc.c:1646  */
    break;

  case 489:
#line 3111 "./parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = (yyvsp[0].exprs); (yyval.function_type).type = PTF_REG_S; }
#line 8654 "parse.cc" /* yacc.c:1646  */
    break;

  case 490:
#line 3112 "./parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_INTEGER; }
#line 8660 "parse.cc" /* yacc.c:1646  */
    break;

  case 491:
#line 3113 "./parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_REAL; }
#line 8666 "parse.cc" /* yacc.c:1646  */
    break;

  case 492:
#line 3114 "./parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_REALTIME; }
#line 8672 "parse.cc" /* yacc.c:1646  */
    break;

  case 493:
#line 3115 "./parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_TIME; }
#line 8678 "parse.cc" /* yacc.c:1646  */
    break;

  case 494:
#line 3116 "./parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_REG; }
#line 8684 "parse.cc" /* yacc.c:1646  */
    break;

  case 495:
#line 3126 "./parse.y" /* yacc.c:1646  */
    { perm_string ident_name = lex_strings.make((yyvsp[-1].text));
	pform_makewire((yylsp[-1]), ident_name, NetNet::REG,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	if ((yyvsp[0].dimensions) != 0) {
	      index_component_t index;
	      if ((yyvsp[0].dimensions)->size() > 1) {
		    yyerror((yylsp[0]), "sorry: only 1 dimensional arrays "
			    "are currently supported.");
	      }
	      index = (yyvsp[0].dimensions)->front();
	      pform_set_reg_idx(ident_name, index.msb, index.lsb);
	      delete (yyvsp[0].dimensions);
	}
	(yyval.text) = (yyvsp[-1].text);
      }
#line 8704 "parse.cc" /* yacc.c:1646  */
    break;

  case 496:
#line 3142 "./parse.y" /* yacc.c:1646  */
    { perm_string ident_name = lex_strings.make((yyvsp[-2].text));
	pform_makewire((yylsp[-2]), ident_name, NetNet::REG,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	pform_make_reginit((yylsp[-2]), ident_name, (yyvsp[0].expr));
	(yyval.text) = (yyvsp[-2].text);
      }
#line 8715 "parse.cc" /* yacc.c:1646  */
    break;

  case 497:
#line 3152 "./parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 8725 "parse.cc" /* yacc.c:1646  */
    break;

  case 498:
#line 3158 "./parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 8735 "parse.cc" /* yacc.c:1646  */
    break;

  case 499:
#line 3167 "./parse.y" /* yacc.c:1646  */
    { perm_string name = lex_strings.make((yyvsp[-1].text));
        pform_makewire((yylsp[-1]), name, NetNet::REG, NetNet::NOT_A_PORT, IVL_VT_REAL, 0);
        if ((yyvsp[0].dimensions) != 0) {
	      index_component_t index;
	      if ((yyvsp[0].dimensions)->size() > 1) {
		    yyerror((yylsp[0]), "sorry: only 1 dimensional arrays "
			    "are currently supported.");
	      }
	      index = (yyvsp[0].dimensions)->front();
	      pform_set_reg_idx(name, index.msb, index.lsb);
	      delete (yyvsp[0].dimensions);
        }
	(yyval.text) = (yyvsp[-1].text);
      }
#line 8754 "parse.cc" /* yacc.c:1646  */
    break;

  case 500:
#line 3182 "./parse.y" /* yacc.c:1646  */
    { perm_string name = lex_strings.make((yyvsp[-2].text));
	pform_makewire((yylsp[-2]), name, NetNet::REG, NetNet::NOT_A_PORT, IVL_VT_REAL, 0);
	pform_make_reginit((yylsp[-2]), name, (yyvsp[0].expr));
	(yyval.text) = (yyvsp[-2].text);
      }
#line 8764 "parse.cc" /* yacc.c:1646  */
    break;

  case 501:
#line 3191 "./parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
	tmp->push_back(lex_strings.make((yyvsp[0].text)));
	(yyval.perm_strings) = tmp;
	delete[](yyvsp[0].text);
      }
#line 8774 "parse.cc" /* yacc.c:1646  */
    break;

  case 502:
#line 3197 "./parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
	tmp->push_back(lex_strings.make((yyvsp[0].text)));
	(yyval.perm_strings) = tmp;
	delete[](yyvsp[0].text);
      }
#line 8784 "parse.cc" /* yacc.c:1646  */
    break;

  case 503:
#line 3206 "./parse.y" /* yacc.c:1646  */
    { perm_string name = lex_strings.make((yyvsp[-1].text));
	pform_makewire((yylsp[-1]), name, NetNet::IMPLICIT,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	if ((yyvsp[0].dimensions) != 0) {
	      index_component_t index;
	      if ((yyvsp[0].dimensions)->size() > 1) {
		    yyerror((yylsp[0]), "sorry: only 1 dimensional arrays "
			    "are currently supported.");
	      }
	      index = (yyvsp[0].dimensions)->front();
	      pform_set_reg_idx(name, index.msb, index.lsb);
	      delete (yyvsp[0].dimensions);
	}
	(yyval.text) = (yyvsp[-1].text);
      }
#line 8804 "parse.cc" /* yacc.c:1646  */
    break;

  case 504:
#line 3225 "./parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 8814 "parse.cc" /* yacc.c:1646  */
    break;

  case 505:
#line 3231 "./parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 8824 "parse.cc" /* yacc.c:1646  */
    break;

  case 507:
#line 3241 "./parse.y" /* yacc.c:1646  */
    { pform_module_specify_path((yyvsp[-1].specpath));
		}
#line 8831 "parse.cc" /* yacc.c:1646  */
    break;

  case 508:
#line 3244 "./parse.y" /* yacc.c:1646  */
    { pform_module_specify_path((yyvsp[-1].specpath));
		}
#line 8838 "parse.cc" /* yacc.c:1646  */
    break;

  case 509:
#line 3247 "./parse.y" /* yacc.c:1646  */
    { PSpecPath*tmp = (yyvsp[-1].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = (yyvsp[-3].expr);
		  }
		  pform_module_specify_path(tmp);
		}
#line 8850 "parse.cc" /* yacc.c:1646  */
    break;

  case 510:
#line 3255 "./parse.y" /* yacc.c:1646  */
    { PSpecPath*tmp = (yyvsp[-1].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = (yyvsp[-3].expr);
		  }
		  pform_module_specify_path(tmp);
		}
#line 8862 "parse.cc" /* yacc.c:1646  */
    break;

  case 511:
#line 3263 "./parse.y" /* yacc.c:1646  */
    { PSpecPath*tmp = (yyvsp[-1].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = 0;
		  }
		  pform_module_specify_path(tmp);
		}
#line 8874 "parse.cc" /* yacc.c:1646  */
    break;

  case 512:
#line 3272 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 8882 "parse.cc" /* yacc.c:1646  */
    break;

  case 513:
#line 3277 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8889 "parse.cc" /* yacc.c:1646  */
    break;

  case 514:
#line 3281 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 8897 "parse.cc" /* yacc.c:1646  */
    break;

  case 515:
#line 3286 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8904 "parse.cc" /* yacc.c:1646  */
    break;

  case 516:
#line 3290 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8911 "parse.cc" /* yacc.c:1646  */
    break;

  case 517:
#line 3294 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 8919 "parse.cc" /* yacc.c:1646  */
    break;

  case 518:
#line 3299 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8926 "parse.cc" /* yacc.c:1646  */
    break;

  case 519:
#line 3303 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8933 "parse.cc" /* yacc.c:1646  */
    break;

  case 520:
#line 3307 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 8941 "parse.cc" /* yacc.c:1646  */
    break;

  case 521:
#line 3312 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8948 "parse.cc" /* yacc.c:1646  */
    break;

  case 522:
#line 3316 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8955 "parse.cc" /* yacc.c:1646  */
    break;

  case 523:
#line 3320 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 8963 "parse.cc" /* yacc.c:1646  */
    break;

  case 524:
#line 3324 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
		}
#line 8970 "parse.cc" /* yacc.c:1646  */
    break;

  case 525:
#line 3327 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings);
		}
#line 8977 "parse.cc" /* yacc.c:1646  */
    break;

  case 526:
#line 3330 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings);
		}
#line 8984 "parse.cc" /* yacc.c:1646  */
    break;

  case 527:
#line 3333 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings);
		}
#line 8991 "parse.cc" /* yacc.c:1646  */
    break;

  case 528:
#line 3336 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings);
		}
#line 8998 "parse.cc" /* yacc.c:1646  */
    break;

  case 531:
#line 3347 "./parse.y" /* yacc.c:1646  */
    { (yyval.specpath) = pform_assign_path_delay((yyvsp[-4].specpath), (yyvsp[-1].exprs)); }
#line 9004 "parse.cc" /* yacc.c:1646  */
    break;

  case 532:
#line 3349 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[0].expr);
		  (yyval.specpath) = pform_assign_path_delay((yyvsp[-2].specpath), tmp);
		}
#line 9013 "parse.cc" /* yacc.c:1646  */
    break;

  case 533:
#line 3355 "./parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 9019 "parse.cc" /* yacc.c:1646  */
    break;

  case 534:
#line 3355 "./parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 9025 "parse.cc" /* yacc.c:1646  */
    break;

  case 535:
#line 3360 "./parse.y" /* yacc.c:1646  */
    { int edge_flag = 0;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[-9]), edge_flag, (yyvsp[-8].perm_strings), (yyvsp[-7].letter), false, (yyvsp[-4].perm_strings), (yyvsp[-2].expr)); }
#line 9032 "parse.cc" /* yacc.c:1646  */
    break;

  case 536:
#line 3364 "./parse.y" /* yacc.c:1646  */
    { int edge_flag = (yyvsp[-9].flag)? 1 : -1;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[-10]), edge_flag, (yyvsp[-8].perm_strings), (yyvsp[-7].letter), false, (yyvsp[-4].perm_strings), (yyvsp[-2].expr));}
#line 9039 "parse.cc" /* yacc.c:1646  */
    break;

  case 537:
#line 3368 "./parse.y" /* yacc.c:1646  */
    { int edge_flag = 0;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[-9]), edge_flag, (yyvsp[-8].perm_strings), (yyvsp[-7].letter), true, (yyvsp[-4].perm_strings), (yyvsp[-2].expr)); }
#line 9046 "parse.cc" /* yacc.c:1646  */
    break;

  case 538:
#line 3372 "./parse.y" /* yacc.c:1646  */
    { int edge_flag = (yyvsp[-9].flag)? 1 : -1;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[-10]), edge_flag, (yyvsp[-8].perm_strings), (yyvsp[-7].letter), true, (yyvsp[-4].perm_strings), (yyvsp[-2].expr)); }
#line 9053 "parse.cc" /* yacc.c:1646  */
    break;

  case 542:
#line 3384 "./parse.y" /* yacc.c:1646  */
    { (yyval.specpath) = pform_assign_path_delay((yyvsp[-4].specpath), (yyvsp[-1].exprs)); }
#line 9059 "parse.cc" /* yacc.c:1646  */
    break;

  case 543:
#line 3386 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[0].expr);
		  (yyval.specpath) = pform_assign_path_delay((yyvsp[-2].specpath), tmp);
		}
#line 9068 "parse.cc" /* yacc.c:1646  */
    break;

  case 544:
#line 3391 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "Syntax error in delay value list.");
		  yyerrok;
		  (yyval.specpath) = 0;
		}
#line 9077 "parse.cc" /* yacc.c:1646  */
    break;

  case 545:
#line 3400 "./parse.y" /* yacc.c:1646  */
    { (yyval.specpath) = pform_make_specify_path((yylsp[-5]), (yyvsp[-4].perm_strings), (yyvsp[-3].letter), false, (yyvsp[-1].perm_strings)); }
#line 9083 "parse.cc" /* yacc.c:1646  */
    break;

  case 546:
#line 3403 "./parse.y" /* yacc.c:1646  */
    { (yyval.specpath) = pform_make_specify_path((yylsp[-5]), (yyvsp[-4].perm_strings), (yyvsp[-3].letter), true, (yyvsp[-1].perm_strings)); }
#line 9089 "parse.cc" /* yacc.c:1646  */
    break;

  case 547:
#line 3405 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "Invalid simple path");
		  yyerrok;
		}
#line 9097 "parse.cc" /* yacc.c:1646  */
    break;

  case 548:
#line 3412 "./parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 9107 "parse.cc" /* yacc.c:1646  */
    break;

  case 549:
#line 3418 "./parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[-3].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[-3].text);
		}
#line 9117 "parse.cc" /* yacc.c:1646  */
    break;

  case 550:
#line 3424 "./parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 9127 "parse.cc" /* yacc.c:1646  */
    break;

  case 551:
#line 3430 "./parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-5].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[-3].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[-3].text);
		}
#line 9137 "parse.cc" /* yacc.c:1646  */
    break;

  case 552:
#line 3439 "./parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[0].expr);
		  pform_set_specparam(lex_strings.make((yyvsp[-2].text)), tmp);
		  delete[](yyvsp[-2].text);
		}
#line 9146 "parse.cc" /* yacc.c:1646  */
    break;

  case 553:
#line 3444 "./parse.y" /* yacc.c:1646  */
    { PExpr*tmp = 0;
		  switch (min_typ_max_flag) {
		      case MIN:
			tmp = (yyvsp[-4].expr);
			delete (yyvsp[-2].expr);
			delete (yyvsp[0].expr);
			break;
		      case TYP:
			delete (yyvsp[-4].expr);
			tmp = (yyvsp[-2].expr);
			delete (yyvsp[0].expr);
			break;
		      case MAX:
			delete (yyvsp[-4].expr);
			delete (yyvsp[-2].expr);
			tmp = (yyvsp[0].expr);
			break;
		  }
		  if (min_typ_max_warn > 0) {
		        cerr << tmp->get_fileline() << ": warning: choosing ";
		        switch (min_typ_max_flag) {
		            case MIN:
		              cerr << "min";
		              break;
		            case TYP:
		              cerr << "typ";
		              break;
		            case MAX:
		              cerr << "max";
		              break;
		        }
		        cerr << " expression." << endl;
		        min_typ_max_warn -= 1;
		  }
		  pform_set_specparam(lex_strings.make((yyvsp[-6].text)), tmp);
		  delete[](yyvsp[-6].text);
		}
#line 9188 "parse.cc" /* yacc.c:1646  */
    break;

  case 554:
#line 3482 "./parse.y" /* yacc.c:1646  */
    { delete[](yyvsp[-2].text);
		  delete (yyvsp[0].expr);
		}
#line 9196 "parse.cc" /* yacc.c:1646  */
    break;

  case 555:
#line 3486 "./parse.y" /* yacc.c:1646  */
    { delete[](yyvsp[-6].text);
		  delete (yyvsp[-3].expr);
		  delete (yyvsp[-1].expr);
		}
#line 9205 "parse.cc" /* yacc.c:1646  */
    break;

  case 558:
#line 3498 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '+'; }
#line 9211 "parse.cc" /* yacc.c:1646  */
    break;

  case 559:
#line 3499 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '-'; }
#line 9217 "parse.cc" /* yacc.c:1646  */
    break;

  case 560:
#line 3500 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 0;   }
#line 9223 "parse.cc" /* yacc.c:1646  */
    break;

  case 561:
#line 3505 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[0].expr); }
#line 9229 "parse.cc" /* yacc.c:1646  */
    break;

  case 562:
#line 3507 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[0].expr); }
#line 9235 "parse.cc" /* yacc.c:1646  */
    break;

  case 563:
#line 3509 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
      delete (yyvsp[0].expr);
    }
#line 9243 "parse.cc" /* yacc.c:1646  */
    break;

  case 564:
#line 3513 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
      delete (yyvsp[0].expr);
    }
#line 9251 "parse.cc" /* yacc.c:1646  */
    break;

  case 565:
#line 3517 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[0].expr); }
#line 9257 "parse.cc" /* yacc.c:1646  */
    break;

  case 566:
#line 3519 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
      delete (yyvsp[0].expr);
    }
#line 9265 "parse.cc" /* yacc.c:1646  */
    break;

  case 567:
#line 3523 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
      delete (yyvsp[0].expr);
    }
#line 9273 "parse.cc" /* yacc.c:1646  */
    break;

  case 568:
#line 3527 "./parse.y" /* yacc.c:1646  */
    { delete (yyvsp[0].expr); }
#line 9279 "parse.cc" /* yacc.c:1646  */
    break;

  case 571:
#line 3541 "./parse.y" /* yacc.c:1646  */
    {  }
#line 9285 "parse.cc" /* yacc.c:1646  */
    break;

  case 572:
#line 3543 "./parse.y" /* yacc.c:1646  */
    {  }
#line 9291 "parse.cc" /* yacc.c:1646  */
    break;

  case 573:
#line 3547 "./parse.y" /* yacc.c:1646  */
    { args_after_notifier = 0; }
#line 9297 "parse.cc" /* yacc.c:1646  */
    break;

  case 574:
#line 3549 "./parse.y" /* yacc.c:1646  */
    { args_after_notifier = 0; delete (yyvsp[0].pform_name); }
#line 9303 "parse.cc" /* yacc.c:1646  */
    break;

  case 575:
#line 3551 "./parse.y" /* yacc.c:1646  */
    {  args_after_notifier += 1; }
#line 9309 "parse.cc" /* yacc.c:1646  */
    break;

  case 576:
#line 3553 "./parse.y" /* yacc.c:1646  */
    { args_after_notifier += 1;
		  if (args_after_notifier >= 3)  {
                    cerr << (yylsp[0]) << ": warning: timing checks are not supported "
		                  "and delayed signal \"" << *(yyvsp[0].pform_name)
		         << "\" will not be driven." << endl;
		  }
                  delete (yyvsp[0].pform_name); }
#line 9321 "parse.cc" /* yacc.c:1646  */
    break;

  case 577:
#line 3562 "./parse.y" /* yacc.c:1646  */
    { args_after_notifier = 0; delete[](yyvsp[0].text); }
#line 9327 "parse.cc" /* yacc.c:1646  */
    break;

  case 578:
#line 3574 "./parse.y" /* yacc.c:1646  */
    { PCAssign*tmp = new PCAssign((yyvsp[-3].expr), (yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9336 "parse.cc" /* yacc.c:1646  */
    break;

  case 579:
#line 3580 "./parse.y" /* yacc.c:1646  */
    { PDeassign*tmp = new PDeassign((yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-2]));
		  (yyval.statement) = tmp;
		}
#line 9345 "parse.cc" /* yacc.c:1646  */
    break;

  case 580:
#line 3590 "./parse.y" /* yacc.c:1646  */
    { PForce*tmp = new PForce((yyvsp[-3].expr), (yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9354 "parse.cc" /* yacc.c:1646  */
    break;

  case 581:
#line 3595 "./parse.y" /* yacc.c:1646  */
    { PRelease*tmp = new PRelease((yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-2]));
		  (yyval.statement) = tmp;
		}
#line 9363 "parse.cc" /* yacc.c:1646  */
    break;

  case 582:
#line 3607 "./parse.y" /* yacc.c:1646  */
    { PBlock*tmp = new PBlock(PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[-2]));
	tmp->set_statement(*(yyvsp[-1].statement_list));
	delete (yyvsp[-1].statement_list);
	(yyval.statement) = tmp;
      }
#line 9374 "parse.cc" /* yacc.c:1646  */
    break;

  case 583:
#line 3614 "./parse.y" /* yacc.c:1646  */
    { PBlock*tmp = pform_push_block_scope((yyvsp[0].text), PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[-2]));
	current_block_stack.push(tmp);
      }
#line 9383 "parse.cc" /* yacc.c:1646  */
    break;

  case 584:
#line 3620 "./parse.y" /* yacc.c:1646  */
    { pform_pop_scope();
	assert(! current_block_stack.empty());
	PBlock*tmp = current_block_stack.top();
	current_block_stack.pop();
	tmp->set_statement(*(yyvsp[-1].statement_list));
	delete[](yyvsp[-4].text);
	delete (yyvsp[-1].statement_list);
	(yyval.statement) = tmp;
      }
#line 9397 "parse.cc" /* yacc.c:1646  */
    break;

  case 585:
#line 3630 "./parse.y" /* yacc.c:1646  */
    { PBlock*tmp = new PBlock(PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[-1]));
	(yyval.statement) = tmp;
      }
#line 9406 "parse.cc" /* yacc.c:1646  */
    break;

  case 586:
#line 3635 "./parse.y" /* yacc.c:1646  */
    { PBlock*tmp = new PBlock(PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[-3]));
	delete[](yyvsp[-1].text);
	(yyval.statement) = tmp;
      }
#line 9416 "parse.cc" /* yacc.c:1646  */
    break;

  case 587:
#line 3641 "./parse.y" /* yacc.c:1646  */
    { yyerrok; }
#line 9422 "parse.cc" /* yacc.c:1646  */
    break;

  case 588:
#line 3649 "./parse.y" /* yacc.c:1646  */
    { PBlock*tmp = pform_push_block_scope((yyvsp[0].text), PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[-2]));
	current_block_stack.push(tmp);
      }
#line 9431 "parse.cc" /* yacc.c:1646  */
    break;

  case 589:
#line 3655 "./parse.y" /* yacc.c:1646  */
    { pform_pop_scope();
        assert(! current_block_stack.empty());
	PBlock*tmp = current_block_stack.top();
	current_block_stack.pop();
	tmp->set_statement(*(yyvsp[-1].statement_list));
	delete[](yyvsp[-4].text);
	delete (yyvsp[-1].statement_list);
	(yyval.statement) = tmp;
      }
#line 9445 "parse.cc" /* yacc.c:1646  */
    break;

  case 590:
#line 3665 "./parse.y" /* yacc.c:1646  */
    { PBlock*tmp = new PBlock(PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[-1]));
	(yyval.statement) = tmp;
      }
#line 9454 "parse.cc" /* yacc.c:1646  */
    break;

  case 591:
#line 3670 "./parse.y" /* yacc.c:1646  */
    { PBlock*tmp = new PBlock(PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[-3]));
	delete[](yyvsp[-1].text);
	(yyval.statement) = tmp;
      }
#line 9464 "parse.cc" /* yacc.c:1646  */
    break;

  case 592:
#line 3677 "./parse.y" /* yacc.c:1646  */
    { PDisable*tmp = new PDisable(*(yyvsp[-1].pform_name));
		  FILE_NAME(tmp, (yylsp[-2]));
		  delete (yyvsp[-1].pform_name);
		  (yyval.statement) = tmp;
		}
#line 9474 "parse.cc" /* yacc.c:1646  */
    break;

  case 593:
#line 3683 "./parse.y" /* yacc.c:1646  */
    { PTrigger*tmp = new PTrigger(*(yyvsp[-1].pform_name));
		  FILE_NAME(tmp, (yylsp[-2]));
		  delete (yyvsp[-1].pform_name);
		  (yyval.statement) = tmp;
		}
#line 9484 "parse.cc" /* yacc.c:1646  */
    break;

  case 594:
#line 3689 "./parse.y" /* yacc.c:1646  */
    { PForever*tmp = new PForever((yyvsp[0].statement));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.statement) = tmp;
		}
#line 9493 "parse.cc" /* yacc.c:1646  */
    break;

  case 595:
#line 3694 "./parse.y" /* yacc.c:1646  */
    { PBlock*tmp = new PBlock(PBlock::BL_PAR);
		  FILE_NAME(tmp, (yylsp[-2]));
		  tmp->set_statement(*(yyvsp[-1].statement_list));
		  delete (yyvsp[-1].statement_list);
		  (yyval.statement) = tmp;
		}
#line 9504 "parse.cc" /* yacc.c:1646  */
    break;

  case 596:
#line 3701 "./parse.y" /* yacc.c:1646  */
    { PRepeat*tmp = new PRepeat((yyvsp[-2].expr), (yyvsp[0].statement));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9513 "parse.cc" /* yacc.c:1646  */
    break;

  case 597:
#line 3706 "./parse.y" /* yacc.c:1646  */
    { PCase*tmp = new PCase(NetCase::EQ, (yyvsp[-3].expr), (yyvsp[-1].citems));
		  FILE_NAME(tmp, (yylsp[-5]));
		  (yyval.statement) = tmp;
		}
#line 9522 "parse.cc" /* yacc.c:1646  */
    break;

  case 598:
#line 3711 "./parse.y" /* yacc.c:1646  */
    { PCase*tmp = new PCase(NetCase::EQX, (yyvsp[-3].expr), (yyvsp[-1].citems));
		  FILE_NAME(tmp, (yylsp[-5]));
		  (yyval.statement) = tmp;
		}
#line 9531 "parse.cc" /* yacc.c:1646  */
    break;

  case 599:
#line 3716 "./parse.y" /* yacc.c:1646  */
    { PCase*tmp = new PCase(NetCase::EQZ, (yyvsp[-3].expr), (yyvsp[-1].citems));
		  FILE_NAME(tmp, (yylsp[-5]));
		  (yyval.statement) = tmp;
		}
#line 9540 "parse.cc" /* yacc.c:1646  */
    break;

  case 600:
#line 3721 "./parse.y" /* yacc.c:1646  */
    { yyerrok; }
#line 9546 "parse.cc" /* yacc.c:1646  */
    break;

  case 601:
#line 3723 "./parse.y" /* yacc.c:1646  */
    { yyerrok; }
#line 9552 "parse.cc" /* yacc.c:1646  */
    break;

  case 602:
#line 3725 "./parse.y" /* yacc.c:1646  */
    { yyerrok; }
#line 9558 "parse.cc" /* yacc.c:1646  */
    break;

  case 603:
#line 3727 "./parse.y" /* yacc.c:1646  */
    { PCondit*tmp = new PCondit((yyvsp[-2].expr), (yyvsp[0].statement), 0);
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9567 "parse.cc" /* yacc.c:1646  */
    break;

  case 604:
#line 3732 "./parse.y" /* yacc.c:1646  */
    { PCondit*tmp = new PCondit((yyvsp[-4].expr), (yyvsp[-2].statement), (yyvsp[0].statement));
		  FILE_NAME(tmp, (yylsp[-6]));
		  (yyval.statement) = tmp;
		}
#line 9576 "parse.cc" /* yacc.c:1646  */
    break;

  case 605:
#line 3737 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-4]), "error: Malformed conditional expression.");
		  (yyval.statement) = (yyvsp[0].statement);
		}
#line 9584 "parse.cc" /* yacc.c:1646  */
    break;

  case 606:
#line 3741 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-6]), "error: Malformed conditional expression.");
		  (yyval.statement) = (yyvsp[-2].statement);
		}
#line 9592 "parse.cc" /* yacc.c:1646  */
    break;

  case 607:
#line 3746 "./parse.y" /* yacc.c:1646  */
    { PForStatement*tmp = new PForStatement((yyvsp[-10].expr), (yyvsp[-8].expr), (yyvsp[-6].expr), (yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].statement));
		  FILE_NAME(tmp, (yylsp[-12]));
		  (yyval.statement) = tmp;
		}
#line 9601 "parse.cc" /* yacc.c:1646  */
    break;

  case 608:
#line 3752 "./parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0;
		  yyerror((yylsp[-10]), "error: Error in for loop step assignment.");
		}
#line 9609 "parse.cc" /* yacc.c:1646  */
    break;

  case 609:
#line 3757 "./parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0;
		  yyerror((yylsp[-12]), "error: Error in for loop condition expression.");
		}
#line 9617 "parse.cc" /* yacc.c:1646  */
    break;

  case 610:
#line 3761 "./parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0;
		  yyerror((yylsp[-4]), "error: Incomprehensible for loop.");
		}
#line 9625 "parse.cc" /* yacc.c:1646  */
    break;

  case 611:
#line 3765 "./parse.y" /* yacc.c:1646  */
    { PWhile*tmp = new PWhile((yyvsp[-2].expr), (yyvsp[0].statement));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9634 "parse.cc" /* yacc.c:1646  */
    break;

  case 612:
#line 3770 "./parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0;
		  yyerror((yylsp[-4]), "error: Error in while loop condition.");
		}
#line 9642 "parse.cc" /* yacc.c:1646  */
    break;

  case 613:
#line 3774 "./parse.y" /* yacc.c:1646  */
    { PExpr*del = (*(yyvsp[-1].exprs))[0];
		  assert((yyvsp[-1].exprs)->count() == 1);
		  PDelayStatement*tmp = new PDelayStatement(del, (yyvsp[0].statement));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.statement) = tmp;
		}
#line 9653 "parse.cc" /* yacc.c:1646  */
    break;

  case 614:
#line 3781 "./parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp = (yyvsp[-2].event_statement);
	if (tmp == 0) {
	      yyerror((yylsp[-2]), "error: Invalid event control.");
	      (yyval.statement) = 0;
	} else {
	      if ((yyvsp[0].statement)) pform_bind_attributes((yyvsp[0].statement)->attributes,(yyvsp[-1].named_pexprs));
	      tmp->set_statement((yyvsp[0].statement));
	      (yyval.statement) = tmp;
	}
      }
#line 9668 "parse.cc" /* yacc.c:1646  */
    break;

  case 615:
#line 3792 "./parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp = new PEventStatement;
	FILE_NAME(tmp, (yylsp[-3]));
	if ((yyvsp[0].statement)) pform_bind_attributes((yyvsp[0].statement)->attributes,(yyvsp[-1].named_pexprs));
	tmp->set_statement((yyvsp[0].statement));
	(yyval.statement) = tmp;
      }
#line 9679 "parse.cc" /* yacc.c:1646  */
    break;

  case 616:
#line 3799 "./parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp = new PEventStatement;
	FILE_NAME(tmp, (yylsp[-5]));
	if ((yyvsp[0].statement)) pform_bind_attributes((yyvsp[0].statement)->attributes,(yyvsp[-1].named_pexprs));
	tmp->set_statement((yyvsp[0].statement));
	(yyval.statement) = tmp;
      }
#line 9690 "parse.cc" /* yacc.c:1646  */
    break;

  case 617:
#line 3806 "./parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-3].expr),(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-3]));
		  (yyval.statement) = tmp;
		}
#line 9699 "parse.cc" /* yacc.c:1646  */
    break;

  case 618:
#line 3811 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "Syntax in assignment statement l-value.");
		  yyerrok;
		  (yyval.statement) = new PNoop;
		}
#line 9708 "parse.cc" /* yacc.c:1646  */
    break;

  case 619:
#line 3816 "./parse.y" /* yacc.c:1646  */
    { PAssignNB*tmp = new PAssignNB((yyvsp[-3].expr),(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-3]));
		  (yyval.statement) = tmp;
		}
#line 9717 "parse.cc" /* yacc.c:1646  */
    break;

  case 620:
#line 3821 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "Syntax in assignment statement l-value.");
		  yyerrok;
		  (yyval.statement) = new PNoop;
		}
#line 9726 "parse.cc" /* yacc.c:1646  */
    break;

  case 621:
#line 3826 "./parse.y" /* yacc.c:1646  */
    { assert((yyvsp[-2].exprs)->count() == 1);
		  PExpr*del = (*(yyvsp[-2].exprs))[0];
		  PAssign*tmp = new PAssign((yyvsp[-4].expr),del,(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9737 "parse.cc" /* yacc.c:1646  */
    break;

  case 622:
#line 3833 "./parse.y" /* yacc.c:1646  */
    { assert((yyvsp[-2].exprs)->count() == 1);
		  PExpr*del = (*(yyvsp[-2].exprs))[0];
		  PAssignNB*tmp = new PAssignNB((yyvsp[-4].expr),del,(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9748 "parse.cc" /* yacc.c:1646  */
    break;

  case 623:
#line 3840 "./parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-4].expr),0,(yyvsp[-2].event_statement),(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9757 "parse.cc" /* yacc.c:1646  */
    break;

  case 624:
#line 3845 "./parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-8].expr),(yyvsp[-4].expr),(yyvsp[-2].event_statement),(yyvsp[-1].expr));
		  FILE_NAME(tmp,(yylsp[-8]));
		  tmp->set_lineno((yylsp[-8]).first_line);
		  (yyval.statement) = tmp;
		}
#line 9767 "parse.cc" /* yacc.c:1646  */
    break;

  case 625:
#line 3851 "./parse.y" /* yacc.c:1646  */
    { PAssignNB*tmp = new PAssignNB((yyvsp[-4].expr),0,(yyvsp[-2].event_statement),(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9776 "parse.cc" /* yacc.c:1646  */
    break;

  case 626:
#line 3856 "./parse.y" /* yacc.c:1646  */
    { PAssignNB*tmp = new PAssignNB((yyvsp[-8].expr),(yyvsp[-4].expr),(yyvsp[-2].event_statement),(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-8]));
		  (yyval.statement) = tmp;
		}
#line 9785 "parse.cc" /* yacc.c:1646  */
    break;

  case 627:
#line 3861 "./parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp;
		  PEEvent*etmp = new PEEvent(PEEvent::POSITIVE, (yyvsp[-2].expr));
		  tmp = new PEventStatement(etmp);
		  FILE_NAME(tmp,(yylsp[-4]));
		  tmp->set_statement((yyvsp[0].statement));
		  (yyval.statement) = tmp;
		}
#line 9797 "parse.cc" /* yacc.c:1646  */
    break;

  case 628:
#line 3869 "./parse.y" /* yacc.c:1646  */
    { PCallTask*tmp = new PCallTask(lex_strings.make((yyvsp[-4].text)), *(yyvsp[-2].exprs));
		  FILE_NAME(tmp,(yylsp[-4]));
		  delete[](yyvsp[-4].text);
		  delete (yyvsp[-2].exprs);
		  (yyval.statement) = tmp;
		}
#line 9808 "parse.cc" /* yacc.c:1646  */
    break;

  case 629:
#line 3876 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>pt (0);
		  PCallTask*tmp = new PCallTask(lex_strings.make((yyvsp[-1].text)), pt);
		  FILE_NAME(tmp,(yylsp[-1]));
		  delete[](yyvsp[-1].text);
		  (yyval.statement) = tmp;
		}
#line 9819 "parse.cc" /* yacc.c:1646  */
    break;

  case 630:
#line 3883 "./parse.y" /* yacc.c:1646  */
    { PCallTask*tmp = new PCallTask(*(yyvsp[-4].pform_name), *(yyvsp[-2].exprs));
		  FILE_NAME(tmp, (yylsp[-4]));
		  delete (yyvsp[-4].pform_name);
		  delete (yyvsp[-2].exprs);
		  (yyval.statement) = tmp;
		}
#line 9830 "parse.cc" /* yacc.c:1646  */
    break;

  case 631:
#line 3895 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>pt (0);
		  PCallTask*tmp = new PCallTask(*(yyvsp[-3].pform_name), pt);
		  FILE_NAME(tmp, (yylsp[-3]));
		  delete (yyvsp[-3].pform_name);
		  (yyval.statement) = tmp;
		}
#line 9841 "parse.cc" /* yacc.c:1646  */
    break;

  case 632:
#line 3902 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>pt (0);
		  PCallTask*tmp = new PCallTask(*(yyvsp[-1].pform_name), pt);
		  FILE_NAME(tmp, (yylsp[-1]));
		  delete (yyvsp[-1].pform_name);
		  (yyval.statement) = tmp;
		}
#line 9852 "parse.cc" /* yacc.c:1646  */
    break;

  case 633:
#line 3909 "./parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[0]), "error: malformed statement");
		  yyerrok;
		  (yyval.statement) = new PNoop;
		}
#line 9861 "parse.cc" /* yacc.c:1646  */
    break;

  case 634:
#line 3917 "./parse.y" /* yacc.c:1646  */
    { svector<Statement*>*tmp = new svector<Statement*>(*(yyvsp[-1].statement_list), (yyvsp[0].statement));
		  delete (yyvsp[-1].statement_list);
		  (yyval.statement_list) = tmp;
		}
#line 9870 "parse.cc" /* yacc.c:1646  */
    break;

  case 635:
#line 3922 "./parse.y" /* yacc.c:1646  */
    { svector<Statement*>*tmp = new svector<Statement*>(1);
		  (*tmp)[0] = (yyvsp[0].statement);
		  (yyval.statement_list) = tmp;
		}
#line 9879 "parse.cc" /* yacc.c:1646  */
    break;

  case 636:
#line 3930 "./parse.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 9885 "parse.cc" /* yacc.c:1646  */
    break;

  case 637:
#line 3932 "./parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0; }
#line 9891 "parse.cc" /* yacc.c:1646  */
    break;

  case 638:
#line 3937 "./parse.y" /* yacc.c:1646  */
    { (yyval.statement) = pform_contribution_statement((yylsp[-2]), (yyvsp[-3].expr), (yyvsp[-1].expr)); }
#line 9897 "parse.cc" /* yacc.c:1646  */
    break;

  case 639:
#line 3943 "./parse.y" /* yacc.c:1646  */
    { (yyval.wires) = new svector<PWire*>(0); }
#line 9903 "parse.cc" /* yacc.c:1646  */
    break;

  case 640:
#line 3944 "./parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 9909 "parse.cc" /* yacc.c:1646  */
    break;

  case 643:
#line 3955 "./parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_NO_TYPE, (yyvsp[-3].flag),
						(yyvsp[-2].exprs), (yyvsp[-1].perm_strings),
						(yylsp[-5]).text, (yylsp[-5]).first_line);
		  (yyval.wires) = tmp;
		}
#line 9921 "parse.cc" /* yacc.c:1646  */
    break;

  case 644:
#line 3963 "./parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, (yyvsp[-3].flag),
						(yyvsp[-2].exprs), (yyvsp[-1].perm_strings),
						(yylsp[-5]).text, (yylsp[-5]).first_line);
		  (yyval.wires) = tmp;
		}
#line 9933 "parse.cc" /* yacc.c:1646  */
    break;

  case 645:
#line 3971 "./parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, (yyvsp[-3].flag),
						(yyvsp[-2].exprs), (yyvsp[-1].perm_strings),
						(yylsp[-5]).text, (yylsp[-5]).first_line);
		  (yyval.wires) = tmp;
		}
#line 9945 "parse.cc" /* yacc.c:1646  */
    break;

  case 646:
#line 3983 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, true,
						range_stub, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 9964 "parse.cc" /* yacc.c:1646  */
    break;

  case 647:
#line 3998 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, true,
						range_stub, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 9983 "parse.cc" /* yacc.c:1646  */
    break;

  case 648:
#line 4013 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, true,
						range_stub, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10002 "parse.cc" /* yacc.c:1646  */
    break;

  case 649:
#line 4031 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, false,
						range_stub, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10020 "parse.cc" /* yacc.c:1646  */
    break;

  case 650:
#line 4045 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, false,
						range_stub, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10038 "parse.cc" /* yacc.c:1646  */
    break;

  case 651:
#line 4059 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, false,
						range_stub, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10056 "parse.cc" /* yacc.c:1646  */
    break;

  case 652:
#line 4076 "./parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_REAL, false,
						0, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10068 "parse.cc" /* yacc.c:1646  */
    break;

  case 653:
#line 4084 "./parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_REAL, true,
						0, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10080 "parse.cc" /* yacc.c:1646  */
    break;

  case 654:
#line 4092 "./parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_REAL, true,
						0, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10092 "parse.cc" /* yacc.c:1646  */
    break;

  case 655:
#line 4103 "./parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[-1].wires), *(yyvsp[0].wires));
		  delete (yyvsp[-1].wires);
		  delete (yyvsp[0].wires);
		  (yyval.wires) = tmp;
		}
#line 10102 "parse.cc" /* yacc.c:1646  */
    break;

  case 656:
#line 4109 "./parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 10108 "parse.cc" /* yacc.c:1646  */
    break;

  case 657:
#line 4114 "./parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 10114 "parse.cc" /* yacc.c:1646  */
    break;

  case 658:
#line 4116 "./parse.y" /* yacc.c:1646  */
    { (yyval.wires) = 0; }
#line 10120 "parse.cc" /* yacc.c:1646  */
    break;

  case 659:
#line 4122 "./parse.y" /* yacc.c:1646  */
    { port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = (yyvsp[-2].flag);
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range((yyvsp[-1].exprs));
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, (yyvsp[-2].flag),
						(yyvsp[-1].exprs), list_from_identifier((yyvsp[0].text)),
						(yylsp[-4]).text, (yylsp[-4]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10137 "parse.cc" /* yacc.c:1646  */
    break;

  case 660:
#line 4136 "./parse.y" /* yacc.c:1646  */
    { port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = (yyvsp[-2].flag);
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range((yyvsp[-1].exprs));
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, (yyvsp[-2].flag),
						(yyvsp[-1].exprs), list_from_identifier((yyvsp[0].text)),
						(yylsp[-4]).text, (yylsp[-4]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10154 "parse.cc" /* yacc.c:1646  */
    break;

  case 661:
#line 4149 "./parse.y" /* yacc.c:1646  */
    { port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = (yyvsp[-2].flag);
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range((yyvsp[-1].exprs));
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, (yyvsp[-2].flag),
						(yyvsp[-1].exprs), list_from_identifier((yyvsp[0].text)),
						(yylsp[-4]).text, (yylsp[-4]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10171 "parse.cc" /* yacc.c:1646  */
    break;

  case 662:
#line 4165 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = true;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, true,
						range_stub,
						list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10196 "parse.cc" /* yacc.c:1646  */
    break;

  case 663:
#line 4186 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = true;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, true,
						range_stub,
						list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10221 "parse.cc" /* yacc.c:1646  */
    break;

  case 664:
#line 4207 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = true;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, true,
						range_stub,
						list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10246 "parse.cc" /* yacc.c:1646  */
    break;

  case 665:
#line 4231 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, false,
						range_stub,
						list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10270 "parse.cc" /* yacc.c:1646  */
    break;

  case 666:
#line 4251 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, false,
						range_stub,
						list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10294 "parse.cc" /* yacc.c:1646  */
    break;

  case 667:
#line 4271 "./parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, false,
						range_stub,
						list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10318 "parse.cc" /* yacc.c:1646  */
    break;

  case 668:
#line 4294 "./parse.y" /* yacc.c:1646  */
    { port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_REAL;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = 0;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_REAL, false,
						0, list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10335 "parse.cc" /* yacc.c:1646  */
    break;

  case 669:
#line 4307 "./parse.y" /* yacc.c:1646  */
    { port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_REAL;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = 0;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_REAL, false,
						0, list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10352 "parse.cc" /* yacc.c:1646  */
    break;

  case 670:
#line 4320 "./parse.y" /* yacc.c:1646  */
    { port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_REAL;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = 0;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_REAL, false,
						0, list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10369 "parse.cc" /* yacc.c:1646  */
    break;

  case 671:
#line 4336 "./parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[-2].wires), *(yyvsp[0].wires));
		  delete (yyvsp[-2].wires);
		  delete (yyvsp[0].wires);
		  (yyval.wires) = tmp;
		}
#line 10379 "parse.cc" /* yacc.c:1646  */
    break;

  case 672:
#line 4342 "./parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 10385 "parse.cc" /* yacc.c:1646  */
    break;

  case 673:
#line 4344 "./parse.y" /* yacc.c:1646  */
    { svector<PWire*>*new_decl
			= pform_make_task_ports(
				port_declaration_context.port_type,
				port_declaration_context.var_type,
				port_declaration_context.sign_flag,
				copy_range(port_declaration_context.range),
				list_from_identifier((yyvsp[0].text)),
				(yylsp[0]).text, (yylsp[0]).first_line);
		  svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[-2].wires), *new_decl);
		  delete (yyvsp[-2].wires);
		  delete new_decl;
		  (yyval.wires) = tmp;
		}
#line 10403 "parse.cc" /* yacc.c:1646  */
    break;

  case 674:
#line 4358 "./parse.y" /* yacc.c:1646  */
    {
		  yyerror((yylsp[0]), "error: NULL port declarations are not "
		              "allowed.");
		}
#line 10412 "parse.cc" /* yacc.c:1646  */
    break;

  case 675:
#line 4363 "./parse.y" /* yacc.c:1646  */
    {
		  yyerror((yylsp[0]), "error: ';' is an invalid port declaration "
		              "separator.");
		}
#line 10421 "parse.cc" /* yacc.c:1646  */
    break;

  case 676:
#line 4371 "./parse.y" /* yacc.c:1646  */
    { lex_start_table(); }
#line 10427 "parse.cc" /* yacc.c:1646  */
    break;

  case 677:
#line 4373 "./parse.y" /* yacc.c:1646  */
    { lex_end_table(); (yyval.strings) = (yyvsp[-1].strings); }
#line 10433 "parse.cc" /* yacc.c:1646  */
    break;

  case 680:
#line 4383 "./parse.y" /* yacc.c:1646  */
    { char*tmp = new char[strlen((yyvsp[-3].text))+3];
		  strcpy(tmp, (yyvsp[-3].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = ':';
		  *tp++ = (yyvsp[-1].letter);
		  *tp++ = 0;
		  delete[](yyvsp[-3].text);
		  (yyval.text) = tmp;
		}
#line 10447 "parse.cc" /* yacc.c:1646  */
    break;

  case 681:
#line 4396 "./parse.y" /* yacc.c:1646  */
    { list<string>*tmp = new list<string>;
		  tmp->push_back((yyvsp[0].text));
		  delete[](yyvsp[0].text);
		  (yyval.strings) = tmp;
		}
#line 10457 "parse.cc" /* yacc.c:1646  */
    break;

  case 682:
#line 4402 "./parse.y" /* yacc.c:1646  */
    { list<string>*tmp = (yyvsp[-1].strings);
		  tmp->push_back((yyvsp[0].text));
		  delete[](yyvsp[0].text);
		  (yyval.strings) = tmp;
		}
#line 10467 "parse.cc" /* yacc.c:1646  */
    break;

  case 683:
#line 4411 "./parse.y" /* yacc.c:1646  */
    { list<string>*tmp = new list<string>;
		  tmp->push_back((yyvsp[0].text));
		  delete[](yyvsp[0].text);
		  (yyval.strings) = tmp;
		}
#line 10477 "parse.cc" /* yacc.c:1646  */
    break;

  case 684:
#line 4417 "./parse.y" /* yacc.c:1646  */
    { list<string>*tmp = (yyvsp[-1].strings);
		  tmp->push_back((yyvsp[0].text));
		  delete[](yyvsp[0].text);
		  (yyval.strings) = tmp;
		}
#line 10487 "parse.cc" /* yacc.c:1646  */
    break;

  case 685:
#line 4426 "./parse.y" /* yacc.c:1646  */
    { char*tmp = new char[strlen((yyvsp[-5].text))+5];
		  strcpy(tmp, (yyvsp[-5].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = ':';
		  *tp++ = (yyvsp[-3].letter);
		  *tp++ = ':';
		  *tp++ = (yyvsp[-1].letter);
		  *tp++ = 0;
		  (yyval.text) = tmp;
		}
#line 10502 "parse.cc" /* yacc.c:1646  */
    break;

  case 686:
#line 4440 "./parse.y" /* yacc.c:1646  */
    { PExpr*etmp = new PENumber((yyvsp[-1].number));
		  PEIdent*itmp = new PEIdent(lex_strings.make((yyvsp[-3].text)));
		  PAssign*atmp = new PAssign(itmp, etmp);
		  FILE_NAME(atmp, (yylsp[-3]));
		  delete[](yyvsp[-3].text);
		  (yyval.statement) = atmp;
		}
#line 10514 "parse.cc" /* yacc.c:1646  */
    break;

  case 687:
#line 4450 "./parse.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 10520 "parse.cc" /* yacc.c:1646  */
    break;

  case 688:
#line 4451 "./parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0; }
#line 10526 "parse.cc" /* yacc.c:1646  */
    break;

  case 689:
#line 4456 "./parse.y" /* yacc.c:1646  */
    { char*tmp = new char[2];
		  tmp[0] = (yyvsp[0].letter);
		  tmp[1] = 0;
		  (yyval.text) = tmp;
		}
#line 10536 "parse.cc" /* yacc.c:1646  */
    break;

  case 690:
#line 4462 "./parse.y" /* yacc.c:1646  */
    { char*tmp = new char[strlen((yyvsp[-1].text))+2];
		  strcpy(tmp, (yyvsp[-1].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = (yyvsp[0].letter);
		  *tp++ = 0;
		  delete[](yyvsp[-1].text);
		  (yyval.text) = tmp;
		}
#line 10549 "parse.cc" /* yacc.c:1646  */
    break;

  case 691:
#line 4473 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '0'; }
#line 10555 "parse.cc" /* yacc.c:1646  */
    break;

  case 692:
#line 4474 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '1'; }
#line 10561 "parse.cc" /* yacc.c:1646  */
    break;

  case 693:
#line 4475 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'x'; }
#line 10567 "parse.cc" /* yacc.c:1646  */
    break;

  case 694:
#line 4476 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '?'; }
#line 10573 "parse.cc" /* yacc.c:1646  */
    break;

  case 695:
#line 4477 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'b'; }
#line 10579 "parse.cc" /* yacc.c:1646  */
    break;

  case 696:
#line 4478 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '*'; }
#line 10585 "parse.cc" /* yacc.c:1646  */
    break;

  case 697:
#line 4479 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '%'; }
#line 10591 "parse.cc" /* yacc.c:1646  */
    break;

  case 698:
#line 4480 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'f'; }
#line 10597 "parse.cc" /* yacc.c:1646  */
    break;

  case 699:
#line 4481 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'F'; }
#line 10603 "parse.cc" /* yacc.c:1646  */
    break;

  case 700:
#line 4482 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'l'; }
#line 10609 "parse.cc" /* yacc.c:1646  */
    break;

  case 701:
#line 4483 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'H'; }
#line 10615 "parse.cc" /* yacc.c:1646  */
    break;

  case 702:
#line 4484 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'B'; }
#line 10621 "parse.cc" /* yacc.c:1646  */
    break;

  case 703:
#line 4485 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'r'; }
#line 10627 "parse.cc" /* yacc.c:1646  */
    break;

  case 704:
#line 4486 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'R'; }
#line 10633 "parse.cc" /* yacc.c:1646  */
    break;

  case 705:
#line 4487 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'M'; }
#line 10639 "parse.cc" /* yacc.c:1646  */
    break;

  case 706:
#line 4488 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'n'; }
#line 10645 "parse.cc" /* yacc.c:1646  */
    break;

  case 707:
#line 4489 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'N'; }
#line 10651 "parse.cc" /* yacc.c:1646  */
    break;

  case 708:
#line 4490 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'p'; }
#line 10657 "parse.cc" /* yacc.c:1646  */
    break;

  case 709:
#line 4491 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'P'; }
#line 10663 "parse.cc" /* yacc.c:1646  */
    break;

  case 710:
#line 4492 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'Q'; }
#line 10669 "parse.cc" /* yacc.c:1646  */
    break;

  case 711:
#line 4493 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'q'; }
#line 10675 "parse.cc" /* yacc.c:1646  */
    break;

  case 712:
#line 4494 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '_'; }
#line 10681 "parse.cc" /* yacc.c:1646  */
    break;

  case 713:
#line 4495 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '+'; }
#line 10687 "parse.cc" /* yacc.c:1646  */
    break;

  case 714:
#line 4499 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '0'; }
#line 10693 "parse.cc" /* yacc.c:1646  */
    break;

  case 715:
#line 4500 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '1'; }
#line 10699 "parse.cc" /* yacc.c:1646  */
    break;

  case 716:
#line 4501 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'x'; }
#line 10705 "parse.cc" /* yacc.c:1646  */
    break;

  case 717:
#line 4502 "./parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '-'; }
#line 10711 "parse.cc" /* yacc.c:1646  */
    break;

  case 718:
#line 4510 "./parse.y" /* yacc.c:1646  */
    { (yyval.wires) = pform_make_udp_input_ports((yyvsp[-1].perm_strings)); }
#line 10717 "parse.cc" /* yacc.c:1646  */
    break;

  case 719:
#line 4512 "./parse.y" /* yacc.c:1646  */
    { perm_string pname = lex_strings.make((yyvsp[-1].text));
	PWire*pp = new PWire(pname, NetNet::IMPLICIT, NetNet::POUTPUT, IVL_VT_LOGIC);
	svector<PWire*>*tmp = new svector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[-1].text);
      }
#line 10729 "parse.cc" /* yacc.c:1646  */
    break;

  case 720:
#line 4520 "./parse.y" /* yacc.c:1646  */
    { perm_string pname = lex_strings.make((yyvsp[-1].text));
	PWire*pp = new PWire(pname, NetNet::REG, NetNet::PIMPLICIT, IVL_VT_LOGIC);
	svector<PWire*>*tmp = new svector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[-1].text);
      }
#line 10741 "parse.cc" /* yacc.c:1646  */
    break;

  case 721:
#line 4528 "./parse.y" /* yacc.c:1646  */
    { perm_string pname = lex_strings.make((yyvsp[-1].text));
	PWire*pp = new PWire(pname, NetNet::REG, NetNet::POUTPUT, IVL_VT_LOGIC);
	svector<PWire*>*tmp = new svector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[-1].text);
      }
#line 10753 "parse.cc" /* yacc.c:1646  */
    break;

  case 722:
#line 4539 "./parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 10759 "parse.cc" /* yacc.c:1646  */
    break;

  case 723:
#line 4541 "./parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[-1].wires), *(yyvsp[0].wires));
		  delete (yyvsp[-1].wires);
		  delete (yyvsp[0].wires);
		  (yyval.wires) = tmp;
		}
#line 10769 "parse.cc" /* yacc.c:1646  */
    break;

  case 724:
#line 4550 "./parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
	tmp->push_back(lex_strings.make((yyvsp[0].text)));
	delete[](yyvsp[0].text);
	(yyval.perm_strings) = tmp;
      }
#line 10779 "parse.cc" /* yacc.c:1646  */
    break;

  case 725:
#line 4556 "./parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
	tmp->push_back(lex_strings.make((yyvsp[0].text)));
	delete[](yyvsp[0].text);
	(yyval.perm_strings) = tmp;
      }
#line 10789 "parse.cc" /* yacc.c:1646  */
    break;

  case 726:
#line 4563 "./parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 10795 "parse.cc" /* yacc.c:1646  */
    break;

  case 727:
#line 4563 "./parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 10801 "parse.cc" /* yacc.c:1646  */
    break;

  case 728:
#line 4566 "./parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 10807 "parse.cc" /* yacc.c:1646  */
    break;

  case 729:
#line 4567 "./parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 10813 "parse.cc" /* yacc.c:1646  */
    break;

  case 730:
#line 4572 "./parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 10823 "parse.cc" /* yacc.c:1646  */
    break;

  case 731:
#line 4578 "./parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-3].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 10833 "parse.cc" /* yacc.c:1646  */
    break;

  case 732:
#line 4596 "./parse.y" /* yacc.c:1646  */
    { perm_string tmp2 = lex_strings.make((yyvsp[-8].text));
		  pform_make_udp(tmp2, (yyvsp[-6].perm_strings), (yyvsp[-3].wires), (yyvsp[-1].strings), (yyvsp[-2].statement),
				 (yylsp[-8]).text, (yylsp[-8]).first_line);
		  delete[](yyvsp[-8].text);
		}
#line 10843 "parse.cc" /* yacc.c:1646  */
    break;

  case 733:
#line 4611 "./parse.y" /* yacc.c:1646  */
    { perm_string tmp2 = lex_strings.make((yyvsp[-11].text));
		  perm_string tmp6 = lex_strings.make((yyvsp[-7].text));
		  pform_make_udp(tmp2, (yyvsp[-8].flag), tmp6, (yyvsp[-6].expr), (yyvsp[-4].perm_strings), (yyvsp[-1].strings),
				 (yylsp[-11]).text, (yylsp[-11]).first_line);
		  delete[](yyvsp[-11].text);
		  delete[](yyvsp[-7].text);
		}
#line 10855 "parse.cc" /* yacc.c:1646  */
    break;


#line 10859 "parse.cc" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
